/* PropertyTarget.c generated by valac 0.56.18, the Vala compiler
 * generated from PropertyTarget.vala, do not modify */

/*
 * Copyright 2025 elementary, Inc. (https://elementary.io)
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * Authored by: Leonhard Kargl <leo.kargl@proton.me>
 */

#include <glib-object.h>
#include "gala.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <clutter/clutter.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_GESTURE_TARGET (gala_gesture_target_get_type ())
#define GALA_GESTURE_TARGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE_TARGET, GalaGestureTarget))
#define GALA_IS_GESTURE_TARGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE_TARGET))
#define GALA_GESTURE_TARGET_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GALA_TYPE_GESTURE_TARGET, GalaGestureTargetIface))

typedef struct _GalaGestureTarget GalaGestureTarget;
typedef struct _GalaGestureTargetIface GalaGestureTargetIface;
typedef enum  {
	GALA_GESTURE_TARGET_UPDATE_TYPE_START,
	GALA_GESTURE_TARGET_UPDATE_TYPE_UPDATE,
	GALA_GESTURE_TARGET_UPDATE_TYPE_COMMIT,
	GALA_GESTURE_TARGET_UPDATE_TYPE_END
} GalaGestureTargetUpdateType;

#define GALA_GESTURE_TARGET_TYPE_UPDATE_TYPE (gala_gesture_target_update_type_get_type ())

#define GALA_TYPE_PROPERTY_TARGET (gala_property_target_get_type ())
#define GALA_PROPERTY_TARGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_PROPERTY_TARGET, GalaPropertyTarget))
#define GALA_PROPERTY_TARGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_PROPERTY_TARGET, GalaPropertyTargetClass))
#define GALA_IS_PROPERTY_TARGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_PROPERTY_TARGET))
#define GALA_IS_PROPERTY_TARGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_PROPERTY_TARGET))
#define GALA_PROPERTY_TARGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_PROPERTY_TARGET, GalaPropertyTargetClass))

typedef struct _GalaPropertyTarget GalaPropertyTarget;
typedef struct _GalaPropertyTargetClass GalaPropertyTargetClass;
typedef struct _GalaPropertyTargetPrivate GalaPropertyTargetPrivate;
enum  {
	GALA_PROPERTY_TARGET_0_PROPERTY,
	GALA_PROPERTY_TARGET_ACTION_PROPERTY,
	GALA_PROPERTY_TARGET_ACTOR_PROPERTY,
	GALA_PROPERTY_TARGET_PROPERTY_PROPERTY,
	GALA_PROPERTY_TARGET_INTERVAL_PROPERTY,
	GALA_PROPERTY_TARGET_NUM_PROPERTIES
};
static GParamSpec* gala_property_target_properties[GALA_PROPERTY_TARGET_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _GalaGestureTargetIface {
	GTypeInterface parent_iface;
	void (*propagate) (GalaGestureTarget* self, GalaGestureTargetUpdateType update_type, GalaGestureAction action, gdouble progress);
	ClutterActor* (*get_actor) (GalaGestureTarget* self);
};

struct _GalaPropertyTarget {
	GObject parent_instance;
	GalaPropertyTargetPrivate * priv;
};

struct _GalaPropertyTargetClass {
	GObjectClass parent_class;
};

struct _GalaPropertyTargetPrivate {
	GalaGestureAction _action;
	ClutterActor* _actor;
	gchar* _property;
	ClutterInterval* _interval;
};

static gint GalaPropertyTarget_private_offset;
static gpointer gala_property_target_parent_class = NULL;
static GalaGestureTargetIface * gala_property_target_gala_gesture_target_parent_iface = NULL;

VALA_EXTERN GType gala_gesture_target_update_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gala_gesture_target_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGestureTarget, g_object_unref)
VALA_EXTERN GType gala_property_target_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaPropertyTarget, g_object_unref)
VALA_EXTERN GalaPropertyTarget* gala_property_target_new (GalaGestureAction action,
                                              ClutterActor* actor,
                                              const gchar* property,
                                              GType value_type,
                                              GValue* from_value,
                                              GValue* to_value);
VALA_EXTERN GalaPropertyTarget* gala_property_target_construct (GType object_type,
                                                    GalaGestureAction action,
                                                    ClutterActor* actor,
                                                    const gchar* property,
                                                    GType value_type,
                                                    GValue* from_value,
                                                    GValue* to_value);
static void __lambda12_ (GalaPropertyTarget* self);
static void ___lambda12__clutter_actor_destroy (ClutterActor* _sender,
                                         gpointer self);
static void gala_property_target_real_propagate (GalaGestureTarget* base,
                                          GalaGestureTargetUpdateType update_type,
                                          GalaGestureAction action,
                                          gdouble progress);
VALA_EXTERN GalaGestureAction gala_property_target_get_action (GalaPropertyTarget* self);
VALA_EXTERN ClutterActor* gala_gesture_target_get_actor (GalaGestureTarget* self);
VALA_EXTERN const gchar* gala_property_target_get_property (GalaPropertyTarget* self);
VALA_EXTERN ClutterInterval* gala_property_target_get_interval (GalaPropertyTarget* self);
static void gala_property_target_set_action (GalaPropertyTarget* self,
                                      GalaGestureAction value);
static void gala_property_target_set_property (GalaPropertyTarget* self,
                                        const gchar* value);
static void gala_property_target_set_interval (GalaPropertyTarget* self,
                                        ClutterInterval* value);
VALA_EXTERN void gala_gesture_target_propagate (GalaGestureTarget* self,
                                    GalaGestureTargetUpdateType update_type,
                                    GalaGestureAction action,
                                    gdouble progress);
static void gala_property_target_finalize (GObject * obj);
static GType gala_property_target_get_type_once (void);
static void _vala_gala_property_target_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_gala_property_target_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
gala_property_target_get_instance_private (GalaPropertyTarget* self)
{
	return G_STRUCT_MEMBER_P (self, GalaPropertyTarget_private_offset);
}

static void
__lambda12_ (GalaPropertyTarget* self)
{
#line 23 "../src/Gestures/PropertyTarget.vala"
	self->priv->_actor = NULL;
#line 164 "PropertyTarget.c"
}

static void
___lambda12__clutter_actor_destroy (ClutterActor* _sender,
                                    gpointer self)
{
#line 23 "../src/Gestures/PropertyTarget.vala"
	__lambda12_ ((GalaPropertyTarget*) self);
#line 173 "PropertyTarget.c"
}

GalaPropertyTarget*
gala_property_target_construct (GType object_type,
                                GalaGestureAction action,
                                ClutterActor* actor,
                                const gchar* property,
                                GType value_type,
                                GValue* from_value,
                                GValue* to_value)
{
	GalaPropertyTarget * self = NULL;
	GValue _tmp0_;
	GValue _tmp1_;
	ClutterInterval* _tmp2_;
	ClutterInterval* _tmp3_;
	ClutterActor* _tmp4_;
#line 19 "../src/Gestures/PropertyTarget.vala"
	g_return_val_if_fail (actor != NULL, NULL);
#line 19 "../src/Gestures/PropertyTarget.vala"
	g_return_val_if_fail (property != NULL, NULL);
#line 19 "../src/Gestures/PropertyTarget.vala"
	g_return_val_if_fail (from_value != NULL, NULL);
#line 19 "../src/Gestures/PropertyTarget.vala"
	g_return_val_if_fail (to_value != NULL, NULL);
#line 20 "../src/Gestures/PropertyTarget.vala"
	_tmp0_ = *from_value;
#line 20 "../src/Gestures/PropertyTarget.vala"
	_tmp1_ = *to_value;
#line 20 "../src/Gestures/PropertyTarget.vala"
	_tmp2_ = clutter_interval_new_with_values (value_type, &_tmp0_, &_tmp1_);
#line 20 "../src/Gestures/PropertyTarget.vala"
	g_object_ref_sink (_tmp2_);
#line 20 "../src/Gestures/PropertyTarget.vala"
	_tmp3_ = _tmp2_;
#line 20 "../src/Gestures/PropertyTarget.vala"
	self = (GalaPropertyTarget*) g_object_new (object_type, "action", action, "property", property, "interval", _tmp3_, NULL);
#line 20 "../src/Gestures/PropertyTarget.vala"
	_g_object_unref0 (_tmp3_);
#line 22 "../src/Gestures/PropertyTarget.vala"
	self->priv->_actor = actor;
#line 23 "../src/Gestures/PropertyTarget.vala"
	_tmp4_ = self->priv->_actor;
#line 23 "../src/Gestures/PropertyTarget.vala"
	g_signal_connect_object (_tmp4_, "destroy", (GCallback) ___lambda12__clutter_actor_destroy, self, 0);
#line 19 "../src/Gestures/PropertyTarget.vala"
	return self;
#line 221 "PropertyTarget.c"
}

GalaPropertyTarget*
gala_property_target_new (GalaGestureAction action,
                          ClutterActor* actor,
                          const gchar* property,
                          GType value_type,
                          GValue* from_value,
                          GValue* to_value)
{
#line 19 "../src/Gestures/PropertyTarget.vala"
	return gala_property_target_construct (GALA_TYPE_PROPERTY_TARGET, action, actor, property, value_type, from_value, to_value);
#line 234 "PropertyTarget.c"
}

static void
gala_property_target_real_propagate (GalaGestureTarget* base,
                                     GalaGestureTargetUpdateType update_type,
                                     GalaGestureAction action,
                                     gdouble progress)
{
	GalaPropertyTarget * self;
	gboolean _tmp0_ = FALSE;
	ClutterActor* _tmp2_;
	ClutterActor* _tmp3_;
	const gchar* _tmp4_;
	ClutterInterval* _tmp5_;
	GValue _tmp6_;
#line 26 "../src/Gestures/PropertyTarget.vala"
	self = (GalaPropertyTarget*) base;
#line 27 "../src/Gestures/PropertyTarget.vala"
	if (update_type != GALA_GESTURE_TARGET_UPDATE_TYPE_UPDATE) {
#line 27 "../src/Gestures/PropertyTarget.vala"
		_tmp0_ = TRUE;
#line 256 "PropertyTarget.c"
	} else {
		GalaGestureAction _tmp1_;
#line 27 "../src/Gestures/PropertyTarget.vala"
		_tmp1_ = self->priv->_action;
#line 27 "../src/Gestures/PropertyTarget.vala"
		_tmp0_ = action != _tmp1_;
#line 263 "PropertyTarget.c"
	}
#line 27 "../src/Gestures/PropertyTarget.vala"
	if (_tmp0_) {
#line 28 "../src/Gestures/PropertyTarget.vala"
		return;
#line 269 "PropertyTarget.c"
	}
#line 31 "../src/Gestures/PropertyTarget.vala"
	_tmp2_ = gala_gesture_target_get_actor ((GalaGestureTarget*) self);
#line 31 "../src/Gestures/PropertyTarget.vala"
	_tmp3_ = _tmp2_;
#line 31 "../src/Gestures/PropertyTarget.vala"
	_tmp4_ = self->priv->_property;
#line 31 "../src/Gestures/PropertyTarget.vala"
	_tmp5_ = self->priv->_interval;
#line 31 "../src/Gestures/PropertyTarget.vala"
	_tmp6_ = *clutter_interval_compute (_tmp5_, progress);
#line 31 "../src/Gestures/PropertyTarget.vala"
	g_object_set_property ((GObject*) _tmp3_, _tmp4_, &_tmp6_);
#line 283 "PropertyTarget.c"
}

GalaGestureAction
gala_property_target_get_action (GalaPropertyTarget* self)
{
	GalaGestureAction result;
#line 9 "../src/Gestures/PropertyTarget.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 9 "../src/Gestures/PropertyTarget.vala"
	result = self->priv->_action;
#line 9 "../src/Gestures/PropertyTarget.vala"
	return result;
#line 296 "PropertyTarget.c"
}

static void
gala_property_target_set_action (GalaPropertyTarget* self,
                                 GalaGestureAction value)
{
	GalaGestureAction old_value;
#line 9 "../src/Gestures/PropertyTarget.vala"
	g_return_if_fail (self != NULL);
#line 9 "../src/Gestures/PropertyTarget.vala"
	old_value = gala_property_target_get_action (self);
#line 9 "../src/Gestures/PropertyTarget.vala"
	if (old_value != value) {
#line 9 "../src/Gestures/PropertyTarget.vala"
		self->priv->_action = value;
#line 9 "../src/Gestures/PropertyTarget.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_property_target_properties[GALA_PROPERTY_TARGET_ACTION_PROPERTY]);
#line 314 "PropertyTarget.c"
	}
}

static ClutterActor*
gala_property_target_real_get_actor (GalaGestureTarget* base)
{
	ClutterActor* result;
	GalaPropertyTarget* self;
	ClutterActor* _tmp0_;
#line 13 "../src/Gestures/PropertyTarget.vala"
	self = (GalaPropertyTarget*) base;
#line 13 "../src/Gestures/PropertyTarget.vala"
	_tmp0_ = self->priv->_actor;
#line 13 "../src/Gestures/PropertyTarget.vala"
	result = _tmp0_;
#line 13 "../src/Gestures/PropertyTarget.vala"
	return result;
#line 332 "PropertyTarget.c"
}

const gchar*
gala_property_target_get_property (GalaPropertyTarget* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 15 "../src/Gestures/PropertyTarget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 15 "../src/Gestures/PropertyTarget.vala"
	_tmp0_ = self->priv->_property;
#line 15 "../src/Gestures/PropertyTarget.vala"
	result = _tmp0_;
#line 15 "../src/Gestures/PropertyTarget.vala"
	return result;
#line 348 "PropertyTarget.c"
}

static void
gala_property_target_set_property (GalaPropertyTarget* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 15 "../src/Gestures/PropertyTarget.vala"
	g_return_if_fail (self != NULL);
#line 15 "../src/Gestures/PropertyTarget.vala"
	old_value = gala_property_target_get_property (self);
#line 15 "../src/Gestures/PropertyTarget.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 362 "PropertyTarget.c"
		gchar* _tmp0_;
#line 15 "../src/Gestures/PropertyTarget.vala"
		_tmp0_ = g_strdup (value);
#line 15 "../src/Gestures/PropertyTarget.vala"
		_g_free0 (self->priv->_property);
#line 15 "../src/Gestures/PropertyTarget.vala"
		self->priv->_property = _tmp0_;
#line 15 "../src/Gestures/PropertyTarget.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_property_target_properties[GALA_PROPERTY_TARGET_PROPERTY_PROPERTY]);
#line 372 "PropertyTarget.c"
	}
}

ClutterInterval*
gala_property_target_get_interval (GalaPropertyTarget* self)
{
	ClutterInterval* result;
	ClutterInterval* _tmp0_;
#line 17 "../src/Gestures/PropertyTarget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 17 "../src/Gestures/PropertyTarget.vala"
	_tmp0_ = self->priv->_interval;
#line 17 "../src/Gestures/PropertyTarget.vala"
	result = _tmp0_;
#line 17 "../src/Gestures/PropertyTarget.vala"
	return result;
#line 389 "PropertyTarget.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 17 "../src/Gestures/PropertyTarget.vala"
	return self ? g_object_ref (self) : NULL;
#line 397 "PropertyTarget.c"
}

static void
gala_property_target_set_interval (GalaPropertyTarget* self,
                                   ClutterInterval* value)
{
	ClutterInterval* old_value;
#line 17 "../src/Gestures/PropertyTarget.vala"
	g_return_if_fail (self != NULL);
#line 17 "../src/Gestures/PropertyTarget.vala"
	old_value = gala_property_target_get_interval (self);
#line 17 "../src/Gestures/PropertyTarget.vala"
	if (old_value != value) {
#line 411 "PropertyTarget.c"
		ClutterInterval* _tmp0_;
#line 17 "../src/Gestures/PropertyTarget.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 17 "../src/Gestures/PropertyTarget.vala"
		_g_object_unref0 (self->priv->_interval);
#line 17 "../src/Gestures/PropertyTarget.vala"
		self->priv->_interval = _tmp0_;
#line 17 "../src/Gestures/PropertyTarget.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_property_target_properties[GALA_PROPERTY_TARGET_INTERVAL_PROPERTY]);
#line 421 "PropertyTarget.c"
	}
}

static void
gala_property_target_class_init (GalaPropertyTargetClass * klass,
                                 gpointer klass_data)
{
#line 8 "../src/Gestures/PropertyTarget.vala"
	gala_property_target_parent_class = g_type_class_peek_parent (klass);
#line 8 "../src/Gestures/PropertyTarget.vala"
	g_type_class_adjust_private_offset (klass, &GalaPropertyTarget_private_offset);
#line 8 "../src/Gestures/PropertyTarget.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_property_target_get_property;
#line 8 "../src/Gestures/PropertyTarget.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_property_target_set_property;
#line 8 "../src/Gestures/PropertyTarget.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_property_target_finalize;
#line 8 "../src/Gestures/PropertyTarget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PROPERTY_TARGET_ACTION_PROPERTY, gala_property_target_properties[GALA_PROPERTY_TARGET_ACTION_PROPERTY] = g_param_spec_enum ("action", "action", "action", GALA_TYPE_GESTURE_ACTION, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 8 "../src/Gestures/PropertyTarget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PROPERTY_TARGET_ACTOR_PROPERTY, gala_property_target_properties[GALA_PROPERTY_TARGET_ACTOR_PROPERTY] = g_param_spec_object ("actor", "actor", "actor", clutter_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 8 "../src/Gestures/PropertyTarget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PROPERTY_TARGET_PROPERTY_PROPERTY, gala_property_target_properties[GALA_PROPERTY_TARGET_PROPERTY_PROPERTY] = g_param_spec_string ("property", "property", "property", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 8 "../src/Gestures/PropertyTarget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PROPERTY_TARGET_INTERVAL_PROPERTY, gala_property_target_properties[GALA_PROPERTY_TARGET_INTERVAL_PROPERTY] = g_param_spec_object ("interval", "interval", "interval", clutter_interval_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 447 "PropertyTarget.c"
}

static void
gala_property_target_gala_gesture_target_interface_init (GalaGestureTargetIface * iface,
                                                         gpointer iface_data)
{
#line 8 "../src/Gestures/PropertyTarget.vala"
	gala_property_target_gala_gesture_target_parent_iface = g_type_interface_peek_parent (iface);
#line 8 "../src/Gestures/PropertyTarget.vala"
	iface->propagate = (void (*) (GalaGestureTarget*, GalaGestureTargetUpdateType, GalaGestureAction, gdouble)) gala_property_target_real_propagate;
#line 8 "../src/Gestures/PropertyTarget.vala"
	iface->get_actor = gala_property_target_real_get_actor;
#line 460 "PropertyTarget.c"
}

static void
gala_property_target_instance_init (GalaPropertyTarget * self,
                                    gpointer klass)
{
#line 8 "../src/Gestures/PropertyTarget.vala"
	self->priv = gala_property_target_get_instance_private (self);
#line 469 "PropertyTarget.c"
}

static void
gala_property_target_finalize (GObject * obj)
{
	GalaPropertyTarget * self;
#line 8 "../src/Gestures/PropertyTarget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_PROPERTY_TARGET, GalaPropertyTarget);
#line 15 "../src/Gestures/PropertyTarget.vala"
	_g_free0 (self->priv->_property);
#line 17 "../src/Gestures/PropertyTarget.vala"
	_g_object_unref0 (self->priv->_interval);
#line 8 "../src/Gestures/PropertyTarget.vala"
	G_OBJECT_CLASS (gala_property_target_parent_class)->finalize (obj);
#line 484 "PropertyTarget.c"
}

 G_GNUC_NO_INLINE static GType
gala_property_target_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaPropertyTargetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_property_target_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaPropertyTarget), 0, (GInstanceInitFunc) gala_property_target_instance_init, NULL };
	static const GInterfaceInfo gala_gesture_target_info = { (GInterfaceInitFunc) gala_property_target_gala_gesture_target_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gala_property_target_type_id;
	gala_property_target_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaPropertyTarget", &g_define_type_info, 0);
	g_type_add_interface_static (gala_property_target_type_id, GALA_TYPE_GESTURE_TARGET, &gala_gesture_target_info);
	GalaPropertyTarget_private_offset = g_type_add_instance_private (gala_property_target_type_id, sizeof (GalaPropertyTargetPrivate));
	return gala_property_target_type_id;
}

GType
gala_property_target_get_type (void)
{
	static gsize gala_property_target_type_id__once = 0;
	if (g_once_init_enter (&gala_property_target_type_id__once)) {
		GType gala_property_target_type_id;
		gala_property_target_type_id = gala_property_target_get_type_once ();
		g_once_init_leave (&gala_property_target_type_id__once, gala_property_target_type_id);
	}
	return gala_property_target_type_id__once;
}

static void
_vala_gala_property_target_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	GalaPropertyTarget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_PROPERTY_TARGET, GalaPropertyTarget);
#line 8 "../src/Gestures/PropertyTarget.vala"
	switch (property_id) {
#line 8 "../src/Gestures/PropertyTarget.vala"
		case GALA_PROPERTY_TARGET_ACTION_PROPERTY:
#line 8 "../src/Gestures/PropertyTarget.vala"
		g_value_set_enum (value, gala_property_target_get_action (self));
#line 8 "../src/Gestures/PropertyTarget.vala"
		break;
#line 8 "../src/Gestures/PropertyTarget.vala"
		case GALA_PROPERTY_TARGET_ACTOR_PROPERTY:
#line 8 "../src/Gestures/PropertyTarget.vala"
		g_value_set_object (value, gala_gesture_target_get_actor ((GalaGestureTarget*) self));
#line 8 "../src/Gestures/PropertyTarget.vala"
		break;
#line 8 "../src/Gestures/PropertyTarget.vala"
		case GALA_PROPERTY_TARGET_PROPERTY_PROPERTY:
#line 8 "../src/Gestures/PropertyTarget.vala"
		g_value_set_string (value, gala_property_target_get_property (self));
#line 8 "../src/Gestures/PropertyTarget.vala"
		break;
#line 8 "../src/Gestures/PropertyTarget.vala"
		case GALA_PROPERTY_TARGET_INTERVAL_PROPERTY:
#line 8 "../src/Gestures/PropertyTarget.vala"
		g_value_set_object (value, gala_property_target_get_interval (self));
#line 8 "../src/Gestures/PropertyTarget.vala"
		break;
#line 545 "PropertyTarget.c"
		default:
#line 8 "../src/Gestures/PropertyTarget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/Gestures/PropertyTarget.vala"
		break;
#line 551 "PropertyTarget.c"
	}
}

static void
_vala_gala_property_target_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	GalaPropertyTarget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_PROPERTY_TARGET, GalaPropertyTarget);
#line 8 "../src/Gestures/PropertyTarget.vala"
	switch (property_id) {
#line 8 "../src/Gestures/PropertyTarget.vala"
		case GALA_PROPERTY_TARGET_ACTION_PROPERTY:
#line 8 "../src/Gestures/PropertyTarget.vala"
		gala_property_target_set_action (self, g_value_get_enum (value));
#line 8 "../src/Gestures/PropertyTarget.vala"
		break;
#line 8 "../src/Gestures/PropertyTarget.vala"
		case GALA_PROPERTY_TARGET_PROPERTY_PROPERTY:
#line 8 "../src/Gestures/PropertyTarget.vala"
		gala_property_target_set_property (self, g_value_get_string (value));
#line 8 "../src/Gestures/PropertyTarget.vala"
		break;
#line 8 "../src/Gestures/PropertyTarget.vala"
		case GALA_PROPERTY_TARGET_INTERVAL_PROPERTY:
#line 8 "../src/Gestures/PropertyTarget.vala"
		gala_property_target_set_interval (self, g_value_get_object (value));
#line 8 "../src/Gestures/PropertyTarget.vala"
		break;
#line 583 "PropertyTarget.c"
		default:
#line 8 "../src/Gestures/PropertyTarget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/Gestures/PropertyTarget.vala"
		break;
#line 589 "PropertyTarget.c"
	}
}

