/* DwellClickTimer.c generated by valac 0.56.18, the Vala compiler
 * generated from DwellClickTimer.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2020, 2025 elementary, Inc. (https://elementary.io)
 */

#include <clutter/clutter.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <cogl/cogl.h>
#include <cairo-gobject.h>
#include <gio/gio.h>
#include <meta/display.h>
#include <gdk/gdk.h>
#include "gala.h"
#include <stdlib.h>
#include <string.h>
#include <meta/meta-cursor-tracker.h>
#include <graphene-gobject.h>

#define GALA_DWELL_CLICK_TIMER_BACKGROUND_OPACITY 0.7
#define GALA_DWELL_CLICK_TIMER_BORDER_WIDTH_PX 1
#define GALA_DWELL_CLICK_TIMER_START_ANGLE ((3 * G_PI) / 2)
#define GALA_DWELL_CLICK_TIMER_DELAY_TIMEOUT ((gdouble) 185)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_DWELL_CLICK_TIMER (gala_dwell_click_timer_get_type ())
#define GALA_DWELL_CLICK_TIMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_DWELL_CLICK_TIMER, GalaDwellClickTimer))
#define GALA_DWELL_CLICK_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_DWELL_CLICK_TIMER, GalaDwellClickTimerClass))
#define GALA_IS_DWELL_CLICK_TIMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_DWELL_CLICK_TIMER))
#define GALA_IS_DWELL_CLICK_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_DWELL_CLICK_TIMER))
#define GALA_DWELL_CLICK_TIMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_DWELL_CLICK_TIMER, GalaDwellClickTimerClass))

typedef struct _GalaDwellClickTimer GalaDwellClickTimer;
typedef struct _GalaDwellClickTimerClass GalaDwellClickTimerClass;
typedef struct _GalaDwellClickTimerPrivate GalaDwellClickTimerPrivate;
enum  {
	GALA_DWELL_CLICK_TIMER_0_PROPERTY,
	GALA_DWELL_CLICK_TIMER_DISPLAY_PROPERTY,
	GALA_DWELL_CLICK_TIMER_ANGLE_PROPERTY,
	GALA_DWELL_CLICK_TIMER_NUM_PROPERTIES
};
static GParamSpec* gala_dwell_click_timer_properties[GALA_DWELL_CLICK_TIMER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))

struct _GalaDwellClickTimer {
	ClutterActor parent_instance;
	GalaDwellClickTimerPrivate * priv;
};

struct _GalaDwellClickTimerClass {
	ClutterActorClass parent_class;
};

struct _GalaDwellClickTimerPrivate {
	gfloat scaling_factor;
	gint cursor_size;
	CoglPipeline* pipeline;
	ClutterPropertyTransition* transition;
	cairo_pattern_t* stroke_color;
	cairo_pattern_t* fill_color;
	GSettings* interface_settings;
	cairo_surface_t* surface;
	MetaDisplay* _display;
	gdouble _angle;
};

static gint GalaDwellClickTimer_private_offset;
static gpointer gala_dwell_click_timer_parent_class = NULL;
static ClutterAnimatableInterface * gala_dwell_click_timer_clutter_animatable_parent_iface = NULL;

VALA_EXTERN GType gala_dwell_click_timer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaDwellClickTimer, g_object_unref)
VALA_EXTERN GalaDwellClickTimer* gala_dwell_click_timer_new (MetaDisplay* display);
VALA_EXTERN GalaDwellClickTimer* gala_dwell_click_timer_construct (GType object_type,
                                                       MetaDisplay* display);
static void gala_dwell_click_timer_update_cursor_size (GalaDwellClickTimer* self,
                                                gfloat scale);
static void gala_dwell_click_timer_real_paint (ClutterActor* base,
                                        ClutterPaintContext* context);
VALA_EXTERN gdouble gala_dwell_click_timer_get_angle (GalaDwellClickTimer* self);
static gboolean gala_dwell_click_timer_real_interpolate_value (ClutterAnimatable* base,
                                                        const gchar* property_name,
                                                        ClutterInterval* interval,
                                                        gdouble progress,
                                                        GValue* value);
VALA_EXTERN MetaDisplay* gala_dwell_click_timer_get_display (GalaDwellClickTimer* self);
static void gala_dwell_click_timer_set_display (GalaDwellClickTimer* self,
                                         MetaDisplay* value);
VALA_EXTERN void gala_dwell_click_timer_set_angle (GalaDwellClickTimer* self,
                                       gdouble value);
static GObject * gala_dwell_click_timer_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void _gala_dwell_click_timer___lambda148_ (GalaDwellClickTimer* self);
static void __gala_dwell_click_timer___lambda148__clutter_timeline_new_frame (ClutterTimeline* _sender,
                                                                       gint msecs,
                                                                       gpointer self);
static void _gala_dwell_click_timer___lambda149_ (GalaDwellClickTimer* self,
                                           ClutterInputDevice* device,
                                           ClutterPointerA11yTimeoutType type,
                                           guint timeout);
static void __gala_dwell_click_timer___lambda149__clutter_seat_ptr_a11y_timeout_started (ClutterSeat* _sender,
                                                                                  ClutterInputDevice* device,
                                                                                  ClutterPointerA11yTimeoutType timeout_type,
                                                                                  guint delay,
                                                                                  gpointer self);
static void _gala_dwell_click_timer___lambda150_ (GalaDwellClickTimer* self,
                                           ClutterInputDevice* device,
                                           ClutterPointerA11yTimeoutType type,
                                           gboolean clicked);
static void __gala_dwell_click_timer___lambda150__clutter_seat_ptr_a11y_timeout_stopped (ClutterSeat* _sender,
                                                                                  ClutterInputDevice* device,
                                                                                  ClutterPointerA11yTimeoutType timeout_type,
                                                                                  gboolean clicked,
                                                                                  gpointer self);
static void gala_dwell_click_timer_finalize (GObject * obj);
static GType gala_dwell_click_timer_get_type_once (void);
static void _vala_gala_dwell_click_timer_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_gala_dwell_click_timer_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
gala_dwell_click_timer_get_instance_private (GalaDwellClickTimer* self)
{
	return G_STRUCT_MEMBER_P (self, GalaDwellClickTimer_private_offset);
}

GalaDwellClickTimer*
gala_dwell_click_timer_construct (GType object_type,
                                  MetaDisplay* display)
{
	GalaDwellClickTimer * self = NULL;
#line 33 "../src/Widgets/DwellClickTimer.vala"
	g_return_val_if_fail (display != NULL, NULL);
#line 34 "../src/Widgets/DwellClickTimer.vala"
	self = (GalaDwellClickTimer*) g_object_new (object_type, "display", display, NULL);
#line 33 "../src/Widgets/DwellClickTimer.vala"
	return self;
#line 169 "DwellClickTimer.c"
}

GalaDwellClickTimer*
gala_dwell_click_timer_new (MetaDisplay* display)
{
#line 33 "../src/Widgets/DwellClickTimer.vala"
	return gala_dwell_click_timer_construct (GALA_TYPE_DWELL_CLICK_TIMER, display);
#line 177 "DwellClickTimer.c"
}

static void
gala_dwell_click_timer_update_cursor_size (GalaDwellClickTimer* self,
                                           gfloat scale)
{
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	cairo_surface_t* _tmp3_;
#line 90 "../src/Widgets/DwellClickTimer.vala"
	g_return_if_fail (self != NULL);
#line 91 "../src/Widgets/DwellClickTimer.vala"
	self->priv->scaling_factor = scale;
#line 93 "../src/Widgets/DwellClickTimer.vala"
	_tmp0_ = self->priv->interface_settings;
#line 93 "../src/Widgets/DwellClickTimer.vala"
	self->priv->cursor_size = (gint) ((g_settings_get_int (_tmp0_, "cursor-size") * self->priv->scaling_factor) * 1.25);
#line 95 "../src/Widgets/DwellClickTimer.vala"
	_tmp3_ = self->priv->surface;
#line 95 "../src/Widgets/DwellClickTimer.vala"
	if (_tmp3_ == NULL) {
#line 95 "../src/Widgets/DwellClickTimer.vala"
		_tmp2_ = TRUE;
#line 202 "DwellClickTimer.c"
	} else {
		cairo_surface_t* _tmp4_;
#line 95 "../src/Widgets/DwellClickTimer.vala"
		_tmp4_ = self->priv->surface;
#line 95 "../src/Widgets/DwellClickTimer.vala"
		_tmp2_ = cairo_image_surface_get_width (_tmp4_) != self->priv->cursor_size;
#line 209 "DwellClickTimer.c"
	}
#line 95 "../src/Widgets/DwellClickTimer.vala"
	if (_tmp2_) {
#line 95 "../src/Widgets/DwellClickTimer.vala"
		_tmp1_ = TRUE;
#line 215 "DwellClickTimer.c"
	} else {
		cairo_surface_t* _tmp5_;
#line 95 "../src/Widgets/DwellClickTimer.vala"
		_tmp5_ = self->priv->surface;
#line 95 "../src/Widgets/DwellClickTimer.vala"
		_tmp1_ = cairo_image_surface_get_height (_tmp5_) != self->priv->cursor_size;
#line 222 "DwellClickTimer.c"
	}
#line 95 "../src/Widgets/DwellClickTimer.vala"
	if (_tmp1_) {
#line 226 "DwellClickTimer.c"
		cairo_surface_t* _tmp6_;
#line 96 "../src/Widgets/DwellClickTimer.vala"
		_tmp6_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, self->priv->cursor_size, self->priv->cursor_size);
#line 96 "../src/Widgets/DwellClickTimer.vala"
		_cairo_surface_destroy0 (self->priv->surface);
#line 96 "../src/Widgets/DwellClickTimer.vala"
		self->priv->surface = _tmp6_;
#line 234 "DwellClickTimer.c"
	}
#line 99 "../src/Widgets/DwellClickTimer.vala"
	clutter_actor_set_size ((ClutterActor*) self, (gfloat) self->priv->cursor_size, (gfloat) self->priv->cursor_size);
#line 238 "DwellClickTimer.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 143 "../src/Widgets/DwellClickTimer.vala"
	return self ? g_object_ref (self) : NULL;
#line 246 "DwellClickTimer.c"
}

static void
gala_dwell_click_timer_real_paint (ClutterActor* base,
                                   ClutterPaintContext* context)
{
	GalaDwellClickTimer * self;
	gdouble _tmp0_;
	GdkRGBA rgba = {0};
	GalaDrawingStyleManager* _tmp1_;
	GalaDrawingStyleManager* _tmp2_;
	GdkRGBA _tmp3_ = {0};
	GdkRGBA _tmp4_;
	GdkRGBA _tmp5_;
	GdkRGBA _tmp6_;
	GdkRGBA _tmp7_;
	GdkRGBA _tmp8_;
	cairo_pattern_t* _tmp9_;
	GdkRGBA _tmp10_;
	GdkRGBA _tmp11_;
	GdkRGBA _tmp12_;
	cairo_pattern_t* _tmp13_;
	gint radius = 0;
	gdouble end_angle = 0.0;
	gdouble _tmp14_;
	gint border_width = 0;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp15_;
	cairo_t* _tmp16_;
	cairo_t* _tmp17_;
	cairo_t* _tmp18_;
	cairo_t* _tmp19_;
	cairo_t* _tmp20_;
	cairo_t* _tmp21_;
	cairo_t* _tmp22_;
	cairo_t* _tmp23_;
	cairo_t* _tmp24_;
	cairo_t* _tmp25_;
	cairo_t* _tmp26_;
	cairo_t* _tmp27_;
	cairo_t* _tmp28_;
	cairo_t* _tmp29_;
	cairo_t* _tmp30_;
	cairo_pattern_t* _tmp31_;
	cairo_t* _tmp32_;
	cairo_t* _tmp33_;
	cairo_t* _tmp34_;
	cairo_pattern_t* _tmp35_;
	cairo_t* _tmp36_;
	CoglContext* cogl_context = NULL;
	CoglFramebuffer* _tmp37_;
	CoglContext* _tmp38_;
	CoglContext* _tmp39_;
	GError* _inner_error0_ = NULL;
#line 102 "../src/Widgets/DwellClickTimer.vala"
	self = (GalaDwellClickTimer*) base;
#line 102 "../src/Widgets/DwellClickTimer.vala"
	g_return_if_fail (context != NULL);
#line 103 "../src/Widgets/DwellClickTimer.vala"
	_tmp0_ = self->priv->_angle;
#line 103 "../src/Widgets/DwellClickTimer.vala"
	if (_tmp0_ == ((gdouble) 0)) {
#line 104 "../src/Widgets/DwellClickTimer.vala"
		return;
#line 311 "DwellClickTimer.c"
	}
#line 107 "../src/Widgets/DwellClickTimer.vala"
	_tmp1_ = gala_drawing_style_manager_get_instance ();
#line 107 "../src/Widgets/DwellClickTimer.vala"
	_tmp2_ = _tmp1_;
#line 107 "../src/Widgets/DwellClickTimer.vala"
	gala_drawing_style_manager_get_theme_accent_color (_tmp2_, &_tmp3_);
#line 107 "../src/Widgets/DwellClickTimer.vala"
	_tmp4_ = _tmp3_;
#line 107 "../src/Widgets/DwellClickTimer.vala"
	_tmp5_ = _tmp4_;
#line 107 "../src/Widgets/DwellClickTimer.vala"
	_g_object_unref0 (_tmp2_);
#line 107 "../src/Widgets/DwellClickTimer.vala"
	rgba = _tmp5_;
#line 110 "../src/Widgets/DwellClickTimer.vala"
	_tmp6_ = rgba;
#line 110 "../src/Widgets/DwellClickTimer.vala"
	_tmp7_ = rgba;
#line 110 "../src/Widgets/DwellClickTimer.vala"
	_tmp8_ = rgba;
#line 110 "../src/Widgets/DwellClickTimer.vala"
	_tmp9_ = cairo_pattern_create_rgb (_tmp6_.red, _tmp7_.green, _tmp8_.blue);
#line 110 "../src/Widgets/DwellClickTimer.vala"
	_cairo_pattern_destroy0 (self->priv->stroke_color);
#line 110 "../src/Widgets/DwellClickTimer.vala"
	self->priv->stroke_color = _tmp9_;
#line 111 "../src/Widgets/DwellClickTimer.vala"
	_tmp10_ = rgba;
#line 111 "../src/Widgets/DwellClickTimer.vala"
	_tmp11_ = rgba;
#line 111 "../src/Widgets/DwellClickTimer.vala"
	_tmp12_ = rgba;
#line 111 "../src/Widgets/DwellClickTimer.vala"
	_tmp13_ = cairo_pattern_create_rgba (_tmp10_.red, _tmp11_.green, _tmp12_.blue, GALA_DWELL_CLICK_TIMER_BACKGROUND_OPACITY);
#line 111 "../src/Widgets/DwellClickTimer.vala"
	_cairo_pattern_destroy0 (self->priv->fill_color);
#line 111 "../src/Widgets/DwellClickTimer.vala"
	self->priv->fill_color = _tmp13_;
#line 113 "../src/Widgets/DwellClickTimer.vala"
	radius = MIN (self->priv->cursor_size / 2, self->priv->cursor_size / 2);
#line 114 "../src/Widgets/DwellClickTimer.vala"
	_tmp14_ = self->priv->_angle;
#line 114 "../src/Widgets/DwellClickTimer.vala"
	end_angle = GALA_DWELL_CLICK_TIMER_START_ANGLE + _tmp14_;
#line 115 "../src/Widgets/DwellClickTimer.vala"
	border_width = gala_utils_scale_to_int (GALA_DWELL_CLICK_TIMER_BORDER_WIDTH_PX, self->priv->scaling_factor);
#line 117 "../src/Widgets/DwellClickTimer.vala"
	_tmp15_ = self->priv->surface;
#line 117 "../src/Widgets/DwellClickTimer.vala"
	_tmp16_ = cairo_create (_tmp15_);
#line 117 "../src/Widgets/DwellClickTimer.vala"
	cr = _tmp16_;
#line 120 "../src/Widgets/DwellClickTimer.vala"
	_tmp17_ = cr;
#line 120 "../src/Widgets/DwellClickTimer.vala"
	cairo_save (_tmp17_);
#line 121 "../src/Widgets/DwellClickTimer.vala"
	_tmp18_ = cr;
#line 121 "../src/Widgets/DwellClickTimer.vala"
	cairo_set_source_rgba (_tmp18_, (gdouble) 0, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 122 "../src/Widgets/DwellClickTimer.vala"
	_tmp19_ = cr;
#line 122 "../src/Widgets/DwellClickTimer.vala"
	cairo_set_operator (_tmp19_, CAIRO_OPERATOR_SOURCE);
#line 123 "../src/Widgets/DwellClickTimer.vala"
	_tmp20_ = cr;
#line 123 "../src/Widgets/DwellClickTimer.vala"
	cairo_paint (_tmp20_);
#line 124 "../src/Widgets/DwellClickTimer.vala"
	_tmp21_ = cr;
#line 124 "../src/Widgets/DwellClickTimer.vala"
	cairo_restore (_tmp21_);
#line 126 "../src/Widgets/DwellClickTimer.vala"
	_tmp22_ = cr;
#line 126 "../src/Widgets/DwellClickTimer.vala"
	cairo_set_line_cap (_tmp22_, CAIRO_LINE_CAP_ROUND);
#line 127 "../src/Widgets/DwellClickTimer.vala"
	_tmp23_ = cr;
#line 127 "../src/Widgets/DwellClickTimer.vala"
	cairo_set_line_join (_tmp23_, CAIRO_LINE_JOIN_ROUND);
#line 128 "../src/Widgets/DwellClickTimer.vala"
	_tmp24_ = cr;
#line 128 "../src/Widgets/DwellClickTimer.vala"
	cairo_translate (_tmp24_, (gdouble) (self->priv->cursor_size / 2), (gdouble) (self->priv->cursor_size / 2));
#line 130 "../src/Widgets/DwellClickTimer.vala"
	_tmp25_ = cr;
#line 130 "../src/Widgets/DwellClickTimer.vala"
	cairo_move_to (_tmp25_, (gdouble) 0, (gdouble) 0);
#line 131 "../src/Widgets/DwellClickTimer.vala"
	_tmp26_ = cr;
#line 131 "../src/Widgets/DwellClickTimer.vala"
	cairo_arc (_tmp26_, (gdouble) 0, (gdouble) 0, (gdouble) (radius - border_width), GALA_DWELL_CLICK_TIMER_START_ANGLE, end_angle);
#line 132 "../src/Widgets/DwellClickTimer.vala"
	_tmp27_ = cr;
#line 132 "../src/Widgets/DwellClickTimer.vala"
	cairo_line_to (_tmp27_, (gdouble) 0, (gdouble) 0);
#line 133 "../src/Widgets/DwellClickTimer.vala"
	_tmp28_ = cr;
#line 133 "../src/Widgets/DwellClickTimer.vala"
	cairo_close_path (_tmp28_);
#line 135 "../src/Widgets/DwellClickTimer.vala"
	_tmp29_ = cr;
#line 135 "../src/Widgets/DwellClickTimer.vala"
	cairo_set_line_width (_tmp29_, (gdouble) 0);
#line 136 "../src/Widgets/DwellClickTimer.vala"
	_tmp30_ = cr;
#line 136 "../src/Widgets/DwellClickTimer.vala"
	_tmp31_ = self->priv->fill_color;
#line 136 "../src/Widgets/DwellClickTimer.vala"
	cairo_set_source (_tmp30_, _tmp31_);
#line 137 "../src/Widgets/DwellClickTimer.vala"
	_tmp32_ = cr;
#line 137 "../src/Widgets/DwellClickTimer.vala"
	cairo_fill_preserve (_tmp32_);
#line 139 "../src/Widgets/DwellClickTimer.vala"
	_tmp33_ = cr;
#line 139 "../src/Widgets/DwellClickTimer.vala"
	cairo_set_line_width (_tmp33_, (gdouble) border_width);
#line 140 "../src/Widgets/DwellClickTimer.vala"
	_tmp34_ = cr;
#line 140 "../src/Widgets/DwellClickTimer.vala"
	_tmp35_ = self->priv->stroke_color;
#line 140 "../src/Widgets/DwellClickTimer.vala"
	cairo_set_source (_tmp34_, _tmp35_);
#line 141 "../src/Widgets/DwellClickTimer.vala"
	_tmp36_ = cr;
#line 141 "../src/Widgets/DwellClickTimer.vala"
	cairo_stroke (_tmp36_);
#line 143 "../src/Widgets/DwellClickTimer.vala"
	_tmp37_ = clutter_paint_context_get_framebuffer (context);
#line 143 "../src/Widgets/DwellClickTimer.vala"
	_tmp38_ = cogl_framebuffer_get_context (_tmp37_);
#line 143 "../src/Widgets/DwellClickTimer.vala"
	_tmp39_ = _g_object_ref0 (_tmp38_);
#line 143 "../src/Widgets/DwellClickTimer.vala"
	cogl_context = _tmp39_;
#line 449 "DwellClickTimer.c"
	{
		CoglTexture2D* texture = NULL;
		CoglContext* _tmp40_;
		cairo_surface_t* _tmp41_;
		cairo_surface_t* _tmp42_;
		guchar* _tmp43_;
		CoglTexture2D* _tmp44_;
		CoglPipeline* _tmp45_;
		CoglTexture2D* _tmp46_;
		CoglFramebuffer* _tmp47_;
		CoglPipeline* _tmp48_;
#line 146 "../src/Widgets/DwellClickTimer.vala"
		_tmp40_ = cogl_context;
#line 146 "../src/Widgets/DwellClickTimer.vala"
		_tmp41_ = self->priv->surface;
#line 146 "../src/Widgets/DwellClickTimer.vala"
		_tmp42_ = self->priv->surface;
#line 146 "../src/Widgets/DwellClickTimer.vala"
		_tmp43_ = cairo_image_surface_get_data (_tmp42_);
#line 146 "../src/Widgets/DwellClickTimer.vala"
		_tmp44_ = (CoglTexture2D*) cogl_texture_2d_new_from_data (_tmp40_, self->priv->cursor_size, self->priv->cursor_size, COGL_PIXEL_FORMAT_BGRA_8888_PRE, cairo_image_surface_get_stride (_tmp41_), _tmp43_, &_inner_error0_);
#line 146 "../src/Widgets/DwellClickTimer.vala"
		texture = _tmp44_;
#line 146 "../src/Widgets/DwellClickTimer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 475 "DwellClickTimer.c"
			goto __catch0_g_error;
		}
#line 149 "../src/Widgets/DwellClickTimer.vala"
		_tmp45_ = self->priv->pipeline;
#line 149 "../src/Widgets/DwellClickTimer.vala"
		_tmp46_ = texture;
#line 149 "../src/Widgets/DwellClickTimer.vala"
		cogl_pipeline_set_layer_texture (_tmp45_, 0, (CoglTexture*) _tmp46_);
#line 151 "../src/Widgets/DwellClickTimer.vala"
		_tmp47_ = clutter_paint_context_get_framebuffer (context);
#line 151 "../src/Widgets/DwellClickTimer.vala"
		_tmp48_ = self->priv->pipeline;
#line 151 "../src/Widgets/DwellClickTimer.vala"
		cogl_framebuffer_draw_rectangle (_tmp47_, _tmp48_, (gfloat) 0, (gfloat) 0, (gfloat) self->priv->cursor_size, (gfloat) self->priv->cursor_size);
#line 145 "../src/Widgets/DwellClickTimer.vala"
		_g_object_unref0 (texture);
#line 492 "DwellClickTimer.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 145 "../src/Widgets/DwellClickTimer.vala"
		g_clear_error (&_inner_error0_);
#line 499 "DwellClickTimer.c"
	}
	__finally0:
#line 145 "../src/Widgets/DwellClickTimer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 145 "../src/Widgets/DwellClickTimer.vala"
		_g_object_unref0 (cogl_context);
#line 145 "../src/Widgets/DwellClickTimer.vala"
		_cairo_destroy0 (cr);
#line 145 "../src/Widgets/DwellClickTimer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 145 "../src/Widgets/DwellClickTimer.vala"
		g_clear_error (&_inner_error0_);
#line 145 "../src/Widgets/DwellClickTimer.vala"
		return;
#line 514 "DwellClickTimer.c"
	}
#line 154 "../src/Widgets/DwellClickTimer.vala"
	CLUTTER_ACTOR_CLASS (gala_dwell_click_timer_parent_class)->paint (G_TYPE_CHECK_INSTANCE_CAST (self, clutter_actor_get_type (), ClutterActor), context);
#line 102 "../src/Widgets/DwellClickTimer.vala"
	_g_object_unref0 (cogl_context);
#line 102 "../src/Widgets/DwellClickTimer.vala"
	_cairo_destroy0 (cr);
#line 522 "DwellClickTimer.c"
}

static gboolean
gala_dwell_click_timer_real_interpolate_value (ClutterAnimatable* base,
                                               const gchar* property_name,
                                               ClutterInterval* interval,
                                               gdouble progress,
                                               GValue* value)
{
	GalaDwellClickTimer * self;
	GValue _vala_value = {0};
	GValue _tmp6_ = {0};
	gboolean _tmp7_;
	gboolean result;
#line 157 "../src/Widgets/DwellClickTimer.vala"
	self = (GalaDwellClickTimer*) base;
#line 157 "../src/Widgets/DwellClickTimer.vala"
	g_return_val_if_fail (property_name != NULL, FALSE);
#line 157 "../src/Widgets/DwellClickTimer.vala"
	g_return_val_if_fail (interval != NULL, FALSE);
#line 158 "../src/Widgets/DwellClickTimer.vala"
	if (g_strcmp0 (property_name, "angle") == 0) {
#line 545 "DwellClickTimer.c"
		GValue _tmp0_ = {0};
		guint elapsed_time = 0U;
		ClutterPropertyTransition* _tmp1_;
#line 159 "../src/Widgets/DwellClickTimer.vala"
		g_value_init (&_tmp0_, G_TYPE_INT);
#line 159 "../src/Widgets/DwellClickTimer.vala"
		g_value_set_int (&_tmp0_, 0);
#line 159 "../src/Widgets/DwellClickTimer.vala"
		G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 159 "../src/Widgets/DwellClickTimer.vala"
		_vala_value = _tmp0_;
#line 161 "../src/Widgets/DwellClickTimer.vala"
		_tmp1_ = self->priv->transition;
#line 161 "../src/Widgets/DwellClickTimer.vala"
		elapsed_time = clutter_timeline_get_elapsed_time ((ClutterTimeline*) _tmp1_);
#line 162 "../src/Widgets/DwellClickTimer.vala"
		if (((gdouble) elapsed_time) > GALA_DWELL_CLICK_TIMER_DELAY_TIMEOUT) {
#line 563 "DwellClickTimer.c"
			gdouble delayed_progress = 0.0;
			ClutterPropertyTransition* _tmp2_;
			guint _tmp3_;
			guint _tmp4_;
			GValue _tmp5_ = {0};
#line 163 "../src/Widgets/DwellClickTimer.vala"
			_tmp2_ = self->priv->transition;
#line 163 "../src/Widgets/DwellClickTimer.vala"
			_tmp3_ = clutter_timeline_get_duration ((ClutterTimeline*) _tmp2_);
#line 163 "../src/Widgets/DwellClickTimer.vala"
			_tmp4_ = _tmp3_;
#line 163 "../src/Widgets/DwellClickTimer.vala"
			delayed_progress = (elapsed_time - GALA_DWELL_CLICK_TIMER_DELAY_TIMEOUT) / (_tmp4_ - GALA_DWELL_CLICK_TIMER_DELAY_TIMEOUT);
#line 164 "../src/Widgets/DwellClickTimer.vala"
			g_value_init (&_tmp5_, G_TYPE_DOUBLE);
#line 164 "../src/Widgets/DwellClickTimer.vala"
			g_value_set_double (&_tmp5_, (delayed_progress * 2) * G_PI);
#line 164 "../src/Widgets/DwellClickTimer.vala"
			G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 164 "../src/Widgets/DwellClickTimer.vala"
			_vala_value = _tmp5_;
#line 585 "DwellClickTimer.c"
		}
#line 167 "../src/Widgets/DwellClickTimer.vala"
		result = TRUE;
#line 167 "../src/Widgets/DwellClickTimer.vala"
		if (value) {
#line 167 "../src/Widgets/DwellClickTimer.vala"
			*value = _vala_value;
#line 593 "DwellClickTimer.c"
		} else {
#line 167 "../src/Widgets/DwellClickTimer.vala"
			G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 597 "DwellClickTimer.c"
		}
#line 167 "../src/Widgets/DwellClickTimer.vala"
		return result;
#line 601 "DwellClickTimer.c"
	}
#line 170 "../src/Widgets/DwellClickTimer.vala"
	_tmp7_ = gala_dwell_click_timer_clutter_animatable_parent_iface->interpolate_value ((ClutterAnimatable*) G_TYPE_CHECK_INSTANCE_CAST (self, clutter_actor_get_type (), ClutterActor), property_name, interval, progress, &_tmp6_);
#line 170 "../src/Widgets/DwellClickTimer.vala"
	G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 170 "../src/Widgets/DwellClickTimer.vala"
	_vala_value = _tmp6_;
#line 170 "../src/Widgets/DwellClickTimer.vala"
	result = _tmp7_;
#line 170 "../src/Widgets/DwellClickTimer.vala"
	if (value) {
#line 170 "../src/Widgets/DwellClickTimer.vala"
		*value = _vala_value;
#line 615 "DwellClickTimer.c"
	} else {
#line 170 "../src/Widgets/DwellClickTimer.vala"
		G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 619 "DwellClickTimer.c"
	}
#line 170 "../src/Widgets/DwellClickTimer.vala"
	return result;
#line 623 "DwellClickTimer.c"
}

MetaDisplay*
gala_dwell_click_timer_get_display (GalaDwellClickTimer* self)
{
	MetaDisplay* result;
	MetaDisplay* _tmp0_;
#line 29 "../src/Widgets/DwellClickTimer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/Widgets/DwellClickTimer.vala"
	_tmp0_ = self->priv->_display;
#line 29 "../src/Widgets/DwellClickTimer.vala"
	result = _tmp0_;
#line 29 "../src/Widgets/DwellClickTimer.vala"
	return result;
#line 639 "DwellClickTimer.c"
}

static void
gala_dwell_click_timer_set_display (GalaDwellClickTimer* self,
                                    MetaDisplay* value)
{
	MetaDisplay* old_value;
#line 29 "../src/Widgets/DwellClickTimer.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Widgets/DwellClickTimer.vala"
	old_value = gala_dwell_click_timer_get_display (self);
#line 29 "../src/Widgets/DwellClickTimer.vala"
	if (old_value != value) {
#line 653 "DwellClickTimer.c"
		MetaDisplay* _tmp0_;
#line 29 "../src/Widgets/DwellClickTimer.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 29 "../src/Widgets/DwellClickTimer.vala"
		_g_object_unref0 (self->priv->_display);
#line 29 "../src/Widgets/DwellClickTimer.vala"
		self->priv->_display = _tmp0_;
#line 29 "../src/Widgets/DwellClickTimer.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_dwell_click_timer_properties[GALA_DWELL_CLICK_TIMER_DISPLAY_PROPERTY]);
#line 663 "DwellClickTimer.c"
	}
}

gdouble
gala_dwell_click_timer_get_angle (GalaDwellClickTimer* self)
{
	gdouble result;
#line 31 "../src/Widgets/DwellClickTimer.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 31 "../src/Widgets/DwellClickTimer.vala"
	result = self->priv->_angle;
#line 31 "../src/Widgets/DwellClickTimer.vala"
	return result;
#line 677 "DwellClickTimer.c"
}

void
gala_dwell_click_timer_set_angle (GalaDwellClickTimer* self,
                                  gdouble value)
{
	gdouble old_value;
#line 31 "../src/Widgets/DwellClickTimer.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/Widgets/DwellClickTimer.vala"
	old_value = gala_dwell_click_timer_get_angle (self);
#line 31 "../src/Widgets/DwellClickTimer.vala"
	if (old_value != value) {
#line 31 "../src/Widgets/DwellClickTimer.vala"
		self->priv->_angle = value;
#line 31 "../src/Widgets/DwellClickTimer.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_dwell_click_timer_properties[GALA_DWELL_CLICK_TIMER_ANGLE_PROPERTY]);
#line 695 "DwellClickTimer.c"
	}
}

static void
_gala_dwell_click_timer___lambda148_ (GalaDwellClickTimer* self)
{
#line 56 "../src/Widgets/DwellClickTimer.vala"
	clutter_actor_queue_redraw ((ClutterActor*) self);
#line 704 "DwellClickTimer.c"
}

static void
__gala_dwell_click_timer___lambda148__clutter_timeline_new_frame (ClutterTimeline* _sender,
                                                                  gint msecs,
                                                                  gpointer self)
{
#line 55 "../src/Widgets/DwellClickTimer.vala"
	_gala_dwell_click_timer___lambda148_ ((GalaDwellClickTimer*) self);
#line 714 "DwellClickTimer.c"
}

static void
_gala_dwell_click_timer___lambda149_ (GalaDwellClickTimer* self,
                                      ClutterInputDevice* device,
                                      ClutterPointerA11yTimeoutType type,
                                      guint timeout)
{
	gfloat scale = 0.0F;
	MetaDisplay* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaCursorTracker* tracker = NULL;
	MetaDisplay* _tmp2_;
	MetaCursorTracker* _tmp3_;
	graphene_point_t coords = {0};
	graphene_point_t _tmp4_ = {0};
	MetaCursorTracker* _tmp5_;
	graphene_point_t _tmp6_ = {0};
	graphene_point_t _tmp7_;
	gfloat _tmp8_;
	gfloat _tmp9_;
	graphene_point_t _tmp10_;
	gfloat _tmp11_;
	gfloat _tmp12_;
	ClutterPropertyTransition* _tmp13_;
	ClutterPropertyTransition* _tmp14_;
#line 64 "../src/Widgets/DwellClickTimer.vala"
	g_return_if_fail (device != NULL);
#line 65 "../src/Widgets/DwellClickTimer.vala"
	_tmp0_ = self->priv->_display;
#line 65 "../src/Widgets/DwellClickTimer.vala"
	_tmp1_ = self->priv->_display;
#line 65 "../src/Widgets/DwellClickTimer.vala"
	scale = meta_display_get_monitor_scale (_tmp0_, meta_display_get_current_monitor (_tmp1_));
#line 66 "../src/Widgets/DwellClickTimer.vala"
	gala_dwell_click_timer_update_cursor_size (self, scale);
#line 71 "../src/Widgets/DwellClickTimer.vala"
	_tmp2_ = self->priv->_display;
#line 71 "../src/Widgets/DwellClickTimer.vala"
	_tmp3_ = meta_cursor_tracker_get_for_display (_tmp2_);
#line 71 "../src/Widgets/DwellClickTimer.vala"
	tracker = _tmp3_;
#line 73 "../src/Widgets/DwellClickTimer.vala"
	coords = _tmp4_;
#line 74 "../src/Widgets/DwellClickTimer.vala"
	_tmp5_ = tracker;
#line 74 "../src/Widgets/DwellClickTimer.vala"
	meta_cursor_tracker_get_pointer (_tmp5_, &_tmp6_, NULL);
#line 74 "../src/Widgets/DwellClickTimer.vala"
	coords = _tmp6_;
#line 76 "../src/Widgets/DwellClickTimer.vala"
	_tmp7_ = coords;
#line 76 "../src/Widgets/DwellClickTimer.vala"
	_tmp8_ = clutter_actor_get_width ((ClutterActor*) self);
#line 76 "../src/Widgets/DwellClickTimer.vala"
	_tmp9_ = _tmp8_;
#line 76 "../src/Widgets/DwellClickTimer.vala"
	clutter_actor_set_x ((ClutterActor*) self, _tmp7_.x - (_tmp9_ / 2));
#line 77 "../src/Widgets/DwellClickTimer.vala"
	_tmp10_ = coords;
#line 77 "../src/Widgets/DwellClickTimer.vala"
	_tmp11_ = clutter_actor_get_width ((ClutterActor*) self);
#line 77 "../src/Widgets/DwellClickTimer.vala"
	_tmp12_ = _tmp11_;
#line 77 "../src/Widgets/DwellClickTimer.vala"
	clutter_actor_set_y ((ClutterActor*) self, _tmp10_.y - (_tmp12_ / 2));
#line 79 "../src/Widgets/DwellClickTimer.vala"
	_tmp13_ = self->priv->transition;
#line 79 "../src/Widgets/DwellClickTimer.vala"
	clutter_timeline_set_duration ((ClutterTimeline*) _tmp13_, timeout);
#line 80 "../src/Widgets/DwellClickTimer.vala"
	g_object_set ((ClutterActor*) self, "visible", TRUE, NULL);
#line 81 "../src/Widgets/DwellClickTimer.vala"
	_tmp14_ = self->priv->transition;
#line 81 "../src/Widgets/DwellClickTimer.vala"
	clutter_timeline_start ((ClutterTimeline*) _tmp14_);
#line 791 "DwellClickTimer.c"
}

static void
__gala_dwell_click_timer___lambda149__clutter_seat_ptr_a11y_timeout_started (ClutterSeat* _sender,
                                                                             ClutterInputDevice* device,
                                                                             ClutterPointerA11yTimeoutType timeout_type,
                                                                             guint delay,
                                                                             gpointer self)
{
#line 64 "../src/Widgets/DwellClickTimer.vala"
	_gala_dwell_click_timer___lambda149_ ((GalaDwellClickTimer*) self, device, timeout_type, delay);
#line 803 "DwellClickTimer.c"
}

static void
_gala_dwell_click_timer___lambda150_ (GalaDwellClickTimer* self,
                                      ClutterInputDevice* device,
                                      ClutterPointerA11yTimeoutType type,
                                      gboolean clicked)
{
	ClutterPropertyTransition* _tmp0_;
#line 84 "../src/Widgets/DwellClickTimer.vala"
	g_return_if_fail (device != NULL);
#line 85 "../src/Widgets/DwellClickTimer.vala"
	_tmp0_ = self->priv->transition;
#line 85 "../src/Widgets/DwellClickTimer.vala"
	clutter_timeline_stop ((ClutterTimeline*) _tmp0_);
#line 86 "../src/Widgets/DwellClickTimer.vala"
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
#line 821 "DwellClickTimer.c"
}

static void
__gala_dwell_click_timer___lambda150__clutter_seat_ptr_a11y_timeout_stopped (ClutterSeat* _sender,
                                                                             ClutterInputDevice* device,
                                                                             ClutterPointerA11yTimeoutType timeout_type,
                                                                             gboolean clicked,
                                                                             gpointer self)
{
#line 84 "../src/Widgets/DwellClickTimer.vala"
	_gala_dwell_click_timer___lambda150_ ((GalaDwellClickTimer*) self, device, timeout_type, clicked);
#line 833 "DwellClickTimer.c"
}

static GObject *
gala_dwell_click_timer_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaDwellClickTimer * self;
	ClutterBackend* backend = NULL;
	ClutterContext* _tmp0_;
	ClutterContext* _tmp1_;
	ClutterBackend* _tmp2_;
	ClutterBackend* _tmp3_;
	CoglContext* _tmp4_;
	CoglPipeline* _tmp5_;
	ClutterPropertyTransition* _tmp6_;
	ClutterPropertyTransition* _tmp7_;
	ClutterPropertyTransition* _tmp8_;
	ClutterPropertyTransition* _tmp9_;
	GValue _tmp10_ = {0};
	ClutterPropertyTransition* _tmp11_;
	GValue _tmp12_ = {0};
	ClutterPropertyTransition* _tmp13_;
	GSettings* _tmp14_;
	ClutterSeat* seat = NULL;
	ClutterBackend* _tmp15_;
	ClutterSeat* _tmp16_;
	ClutterSeat* _tmp17_;
	ClutterSeat* _tmp18_;
	ClutterSeat* _tmp19_;
	ClutterSeat* _tmp20_;
#line 37 "../src/Widgets/DwellClickTimer.vala"
	parent_class = G_OBJECT_CLASS (gala_dwell_click_timer_parent_class);
#line 37 "../src/Widgets/DwellClickTimer.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 37 "../src/Widgets/DwellClickTimer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_DWELL_CLICK_TIMER, GalaDwellClickTimer);
#line 38 "../src/Widgets/DwellClickTimer.vala"
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
#line 39 "../src/Widgets/DwellClickTimer.vala"
	clutter_actor_set_reactive ((ClutterActor*) self, FALSE);
#line 42 "../src/Widgets/DwellClickTimer.vala"
	_tmp0_ = clutter_actor_get_context ((ClutterActor*) self);
#line 42 "../src/Widgets/DwellClickTimer.vala"
	_tmp1_ = _tmp0_;
#line 42 "../src/Widgets/DwellClickTimer.vala"
	_tmp2_ = clutter_context_get_backend (_tmp1_);
#line 42 "../src/Widgets/DwellClickTimer.vala"
	backend = _tmp2_;
#line 47 "../src/Widgets/DwellClickTimer.vala"
	_tmp3_ = backend;
#line 47 "../src/Widgets/DwellClickTimer.vala"
	_tmp4_ = clutter_backend_get_cogl_context (_tmp3_);
#line 47 "../src/Widgets/DwellClickTimer.vala"
	_tmp5_ = cogl_pipeline_new (_tmp4_);
#line 47 "../src/Widgets/DwellClickTimer.vala"
	_g_object_unref0 (self->priv->pipeline);
#line 47 "../src/Widgets/DwellClickTimer.vala"
	self->priv->pipeline = _tmp5_;
#line 49 "../src/Widgets/DwellClickTimer.vala"
	_tmp6_ = (ClutterPropertyTransition*) clutter_property_transition_new ("angle");
#line 49 "../src/Widgets/DwellClickTimer.vala"
	_g_object_unref0 (self->priv->transition);
#line 49 "../src/Widgets/DwellClickTimer.vala"
	self->priv->transition = _tmp6_;
#line 50 "../src/Widgets/DwellClickTimer.vala"
	_tmp7_ = self->priv->transition;
#line 50 "../src/Widgets/DwellClickTimer.vala"
	clutter_timeline_set_progress_mode ((ClutterTimeline*) _tmp7_, CLUTTER_EASE_OUT_QUAD);
#line 51 "../src/Widgets/DwellClickTimer.vala"
	_tmp8_ = self->priv->transition;
#line 51 "../src/Widgets/DwellClickTimer.vala"
	clutter_transition_set_animatable ((ClutterTransition*) _tmp8_, (ClutterAnimatable*) self);
#line 52 "../src/Widgets/DwellClickTimer.vala"
	_tmp9_ = self->priv->transition;
#line 52 "../src/Widgets/DwellClickTimer.vala"
	g_value_init (&_tmp10_, G_TYPE_DOUBLE);
#line 52 "../src/Widgets/DwellClickTimer.vala"
	g_value_set_double (&_tmp10_, GALA_DWELL_CLICK_TIMER_START_ANGLE);
#line 52 "../src/Widgets/DwellClickTimer.vala"
	clutter_transition_set_from_value ((ClutterTransition*) _tmp9_, &_tmp10_);
#line 52 "../src/Widgets/DwellClickTimer.vala"
	G_IS_VALUE (&_tmp10_) ? (g_value_unset (&_tmp10_), NULL) : NULL;
#line 53 "../src/Widgets/DwellClickTimer.vala"
	_tmp11_ = self->priv->transition;
#line 53 "../src/Widgets/DwellClickTimer.vala"
	g_value_init (&_tmp12_, G_TYPE_DOUBLE);
#line 53 "../src/Widgets/DwellClickTimer.vala"
	g_value_set_double (&_tmp12_, GALA_DWELL_CLICK_TIMER_START_ANGLE + (2 * G_PI));
#line 53 "../src/Widgets/DwellClickTimer.vala"
	clutter_transition_set_to_value ((ClutterTransition*) _tmp11_, &_tmp12_);
#line 53 "../src/Widgets/DwellClickTimer.vala"
	G_IS_VALUE (&_tmp12_) ? (g_value_unset (&_tmp12_), NULL) : NULL;
#line 55 "../src/Widgets/DwellClickTimer.vala"
	_tmp13_ = self->priv->transition;
#line 55 "../src/Widgets/DwellClickTimer.vala"
	g_signal_connect_object ((ClutterTimeline*) _tmp13_, "new-frame", (GCallback) __gala_dwell_click_timer___lambda148__clutter_timeline_new_frame, self, 0);
#line 59 "../src/Widgets/DwellClickTimer.vala"
	_tmp14_ = g_settings_new ("org.gnome.desktop.interface");
#line 59 "../src/Widgets/DwellClickTimer.vala"
	_g_object_unref0 (self->priv->interface_settings);
#line 59 "../src/Widgets/DwellClickTimer.vala"
	self->priv->interface_settings = _tmp14_;
#line 61 "../src/Widgets/DwellClickTimer.vala"
	_tmp15_ = backend;
#line 61 "../src/Widgets/DwellClickTimer.vala"
	_tmp16_ = clutter_backend_get_default_seat (_tmp15_);
#line 61 "../src/Widgets/DwellClickTimer.vala"
	_tmp17_ = _g_object_ref0 (_tmp16_);
#line 61 "../src/Widgets/DwellClickTimer.vala"
	seat = _tmp17_;
#line 62 "../src/Widgets/DwellClickTimer.vala"
	_tmp18_ = seat;
#line 62 "../src/Widgets/DwellClickTimer.vala"
	clutter_seat_set_pointer_a11y_dwell_click_type (_tmp18_, CLUTTER_A11Y_DWELL_CLICK_TYPE_PRIMARY);
#line 64 "../src/Widgets/DwellClickTimer.vala"
	_tmp19_ = seat;
#line 64 "../src/Widgets/DwellClickTimer.vala"
	g_signal_connect_object (_tmp19_, "ptr-a11y-timeout-started", (GCallback) __gala_dwell_click_timer___lambda149__clutter_seat_ptr_a11y_timeout_started, self, 0);
#line 84 "../src/Widgets/DwellClickTimer.vala"
	_tmp20_ = seat;
#line 84 "../src/Widgets/DwellClickTimer.vala"
	g_signal_connect_object (_tmp20_, "ptr-a11y-timeout-stopped", (GCallback) __gala_dwell_click_timer___lambda150__clutter_seat_ptr_a11y_timeout_stopped, self, 0);
#line 37 "../src/Widgets/DwellClickTimer.vala"
	_g_object_unref0 (seat);
#line 37 "../src/Widgets/DwellClickTimer.vala"
	return obj;
#line 963 "DwellClickTimer.c"
}

static void
gala_dwell_click_timer_class_init (GalaDwellClickTimerClass * klass,
                                   gpointer klass_data)
{
#line 6 "../src/Widgets/DwellClickTimer.vala"
	gala_dwell_click_timer_parent_class = g_type_class_peek_parent (klass);
#line 6 "../src/Widgets/DwellClickTimer.vala"
	g_type_class_adjust_private_offset (klass, &GalaDwellClickTimer_private_offset);
#line 6 "../src/Widgets/DwellClickTimer.vala"
	((ClutterActorClass *) klass)->paint = (void (*) (ClutterActor*, ClutterPaintContext*)) gala_dwell_click_timer_real_paint;
#line 6 "../src/Widgets/DwellClickTimer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_dwell_click_timer_get_property;
#line 6 "../src/Widgets/DwellClickTimer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_dwell_click_timer_set_property;
#line 6 "../src/Widgets/DwellClickTimer.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_dwell_click_timer_constructor;
#line 6 "../src/Widgets/DwellClickTimer.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_dwell_click_timer_finalize;
#line 6 "../src/Widgets/DwellClickTimer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DWELL_CLICK_TIMER_DISPLAY_PROPERTY, gala_dwell_click_timer_properties[GALA_DWELL_CLICK_TIMER_DISPLAY_PROPERTY] = g_param_spec_object ("display", "display", "display", meta_display_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 6 "../src/Widgets/DwellClickTimer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DWELL_CLICK_TIMER_ANGLE_PROPERTY, gala_dwell_click_timer_properties[GALA_DWELL_CLICK_TIMER_ANGLE_PROPERTY] = g_param_spec_double ("angle", "angle", "angle", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 988 "DwellClickTimer.c"
}

static void
gala_dwell_click_timer_clutter_animatable_interface_init (ClutterAnimatableInterface * iface,
                                                          gpointer iface_data)
{
#line 6 "../src/Widgets/DwellClickTimer.vala"
	gala_dwell_click_timer_clutter_animatable_parent_iface = g_type_interface_peek_parent (iface);
#line 6 "../src/Widgets/DwellClickTimer.vala"
	iface->interpolate_value = (gboolean (*) (ClutterAnimatable*, const gchar*, ClutterInterval*, gdouble, GValue*)) gala_dwell_click_timer_real_interpolate_value;
#line 999 "DwellClickTimer.c"
}

static void
gala_dwell_click_timer_instance_init (GalaDwellClickTimer * self,
                                      gpointer klass)
{
#line 6 "../src/Widgets/DwellClickTimer.vala"
	self->priv = gala_dwell_click_timer_get_instance_private (self);
#line 19 "../src/Widgets/DwellClickTimer.vala"
	self->priv->scaling_factor = 1.0f;
#line 20 "../src/Widgets/DwellClickTimer.vala"
	self->priv->cursor_size = 24;
#line 1012 "DwellClickTimer.c"
}

static void
gala_dwell_click_timer_finalize (GObject * obj)
{
	GalaDwellClickTimer * self;
#line 6 "../src/Widgets/DwellClickTimer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_DWELL_CLICK_TIMER, GalaDwellClickTimer);
#line 22 "../src/Widgets/DwellClickTimer.vala"
	_g_object_unref0 (self->priv->pipeline);
#line 23 "../src/Widgets/DwellClickTimer.vala"
	_g_object_unref0 (self->priv->transition);
#line 24 "../src/Widgets/DwellClickTimer.vala"
	_cairo_pattern_destroy0 (self->priv->stroke_color);
#line 25 "../src/Widgets/DwellClickTimer.vala"
	_cairo_pattern_destroy0 (self->priv->fill_color);
#line 26 "../src/Widgets/DwellClickTimer.vala"
	_g_object_unref0 (self->priv->interface_settings);
#line 27 "../src/Widgets/DwellClickTimer.vala"
	_cairo_surface_destroy0 (self->priv->surface);
#line 29 "../src/Widgets/DwellClickTimer.vala"
	_g_object_unref0 (self->priv->_display);
#line 6 "../src/Widgets/DwellClickTimer.vala"
	G_OBJECT_CLASS (gala_dwell_click_timer_parent_class)->finalize (obj);
#line 1037 "DwellClickTimer.c"
}

 G_GNUC_NO_INLINE static GType
gala_dwell_click_timer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaDwellClickTimerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_dwell_click_timer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaDwellClickTimer), 0, (GInstanceInitFunc) gala_dwell_click_timer_instance_init, NULL };
	static const GInterfaceInfo clutter_animatable_info = { (GInterfaceInitFunc) gala_dwell_click_timer_clutter_animatable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gala_dwell_click_timer_type_id;
	gala_dwell_click_timer_type_id = g_type_register_static (clutter_actor_get_type (), "GalaDwellClickTimer", &g_define_type_info, 0);
	g_type_add_interface_static (gala_dwell_click_timer_type_id, clutter_animatable_get_type (), &clutter_animatable_info);
	GalaDwellClickTimer_private_offset = g_type_add_instance_private (gala_dwell_click_timer_type_id, sizeof (GalaDwellClickTimerPrivate));
	return gala_dwell_click_timer_type_id;
}

GType
gala_dwell_click_timer_get_type (void)
{
	static gsize gala_dwell_click_timer_type_id__once = 0;
	if (g_once_init_enter (&gala_dwell_click_timer_type_id__once)) {
		GType gala_dwell_click_timer_type_id;
		gala_dwell_click_timer_type_id = gala_dwell_click_timer_get_type_once ();
		g_once_init_leave (&gala_dwell_click_timer_type_id__once, gala_dwell_click_timer_type_id);
	}
	return gala_dwell_click_timer_type_id__once;
}

static void
_vala_gala_dwell_click_timer_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	GalaDwellClickTimer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_DWELL_CLICK_TIMER, GalaDwellClickTimer);
#line 6 "../src/Widgets/DwellClickTimer.vala"
	switch (property_id) {
#line 6 "../src/Widgets/DwellClickTimer.vala"
		case GALA_DWELL_CLICK_TIMER_DISPLAY_PROPERTY:
#line 6 "../src/Widgets/DwellClickTimer.vala"
		g_value_set_object (value, gala_dwell_click_timer_get_display (self));
#line 6 "../src/Widgets/DwellClickTimer.vala"
		break;
#line 6 "../src/Widgets/DwellClickTimer.vala"
		case GALA_DWELL_CLICK_TIMER_ANGLE_PROPERTY:
#line 6 "../src/Widgets/DwellClickTimer.vala"
		g_value_set_double (value, gala_dwell_click_timer_get_angle (self));
#line 6 "../src/Widgets/DwellClickTimer.vala"
		break;
#line 1086 "DwellClickTimer.c"
		default:
#line 6 "../src/Widgets/DwellClickTimer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../src/Widgets/DwellClickTimer.vala"
		break;
#line 1092 "DwellClickTimer.c"
	}
}

static void
_vala_gala_dwell_click_timer_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	GalaDwellClickTimer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_DWELL_CLICK_TIMER, GalaDwellClickTimer);
#line 6 "../src/Widgets/DwellClickTimer.vala"
	switch (property_id) {
#line 6 "../src/Widgets/DwellClickTimer.vala"
		case GALA_DWELL_CLICK_TIMER_DISPLAY_PROPERTY:
#line 6 "../src/Widgets/DwellClickTimer.vala"
		gala_dwell_click_timer_set_display (self, g_value_get_object (value));
#line 6 "../src/Widgets/DwellClickTimer.vala"
		break;
#line 6 "../src/Widgets/DwellClickTimer.vala"
		case GALA_DWELL_CLICK_TIMER_ANGLE_PROPERTY:
#line 6 "../src/Widgets/DwellClickTimer.vala"
		gala_dwell_click_timer_set_angle (self, g_value_get_double (value));
#line 6 "../src/Widgets/DwellClickTimer.vala"
		break;
#line 1118 "DwellClickTimer.c"
		default:
#line 6 "../src/Widgets/DwellClickTimer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../src/Widgets/DwellClickTimer.vala"
		break;
#line 1124 "DwellClickTimer.c"
	}
}

