/* PointerLocator.c generated by valac 0.56.18, the Vala compiler
 * generated from PointerLocator.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2020-2025 elementary, Inc. (https://elementary.io)
 */

#include <clutter/clutter.h>
#include <glib-object.h>
#include <meta/display.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <cogl/cogl.h>
#include <cairo-gobject.h>
#include "gala.h"
#include <gdk/gdk.h>
#include <meta/meta-cursor-tracker.h>
#include <graphene-gobject.h>
#include <string.h>

#define GALA_POINTER_LOCATOR_WIDTH_PX 300
#define GALA_POINTER_LOCATOR_HEIGHT_PX 300
#define GALA_POINTER_LOCATOR_ANIMATION_TIME_MS 300
#define GALA_POINTER_LOCATOR_BORDER_WIDTH_PX 1
#define GALA_POINTER_LOCATOR_BACKGROUND_OPACITY 0.7
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_POINTER_LOCATOR (gala_pointer_locator_get_type ())
#define GALA_POINTER_LOCATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_POINTER_LOCATOR, GalaPointerLocator))
#define GALA_POINTER_LOCATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_POINTER_LOCATOR, GalaPointerLocatorClass))
#define GALA_IS_POINTER_LOCATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_POINTER_LOCATOR))
#define GALA_IS_POINTER_LOCATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_POINTER_LOCATOR))
#define GALA_POINTER_LOCATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_POINTER_LOCATOR, GalaPointerLocatorClass))

typedef struct _GalaPointerLocator GalaPointerLocator;
typedef struct _GalaPointerLocatorClass GalaPointerLocatorClass;
typedef struct _GalaPointerLocatorPrivate GalaPointerLocatorPrivate;
enum  {
	GALA_POINTER_LOCATOR_0_PROPERTY,
	GALA_POINTER_LOCATOR_DISPLAY_PROPERTY,
	GALA_POINTER_LOCATOR_NUM_PROPERTIES
};
static GParamSpec* gala_pointer_locator_properties[GALA_POINTER_LOCATOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))

struct _GalaPointerLocator {
	ClutterActor parent_instance;
	GalaPointerLocatorPrivate * priv;
};

struct _GalaPointerLocatorClass {
	ClutterActorClass parent_class;
};

struct _GalaPointerLocatorPrivate {
	MetaDisplay* _display;
	gfloat scaling_factor;
	gint surface_width;
	gint surface_height;
	GSettings* settings;
	CoglPipeline* pipeline;
	cairo_surface_t* surface;
	cairo_pattern_t* stroke_color;
	cairo_pattern_t* fill_color;
};

static gint GalaPointerLocator_private_offset;
static gpointer gala_pointer_locator_parent_class = NULL;
static ClutterAnimatableInterface * gala_pointer_locator_clutter_animatable_parent_iface = NULL;

VALA_EXTERN GType gala_pointer_locator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaPointerLocator, g_object_unref)
VALA_EXTERN GalaPointerLocator* gala_pointer_locator_new (MetaDisplay* display);
VALA_EXTERN GalaPointerLocator* gala_pointer_locator_construct (GType object_type,
                                                    MetaDisplay* display);
static void gala_pointer_locator_update_surface (GalaPointerLocator* self,
                                          gfloat cur_scale);
static void gala_pointer_locator_real_paint (ClutterActor* base,
                                      ClutterPaintContext* context);
VALA_EXTERN void gala_pointer_locator_show_ripple (GalaPointerLocator* self);
static void __lambda92_ (GalaPointerLocator* self);
static void ___lambda92__clutter_timeline_stopped (ClutterTimeline* _sender,
                                            gboolean is_finished,
                                            gpointer self);
static void __lambda93_ (GalaPointerLocator* self);
static void ___lambda93__clutter_timeline_started (ClutterTimeline* _sender,
                                            gpointer self);
VALA_EXTERN MetaDisplay* gala_pointer_locator_get_display (GalaPointerLocator* self);
static void gala_pointer_locator_set_display (GalaPointerLocator* self,
                                       MetaDisplay* value);
static GObject * gala_pointer_locator_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void gala_pointer_locator_finalize (GObject * obj);
static GType gala_pointer_locator_get_type_once (void);
static void _vala_gala_pointer_locator_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_gala_pointer_locator_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
gala_pointer_locator_get_instance_private (GalaPointerLocator* self)
{
	return G_STRUCT_MEMBER_P (self, GalaPointerLocator_private_offset);
}

GalaPointerLocator*
gala_pointer_locator_construct (GType object_type,
                                MetaDisplay* display)
{
	GalaPointerLocator * self = NULL;
#line 27 "../src/Widgets/PointerLocator.vala"
	g_return_val_if_fail (display != NULL, NULL);
#line 28 "../src/Widgets/PointerLocator.vala"
	self = (GalaPointerLocator*) g_object_new (object_type, "display", display, NULL);
#line 27 "../src/Widgets/PointerLocator.vala"
	return self;
#line 145 "PointerLocator.c"
}

GalaPointerLocator*
gala_pointer_locator_new (MetaDisplay* display)
{
#line 27 "../src/Widgets/PointerLocator.vala"
	return gala_pointer_locator_construct (GALA_TYPE_POINTER_LOCATOR, display);
#line 153 "PointerLocator.c"
}

static void
gala_pointer_locator_update_surface (GalaPointerLocator* self,
                                     gfloat cur_scale)
{
	gboolean _tmp0_ = FALSE;
	cairo_surface_t* _tmp1_;
#line 49 "../src/Widgets/PointerLocator.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/Widgets/PointerLocator.vala"
	_tmp1_ = self->priv->surface;
#line 50 "../src/Widgets/PointerLocator.vala"
	if (_tmp1_ == NULL) {
#line 50 "../src/Widgets/PointerLocator.vala"
		_tmp0_ = TRUE;
#line 170 "PointerLocator.c"
	} else {
#line 50 "../src/Widgets/PointerLocator.vala"
		_tmp0_ = cur_scale != self->priv->scaling_factor;
#line 174 "PointerLocator.c"
	}
#line 50 "../src/Widgets/PointerLocator.vala"
	if (_tmp0_) {
#line 178 "PointerLocator.c"
		cairo_surface_t* _tmp2_;
#line 51 "../src/Widgets/PointerLocator.vala"
		self->priv->scaling_factor = cur_scale;
#line 52 "../src/Widgets/PointerLocator.vala"
		self->priv->surface_width = gala_utils_scale_to_int (GALA_POINTER_LOCATOR_WIDTH_PX, self->priv->scaling_factor);
#line 53 "../src/Widgets/PointerLocator.vala"
		self->priv->surface_height = gala_utils_scale_to_int (GALA_POINTER_LOCATOR_HEIGHT_PX, self->priv->scaling_factor);
#line 55 "../src/Widgets/PointerLocator.vala"
		_tmp2_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, self->priv->surface_width, self->priv->surface_height);
#line 55 "../src/Widgets/PointerLocator.vala"
		_cairo_surface_destroy0 (self->priv->surface);
#line 55 "../src/Widgets/PointerLocator.vala"
		self->priv->surface = _tmp2_;
#line 57 "../src/Widgets/PointerLocator.vala"
		clutter_actor_set_size ((ClutterActor*) self, (gfloat) self->priv->surface_width, (gfloat) self->priv->surface_height);
#line 194 "PointerLocator.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 90 "../src/Widgets/PointerLocator.vala"
	return self ? g_object_ref (self) : NULL;
#line 203 "PointerLocator.c"
}

static void
gala_pointer_locator_real_paint (ClutterActor* base,
                                 ClutterPaintContext* context)
{
	GalaPointerLocator * self;
	gint radius = 0;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp0_;
	cairo_t* _tmp1_;
	gint border_width = 0;
	cairo_pattern_t* _tmp2_;
	cairo_pattern_t* _tmp3_;
	CoglContext* cogl_context = NULL;
	CoglFramebuffer* _tmp4_;
	CoglContext* _tmp5_;
	CoglContext* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 61 "../src/Widgets/PointerLocator.vala"
	self = (GalaPointerLocator*) base;
#line 61 "../src/Widgets/PointerLocator.vala"
	g_return_if_fail (context != NULL);
#line 62 "../src/Widgets/PointerLocator.vala"
	radius = MIN (self->priv->surface_width / 2, self->priv->surface_height / 2);
#line 64 "../src/Widgets/PointerLocator.vala"
	_tmp0_ = self->priv->surface;
#line 64 "../src/Widgets/PointerLocator.vala"
	_tmp1_ = cairo_create (_tmp0_);
#line 64 "../src/Widgets/PointerLocator.vala"
	cr = _tmp1_;
#line 65 "../src/Widgets/PointerLocator.vala"
	border_width = gala_utils_scale_to_int (GALA_POINTER_LOCATOR_BORDER_WIDTH_PX, self->priv->scaling_factor);
#line 68 "../src/Widgets/PointerLocator.vala"
	cairo_save (cr);
#line 69 "../src/Widgets/PointerLocator.vala"
	cairo_set_source_rgba (cr, (gdouble) 0, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 70 "../src/Widgets/PointerLocator.vala"
	cairo_set_operator (cr, CAIRO_OPERATOR_SOURCE);
#line 71 "../src/Widgets/PointerLocator.vala"
	cairo_paint (cr);
#line 72 "../src/Widgets/PointerLocator.vala"
	cairo_restore (cr);
#line 74 "../src/Widgets/PointerLocator.vala"
	cairo_set_line_cap (cr, CAIRO_LINE_CAP_ROUND);
#line 75 "../src/Widgets/PointerLocator.vala"
	cairo_set_line_join (cr, CAIRO_LINE_JOIN_ROUND);
#line 76 "../src/Widgets/PointerLocator.vala"
	cairo_translate (cr, (gdouble) (self->priv->surface_width / 2), (gdouble) (self->priv->surface_height / 2));
#line 78 "../src/Widgets/PointerLocator.vala"
	cairo_move_to (cr, (gdouble) (radius - GALA_POINTER_LOCATOR_BORDER_WIDTH_PX), (gdouble) 0);
#line 79 "../src/Widgets/PointerLocator.vala"
	cairo_arc (cr, (gdouble) 0, (gdouble) 0, (gdouble) (radius - border_width), (gdouble) 0, 2 * G_PI);
#line 80 "../src/Widgets/PointerLocator.vala"
	cairo_close_path (cr);
#line 82 "../src/Widgets/PointerLocator.vala"
	cairo_set_line_width (cr, (gdouble) 0);
#line 83 "../src/Widgets/PointerLocator.vala"
	_tmp2_ = self->priv->fill_color;
#line 83 "../src/Widgets/PointerLocator.vala"
	cairo_set_source (cr, _tmp2_);
#line 84 "../src/Widgets/PointerLocator.vala"
	cairo_fill_preserve (cr);
#line 86 "../src/Widgets/PointerLocator.vala"
	cairo_set_line_width (cr, (gdouble) border_width);
#line 87 "../src/Widgets/PointerLocator.vala"
	_tmp3_ = self->priv->stroke_color;
#line 87 "../src/Widgets/PointerLocator.vala"
	cairo_set_source (cr, _tmp3_);
#line 88 "../src/Widgets/PointerLocator.vala"
	cairo_stroke (cr);
#line 90 "../src/Widgets/PointerLocator.vala"
	_tmp4_ = clutter_paint_context_get_framebuffer (context);
#line 90 "../src/Widgets/PointerLocator.vala"
	_tmp5_ = cogl_framebuffer_get_context (_tmp4_);
#line 90 "../src/Widgets/PointerLocator.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 90 "../src/Widgets/PointerLocator.vala"
	cogl_context = _tmp6_;
#line 283 "PointerLocator.c"
	{
		CoglTexture2D* texture = NULL;
		cairo_surface_t* _tmp7_;
		cairo_surface_t* _tmp8_;
		guchar* _tmp9_;
		CoglTexture2D* _tmp10_;
		CoglPipeline* _tmp11_;
		CoglFramebuffer* _tmp12_;
		CoglPipeline* _tmp13_;
#line 93 "../src/Widgets/PointerLocator.vala"
		_tmp7_ = self->priv->surface;
#line 93 "../src/Widgets/PointerLocator.vala"
		_tmp8_ = self->priv->surface;
#line 93 "../src/Widgets/PointerLocator.vala"
		_tmp9_ = cairo_image_surface_get_data (_tmp8_);
#line 93 "../src/Widgets/PointerLocator.vala"
		_tmp10_ = (CoglTexture2D*) cogl_texture_2d_new_from_data (cogl_context, self->priv->surface_width, self->priv->surface_height, COGL_PIXEL_FORMAT_BGRA_8888_PRE, cairo_image_surface_get_stride (_tmp7_), _tmp9_, &_inner_error0_);
#line 93 "../src/Widgets/PointerLocator.vala"
		texture = _tmp10_;
#line 93 "../src/Widgets/PointerLocator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 305 "PointerLocator.c"
			goto __catch0_g_error;
		}
#line 96 "../src/Widgets/PointerLocator.vala"
		_tmp11_ = self->priv->pipeline;
#line 96 "../src/Widgets/PointerLocator.vala"
		cogl_pipeline_set_layer_texture (_tmp11_, 0, (CoglTexture*) texture);
#line 98 "../src/Widgets/PointerLocator.vala"
		_tmp12_ = clutter_paint_context_get_framebuffer (context);
#line 98 "../src/Widgets/PointerLocator.vala"
		_tmp13_ = self->priv->pipeline;
#line 98 "../src/Widgets/PointerLocator.vala"
		cogl_framebuffer_draw_rectangle (_tmp12_, _tmp13_, (gfloat) 0, (gfloat) 0, (gfloat) self->priv->surface_width, (gfloat) self->priv->surface_height);
#line 92 "../src/Widgets/PointerLocator.vala"
		_g_object_unref0 (texture);
#line 320 "PointerLocator.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 92 "../src/Widgets/PointerLocator.vala"
		g_clear_error (&_inner_error0_);
#line 327 "PointerLocator.c"
	}
	__finally0:
#line 92 "../src/Widgets/PointerLocator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 92 "../src/Widgets/PointerLocator.vala"
		_g_object_unref0 (cogl_context);
#line 92 "../src/Widgets/PointerLocator.vala"
		_cairo_destroy0 (cr);
#line 92 "../src/Widgets/PointerLocator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 92 "../src/Widgets/PointerLocator.vala"
		g_clear_error (&_inner_error0_);
#line 92 "../src/Widgets/PointerLocator.vala"
		return;
#line 342 "PointerLocator.c"
	}
#line 101 "../src/Widgets/PointerLocator.vala"
	CLUTTER_ACTOR_CLASS (gala_pointer_locator_parent_class)->paint (G_TYPE_CHECK_INSTANCE_CAST (self, clutter_actor_get_type (), ClutterActor), context);
#line 61 "../src/Widgets/PointerLocator.vala"
	_g_object_unref0 (cogl_context);
#line 61 "../src/Widgets/PointerLocator.vala"
	_cairo_destroy0 (cr);
#line 350 "PointerLocator.c"
}

static void
__lambda92_ (GalaPointerLocator* self)
{
#line 130 "../src/Widgets/PointerLocator.vala"
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
#line 358 "PointerLocator.c"
}

static void
___lambda92__clutter_timeline_stopped (ClutterTimeline* _sender,
                                       gboolean is_finished,
                                       gpointer self)
{
#line 130 "../src/Widgets/PointerLocator.vala"
	__lambda92_ ((GalaPointerLocator*) self);
#line 368 "PointerLocator.c"
}

static void
__lambda93_ (GalaPointerLocator* self)
{
#line 131 "../src/Widgets/PointerLocator.vala"
	g_object_set ((ClutterActor*) self, "visible", TRUE, NULL);
#line 376 "PointerLocator.c"
}

static void
___lambda93__clutter_timeline_started (ClutterTimeline* _sender,
                                       gpointer self)
{
#line 131 "../src/Widgets/PointerLocator.vala"
	__lambda93_ ((GalaPointerLocator*) self);
#line 385 "PointerLocator.c"
}

void
gala_pointer_locator_show_ripple (GalaPointerLocator* self)
{
	GSettings* _tmp0_;
	ClutterTransition* old_transition = NULL;
	ClutterTransition* _tmp1_;
	ClutterTransition* _tmp2_;
	ClutterTransitionGroup* transition = NULL;
	ClutterTransitionGroup* _tmp4_;
	ClutterTransitionGroup* _tmp5_;
	ClutterPropertyTransition* transition_x = NULL;
	ClutterPropertyTransition* _tmp6_;
	ClutterPropertyTransition* transition_y = NULL;
	ClutterPropertyTransition* _tmp7_;
	GValue start_val = {0};
	GValue _tmp8_ = {0};
	GValue stop_val = {0};
	GValue _tmp9_ = {0};
	ClutterPropertyTransition* _tmp10_;
	GValue _tmp11_;
	ClutterPropertyTransition* _tmp12_;
	GValue _tmp13_;
	ClutterPropertyTransition* _tmp14_;
	GValue _tmp15_;
	ClutterPropertyTransition* _tmp16_;
	GValue _tmp17_;
	ClutterTransitionGroup* _tmp18_;
	ClutterTransitionGroup* _tmp19_;
	ClutterTransitionGroup* _tmp20_;
	ClutterPropertyTransition* _tmp21_;
	ClutterTransitionGroup* _tmp22_;
	ClutterPropertyTransition* _tmp23_;
	ClutterTransitionGroup* _tmp24_;
	ClutterTransitionGroup* _tmp25_;
	ClutterTransitionGroup* _tmp26_;
	GdkRGBA rgba = {0};
	GalaDrawingStyleManager* _tmp27_;
	GalaDrawingStyleManager* _tmp28_;
	GdkRGBA _tmp29_ = {0};
	GdkRGBA _tmp30_;
	GdkRGBA _tmp31_;
	GdkRGBA _tmp32_;
	GdkRGBA _tmp33_;
	GdkRGBA _tmp34_;
	cairo_pattern_t* _tmp35_;
	GdkRGBA _tmp36_;
	GdkRGBA _tmp37_;
	GdkRGBA _tmp38_;
	cairo_pattern_t* _tmp39_;
	MetaCursorTracker* tracker = NULL;
	MetaDisplay* _tmp40_;
	MetaCursorTracker* _tmp41_;
	graphene_point_t coords = {0};
	graphene_point_t _tmp42_ = {0};
	MetaCursorTracker* _tmp43_;
	graphene_point_t _tmp44_ = {0};
	MetaDisplay* _tmp45_;
	MetaDisplay* _tmp46_;
	graphene_point_t _tmp47_;
	gfloat _tmp48_;
	gfloat _tmp49_;
	graphene_point_t _tmp50_;
	gfloat _tmp51_;
	gfloat _tmp52_;
	ClutterTransitionGroup* _tmp53_;
#line 104 "../src/Widgets/PointerLocator.vala"
	g_return_if_fail (self != NULL);
#line 105 "../src/Widgets/PointerLocator.vala"
	_tmp0_ = self->priv->settings;
#line 105 "../src/Widgets/PointerLocator.vala"
	if (!g_settings_get_boolean (_tmp0_, "locate-pointer")) {
#line 106 "../src/Widgets/PointerLocator.vala"
		return;
#line 461 "PointerLocator.c"
	}
#line 109 "../src/Widgets/PointerLocator.vala"
	_tmp1_ = clutter_actor_get_transition ((ClutterActor*) self, "circle");
#line 109 "../src/Widgets/PointerLocator.vala"
	old_transition = _tmp1_;
#line 110 "../src/Widgets/PointerLocator.vala"
	_tmp2_ = old_transition;
#line 110 "../src/Widgets/PointerLocator.vala"
	if (_tmp2_ != NULL) {
#line 471 "PointerLocator.c"
		ClutterTransition* _tmp3_;
#line 111 "../src/Widgets/PointerLocator.vala"
		_tmp3_ = old_transition;
#line 111 "../src/Widgets/PointerLocator.vala"
		clutter_timeline_stop ((ClutterTimeline*) _tmp3_);
#line 477 "PointerLocator.c"
	}
#line 114 "../src/Widgets/PointerLocator.vala"
	_tmp4_ = (ClutterTransitionGroup*) clutter_transition_group_new ();
#line 114 "../src/Widgets/PointerLocator.vala"
	transition = _tmp4_;
#line 115 "../src/Widgets/PointerLocator.vala"
	_tmp5_ = transition;
#line 115 "../src/Widgets/PointerLocator.vala"
	clutter_transition_set_remove_on_complete ((ClutterTransition*) _tmp5_, TRUE);
#line 116 "../src/Widgets/PointerLocator.vala"
	_tmp6_ = (ClutterPropertyTransition*) clutter_property_transition_new ("scale-x");
#line 116 "../src/Widgets/PointerLocator.vala"
	transition_x = _tmp6_;
#line 117 "../src/Widgets/PointerLocator.vala"
	_tmp7_ = (ClutterPropertyTransition*) clutter_property_transition_new ("scale-y");
#line 117 "../src/Widgets/PointerLocator.vala"
	transition_y = _tmp7_;
#line 118 "../src/Widgets/PointerLocator.vala"
	g_value_init (&_tmp8_, G_TYPE_DOUBLE);
#line 118 "../src/Widgets/PointerLocator.vala"
	start_val = _tmp8_;
#line 119 "../src/Widgets/PointerLocator.vala"
	g_value_set_double (&start_val, (gdouble) 1);
#line 120 "../src/Widgets/PointerLocator.vala"
	g_value_init (&_tmp9_, G_TYPE_DOUBLE);
#line 120 "../src/Widgets/PointerLocator.vala"
	stop_val = _tmp9_;
#line 121 "../src/Widgets/PointerLocator.vala"
	g_value_set_double (&stop_val, (gdouble) 0);
#line 122 "../src/Widgets/PointerLocator.vala"
	_tmp10_ = transition_x;
#line 122 "../src/Widgets/PointerLocator.vala"
	_tmp11_ = start_val;
#line 122 "../src/Widgets/PointerLocator.vala"
	clutter_transition_set_from_value ((ClutterTransition*) _tmp10_, &_tmp11_);
#line 123 "../src/Widgets/PointerLocator.vala"
	_tmp12_ = transition_y;
#line 123 "../src/Widgets/PointerLocator.vala"
	_tmp13_ = start_val;
#line 123 "../src/Widgets/PointerLocator.vala"
	clutter_transition_set_from_value ((ClutterTransition*) _tmp12_, &_tmp13_);
#line 124 "../src/Widgets/PointerLocator.vala"
	_tmp14_ = transition_x;
#line 124 "../src/Widgets/PointerLocator.vala"
	_tmp15_ = stop_val;
#line 124 "../src/Widgets/PointerLocator.vala"
	clutter_transition_set_to_value ((ClutterTransition*) _tmp14_, &_tmp15_);
#line 125 "../src/Widgets/PointerLocator.vala"
	_tmp16_ = transition_y;
#line 125 "../src/Widgets/PointerLocator.vala"
	_tmp17_ = stop_val;
#line 125 "../src/Widgets/PointerLocator.vala"
	clutter_transition_set_to_value ((ClutterTransition*) _tmp16_, &_tmp17_);
#line 126 "../src/Widgets/PointerLocator.vala"
	_tmp18_ = transition;
#line 126 "../src/Widgets/PointerLocator.vala"
	clutter_timeline_set_progress_mode ((ClutterTimeline*) _tmp18_, CLUTTER_EASE_OUT_QUAD);
#line 127 "../src/Widgets/PointerLocator.vala"
	_tmp19_ = transition;
#line 127 "../src/Widgets/PointerLocator.vala"
	clutter_timeline_set_duration ((ClutterTimeline*) _tmp19_, (guint) GALA_POINTER_LOCATOR_ANIMATION_TIME_MS);
#line 128 "../src/Widgets/PointerLocator.vala"
	_tmp20_ = transition;
#line 128 "../src/Widgets/PointerLocator.vala"
	_tmp21_ = transition_x;
#line 128 "../src/Widgets/PointerLocator.vala"
	clutter_transition_group_add_transition (_tmp20_, (ClutterTransition*) _tmp21_);
#line 129 "../src/Widgets/PointerLocator.vala"
	_tmp22_ = transition;
#line 129 "../src/Widgets/PointerLocator.vala"
	_tmp23_ = transition_y;
#line 129 "../src/Widgets/PointerLocator.vala"
	clutter_transition_group_add_transition (_tmp22_, (ClutterTransition*) _tmp23_);
#line 130 "../src/Widgets/PointerLocator.vala"
	_tmp24_ = transition;
#line 130 "../src/Widgets/PointerLocator.vala"
	g_signal_connect_object ((ClutterTimeline*) _tmp24_, "stopped", (GCallback) ___lambda92__clutter_timeline_stopped, self, 0);
#line 131 "../src/Widgets/PointerLocator.vala"
	_tmp25_ = transition;
#line 131 "../src/Widgets/PointerLocator.vala"
	g_signal_connect_object ((ClutterTimeline*) _tmp25_, "started", (GCallback) ___lambda93__clutter_timeline_started, self, 0);
#line 132 "../src/Widgets/PointerLocator.vala"
	_tmp26_ = transition;
#line 132 "../src/Widgets/PointerLocator.vala"
	clutter_actor_add_transition ((ClutterActor*) self, "circle", (ClutterTransition*) _tmp26_);
#line 134 "../src/Widgets/PointerLocator.vala"
	_tmp27_ = gala_drawing_style_manager_get_instance ();
#line 134 "../src/Widgets/PointerLocator.vala"
	_tmp28_ = _tmp27_;
#line 134 "../src/Widgets/PointerLocator.vala"
	gala_drawing_style_manager_get_theme_accent_color (_tmp28_, &_tmp29_);
#line 134 "../src/Widgets/PointerLocator.vala"
	_tmp30_ = _tmp29_;
#line 134 "../src/Widgets/PointerLocator.vala"
	_tmp31_ = _tmp30_;
#line 134 "../src/Widgets/PointerLocator.vala"
	_g_object_unref0 (_tmp28_);
#line 134 "../src/Widgets/PointerLocator.vala"
	rgba = _tmp31_;
#line 137 "../src/Widgets/PointerLocator.vala"
	_tmp32_ = rgba;
#line 137 "../src/Widgets/PointerLocator.vala"
	_tmp33_ = rgba;
#line 137 "../src/Widgets/PointerLocator.vala"
	_tmp34_ = rgba;
#line 137 "../src/Widgets/PointerLocator.vala"
	_tmp35_ = cairo_pattern_create_rgb (_tmp32_.red, _tmp33_.green, _tmp34_.blue);
#line 137 "../src/Widgets/PointerLocator.vala"
	_cairo_pattern_destroy0 (self->priv->stroke_color);
#line 137 "../src/Widgets/PointerLocator.vala"
	self->priv->stroke_color = _tmp35_;
#line 138 "../src/Widgets/PointerLocator.vala"
	_tmp36_ = rgba;
#line 138 "../src/Widgets/PointerLocator.vala"
	_tmp37_ = rgba;
#line 138 "../src/Widgets/PointerLocator.vala"
	_tmp38_ = rgba;
#line 138 "../src/Widgets/PointerLocator.vala"
	_tmp39_ = cairo_pattern_create_rgba (_tmp36_.red, _tmp37_.green, _tmp38_.blue, GALA_POINTER_LOCATOR_BACKGROUND_OPACITY);
#line 138 "../src/Widgets/PointerLocator.vala"
	_cairo_pattern_destroy0 (self->priv->fill_color);
#line 138 "../src/Widgets/PointerLocator.vala"
	self->priv->fill_color = _tmp39_;
#line 143 "../src/Widgets/PointerLocator.vala"
	_tmp40_ = self->priv->_display;
#line 143 "../src/Widgets/PointerLocator.vala"
	_tmp41_ = meta_cursor_tracker_get_for_display (_tmp40_);
#line 143 "../src/Widgets/PointerLocator.vala"
	tracker = _tmp41_;
#line 145 "../src/Widgets/PointerLocator.vala"
	coords = _tmp42_;
#line 146 "../src/Widgets/PointerLocator.vala"
	_tmp43_ = tracker;
#line 146 "../src/Widgets/PointerLocator.vala"
	meta_cursor_tracker_get_pointer (_tmp43_, &_tmp44_, NULL);
#line 146 "../src/Widgets/PointerLocator.vala"
	coords = _tmp44_;
#line 148 "../src/Widgets/PointerLocator.vala"
	_tmp45_ = self->priv->_display;
#line 148 "../src/Widgets/PointerLocator.vala"
	_tmp46_ = self->priv->_display;
#line 148 "../src/Widgets/PointerLocator.vala"
	gala_pointer_locator_update_surface (self, meta_display_get_monitor_scale (_tmp45_, meta_display_get_current_monitor (_tmp46_)));
#line 150 "../src/Widgets/PointerLocator.vala"
	_tmp47_ = coords;
#line 150 "../src/Widgets/PointerLocator.vala"
	_tmp48_ = clutter_actor_get_width ((ClutterActor*) self);
#line 150 "../src/Widgets/PointerLocator.vala"
	_tmp49_ = _tmp48_;
#line 150 "../src/Widgets/PointerLocator.vala"
	clutter_actor_set_x ((ClutterActor*) self, _tmp47_.x - (_tmp49_ / 2));
#line 151 "../src/Widgets/PointerLocator.vala"
	_tmp50_ = coords;
#line 151 "../src/Widgets/PointerLocator.vala"
	_tmp51_ = clutter_actor_get_width ((ClutterActor*) self);
#line 151 "../src/Widgets/PointerLocator.vala"
	_tmp52_ = _tmp51_;
#line 151 "../src/Widgets/PointerLocator.vala"
	clutter_actor_set_y ((ClutterActor*) self, _tmp50_.y - (_tmp52_ / 2));
#line 153 "../src/Widgets/PointerLocator.vala"
	_tmp53_ = transition;
#line 153 "../src/Widgets/PointerLocator.vala"
	clutter_timeline_start ((ClutterTimeline*) _tmp53_);
#line 104 "../src/Widgets/PointerLocator.vala"
	G_IS_VALUE (&stop_val) ? (g_value_unset (&stop_val), NULL) : NULL;
#line 104 "../src/Widgets/PointerLocator.vala"
	G_IS_VALUE (&start_val) ? (g_value_unset (&start_val), NULL) : NULL;
#line 104 "../src/Widgets/PointerLocator.vala"
	_g_object_unref0 (transition_y);
#line 104 "../src/Widgets/PointerLocator.vala"
	_g_object_unref0 (transition_x);
#line 104 "../src/Widgets/PointerLocator.vala"
	_g_object_unref0 (transition);
#line 651 "PointerLocator.c"
}

MetaDisplay*
gala_pointer_locator_get_display (GalaPointerLocator* self)
{
	MetaDisplay* result;
	MetaDisplay* _tmp0_;
#line 15 "../src/Widgets/PointerLocator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 15 "../src/Widgets/PointerLocator.vala"
	_tmp0_ = self->priv->_display;
#line 15 "../src/Widgets/PointerLocator.vala"
	result = _tmp0_;
#line 15 "../src/Widgets/PointerLocator.vala"
	return result;
#line 667 "PointerLocator.c"
}

static void
gala_pointer_locator_set_display (GalaPointerLocator* self,
                                  MetaDisplay* value)
{
	MetaDisplay* old_value;
#line 15 "../src/Widgets/PointerLocator.vala"
	g_return_if_fail (self != NULL);
#line 15 "../src/Widgets/PointerLocator.vala"
	old_value = gala_pointer_locator_get_display (self);
#line 15 "../src/Widgets/PointerLocator.vala"
	if (old_value != value) {
#line 681 "PointerLocator.c"
		MetaDisplay* _tmp0_;
#line 15 "../src/Widgets/PointerLocator.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 15 "../src/Widgets/PointerLocator.vala"
		_g_object_unref0 (self->priv->_display);
#line 15 "../src/Widgets/PointerLocator.vala"
		self->priv->_display = _tmp0_;
#line 15 "../src/Widgets/PointerLocator.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_pointer_locator_properties[GALA_POINTER_LOCATOR_DISPLAY_PROPERTY]);
#line 691 "PointerLocator.c"
	}
}

static GObject *
gala_pointer_locator_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaPointerLocator * self;
	GSettings* _tmp0_;
	CoglContext* ctx = NULL;
	ClutterContext* _tmp1_;
	ClutterContext* _tmp2_;
	ClutterBackend* _tmp3_;
	CoglContext* _tmp4_;
	CoglContext* _tmp5_;
	CoglPipeline* _tmp6_;
	graphene_point_t pivot = {0};
	graphene_point_t _tmp7_;
#line 31 "../src/Widgets/PointerLocator.vala"
	parent_class = G_OBJECT_CLASS (gala_pointer_locator_parent_class);
#line 31 "../src/Widgets/PointerLocator.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 31 "../src/Widgets/PointerLocator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_POINTER_LOCATOR, GalaPointerLocator);
#line 32 "../src/Widgets/PointerLocator.vala"
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
#line 33 "../src/Widgets/PointerLocator.vala"
	clutter_actor_set_reactive ((ClutterActor*) self, FALSE);
#line 35 "../src/Widgets/PointerLocator.vala"
	_tmp0_ = g_settings_new ("org.gnome.desktop.interface");
#line 35 "../src/Widgets/PointerLocator.vala"
	_g_object_unref0 (self->priv->settings);
#line 35 "../src/Widgets/PointerLocator.vala"
	self->priv->settings = _tmp0_;
#line 38 "../src/Widgets/PointerLocator.vala"
	_tmp1_ = clutter_actor_get_context ((ClutterActor*) self);
#line 38 "../src/Widgets/PointerLocator.vala"
	_tmp2_ = _tmp1_;
#line 38 "../src/Widgets/PointerLocator.vala"
	_tmp3_ = clutter_context_get_backend (_tmp2_);
#line 38 "../src/Widgets/PointerLocator.vala"
	_tmp4_ = clutter_backend_get_cogl_context (_tmp3_);
#line 38 "../src/Widgets/PointerLocator.vala"
	ctx = _tmp4_;
#line 42 "../src/Widgets/PointerLocator.vala"
	_tmp5_ = ctx;
#line 42 "../src/Widgets/PointerLocator.vala"
	_tmp6_ = cogl_pipeline_new (_tmp5_);
#line 42 "../src/Widgets/PointerLocator.vala"
	_g_object_unref0 (self->priv->pipeline);
#line 42 "../src/Widgets/PointerLocator.vala"
	self->priv->pipeline = _tmp6_;
#line 44 "../src/Widgets/PointerLocator.vala"
	memset (&pivot, 0, sizeof (graphene_point_t));
#line 45 "../src/Widgets/PointerLocator.vala"
	graphene_point_init (&pivot, 0.5f, 0.5f);
#line 46 "../src/Widgets/PointerLocator.vala"
	_tmp7_ = pivot;
#line 46 "../src/Widgets/PointerLocator.vala"
	g_object_set ((ClutterActor*) self, "pivot-point", &_tmp7_, NULL);
#line 31 "../src/Widgets/PointerLocator.vala"
	return obj;
#line 757 "PointerLocator.c"
}

static void
gala_pointer_locator_class_init (GalaPointerLocatorClass * klass,
                                 gpointer klass_data)
{
#line 6 "../src/Widgets/PointerLocator.vala"
	gala_pointer_locator_parent_class = g_type_class_peek_parent (klass);
#line 6 "../src/Widgets/PointerLocator.vala"
	g_type_class_adjust_private_offset (klass, &GalaPointerLocator_private_offset);
#line 6 "../src/Widgets/PointerLocator.vala"
	((ClutterActorClass *) klass)->paint = (void (*) (ClutterActor*, ClutterPaintContext*)) gala_pointer_locator_real_paint;
#line 6 "../src/Widgets/PointerLocator.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_pointer_locator_get_property;
#line 6 "../src/Widgets/PointerLocator.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_pointer_locator_set_property;
#line 6 "../src/Widgets/PointerLocator.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_pointer_locator_constructor;
#line 6 "../src/Widgets/PointerLocator.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_pointer_locator_finalize;
#line 6 "../src/Widgets/PointerLocator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_POINTER_LOCATOR_DISPLAY_PROPERTY, gala_pointer_locator_properties[GALA_POINTER_LOCATOR_DISPLAY_PROPERTY] = g_param_spec_object ("display", "display", "display", meta_display_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 780 "PointerLocator.c"
}

static void
gala_pointer_locator_clutter_animatable_interface_init (ClutterAnimatableInterface * iface,
                                                        gpointer iface_data)
{
#line 6 "../src/Widgets/PointerLocator.vala"
	gala_pointer_locator_clutter_animatable_parent_iface = g_type_interface_peek_parent (iface);
#line 789 "PointerLocator.c"
}

static void
gala_pointer_locator_instance_init (GalaPointerLocator * self,
                                    gpointer klass)
{
#line 6 "../src/Widgets/PointerLocator.vala"
	self->priv = gala_pointer_locator_get_instance_private (self);
#line 17 "../src/Widgets/PointerLocator.vala"
	self->priv->scaling_factor = 1.0f;
#line 18 "../src/Widgets/PointerLocator.vala"
	self->priv->surface_width = GALA_POINTER_LOCATOR_WIDTH_PX;
#line 19 "../src/Widgets/PointerLocator.vala"
	self->priv->surface_height = GALA_POINTER_LOCATOR_HEIGHT_PX;
#line 804 "PointerLocator.c"
}

static void
gala_pointer_locator_finalize (GObject * obj)
{
	GalaPointerLocator * self;
#line 6 "../src/Widgets/PointerLocator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_POINTER_LOCATOR, GalaPointerLocator);
#line 15 "../src/Widgets/PointerLocator.vala"
	_g_object_unref0 (self->priv->_display);
#line 21 "../src/Widgets/PointerLocator.vala"
	_g_object_unref0 (self->priv->settings);
#line 22 "../src/Widgets/PointerLocator.vala"
	_g_object_unref0 (self->priv->pipeline);
#line 23 "../src/Widgets/PointerLocator.vala"
	_cairo_surface_destroy0 (self->priv->surface);
#line 24 "../src/Widgets/PointerLocator.vala"
	_cairo_pattern_destroy0 (self->priv->stroke_color);
#line 25 "../src/Widgets/PointerLocator.vala"
	_cairo_pattern_destroy0 (self->priv->fill_color);
#line 6 "../src/Widgets/PointerLocator.vala"
	G_OBJECT_CLASS (gala_pointer_locator_parent_class)->finalize (obj);
#line 827 "PointerLocator.c"
}

 G_GNUC_NO_INLINE static GType
gala_pointer_locator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaPointerLocatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_pointer_locator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaPointerLocator), 0, (GInstanceInitFunc) gala_pointer_locator_instance_init, NULL };
	static const GInterfaceInfo clutter_animatable_info = { (GInterfaceInitFunc) gala_pointer_locator_clutter_animatable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gala_pointer_locator_type_id;
	gala_pointer_locator_type_id = g_type_register_static (clutter_actor_get_type (), "GalaPointerLocator", &g_define_type_info, 0);
	g_type_add_interface_static (gala_pointer_locator_type_id, clutter_animatable_get_type (), &clutter_animatable_info);
	GalaPointerLocator_private_offset = g_type_add_instance_private (gala_pointer_locator_type_id, sizeof (GalaPointerLocatorPrivate));
	return gala_pointer_locator_type_id;
}

GType
gala_pointer_locator_get_type (void)
{
	static gsize gala_pointer_locator_type_id__once = 0;
	if (g_once_init_enter (&gala_pointer_locator_type_id__once)) {
		GType gala_pointer_locator_type_id;
		gala_pointer_locator_type_id = gala_pointer_locator_get_type_once ();
		g_once_init_leave (&gala_pointer_locator_type_id__once, gala_pointer_locator_type_id);
	}
	return gala_pointer_locator_type_id__once;
}

static void
_vala_gala_pointer_locator_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	GalaPointerLocator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_POINTER_LOCATOR, GalaPointerLocator);
#line 6 "../src/Widgets/PointerLocator.vala"
	switch (property_id) {
#line 6 "../src/Widgets/PointerLocator.vala"
		case GALA_POINTER_LOCATOR_DISPLAY_PROPERTY:
#line 6 "../src/Widgets/PointerLocator.vala"
		g_value_set_object (value, gala_pointer_locator_get_display (self));
#line 6 "../src/Widgets/PointerLocator.vala"
		break;
#line 870 "PointerLocator.c"
		default:
#line 6 "../src/Widgets/PointerLocator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../src/Widgets/PointerLocator.vala"
		break;
#line 876 "PointerLocator.c"
	}
}

static void
_vala_gala_pointer_locator_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	GalaPointerLocator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_POINTER_LOCATOR, GalaPointerLocator);
#line 6 "../src/Widgets/PointerLocator.vala"
	switch (property_id) {
#line 6 "../src/Widgets/PointerLocator.vala"
		case GALA_POINTER_LOCATOR_DISPLAY_PROPERTY:
#line 6 "../src/Widgets/PointerLocator.vala"
		gala_pointer_locator_set_display (self, g_value_get_object (value));
#line 6 "../src/Widgets/PointerLocator.vala"
		break;
#line 896 "PointerLocator.c"
		default:
#line 6 "../src/Widgets/PointerLocator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../src/Widgets/PointerLocator.vala"
		break;
#line 902 "PointerLocator.c"
	}
}

