/* WindowSwitcher.c generated by valac 0.56.18, the Vala compiler
 * generated from WindowSwitcher.vala, do not modify */

/*
 * Copyright 2021 Aral Balkan <mail@ar.al>
 * Copyright 2020 Mark Story <mark@mark-story.com>
 * Copyright 2017 Popye <sailor3101@gmail.com>
 * Copyright 2014 Tom Beckmann
 * Copyright 2023 elementary, Inc. <https://elementary.io>
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include "gala.h"
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <clutter/clutter.h>
#include <cairo-gobject.h>
#include <stdlib.h>
#include <string.h>
#include <meta/meta-plugin.h>
#include <meta/display.h>
#include <mtk/mtk.h>
#include <gdk/gdk.h>
#include <cogl/cogl.h>
#include <meta/window.h>
#include <meta/keybindings.h>
#include <meta/workspace.h>
#include <meta/meta-workspace-manager.h>
#include <atk/atk.h>
#include <meta/prefs.h>
#include <meta/meta-cursor-tracker.h>
#include <glib/gi18n-lib.h>
#include <pango/pango.h>
#include <meta/meta-monitor-manager.h>
#include <meta/meta-context.h>
#include <meta/meta-backend.h>

#define GALA_WINDOW_SWITCHER_ICON_SIZE 64
#define GALA_WINDOW_SWITCHER_WRAPPER_PADDING 12
#define GALA_WINDOW_SWITCHER_CAPTION_FONT_NAME "Inter"
#define GALA_WINDOW_SWITCHER_MIN_OFFSET 64
#define GALA_WINDOW_SWITCHER_ANIMATION_DURATION 200
#define GALA_WINDOW_SWITCHER_GESTURE_STEP 0.1
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_GESTURE_TARGET (gala_gesture_target_get_type ())
#define GALA_GESTURE_TARGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE_TARGET, GalaGestureTarget))
#define GALA_IS_GESTURE_TARGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE_TARGET))
#define GALA_GESTURE_TARGET_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GALA_TYPE_GESTURE_TARGET, GalaGestureTargetIface))

typedef struct _GalaGestureTarget GalaGestureTarget;
typedef struct _GalaGestureTargetIface GalaGestureTargetIface;
typedef enum  {
	GALA_GESTURE_TARGET_UPDATE_TYPE_START,
	GALA_GESTURE_TARGET_UPDATE_TYPE_UPDATE,
	GALA_GESTURE_TARGET_UPDATE_TYPE_COMMIT,
	GALA_GESTURE_TARGET_UPDATE_TYPE_END
} GalaGestureTargetUpdateType;

#define GALA_GESTURE_TARGET_TYPE_UPDATE_TYPE (gala_gesture_target_update_type_get_type ())

#define GALA_TYPE_ROOT_TARGET (gala_root_target_get_type ())
#define GALA_ROOT_TARGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_ROOT_TARGET, GalaRootTarget))
#define GALA_IS_ROOT_TARGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_ROOT_TARGET))
#define GALA_ROOT_TARGET_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GALA_TYPE_ROOT_TARGET, GalaRootTargetIface))

typedef struct _GalaRootTarget GalaRootTarget;
typedef struct _GalaRootTargetIface GalaRootTargetIface;

#define GALA_TYPE_WINDOW_SWITCHER (gala_window_switcher_get_type ())
#define GALA_WINDOW_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher))
#define GALA_WINDOW_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcherClass))
#define GALA_IS_WINDOW_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_SWITCHER))
#define GALA_IS_WINDOW_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_SWITCHER))
#define GALA_WINDOW_SWITCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcherClass))

typedef struct _GalaWindowSwitcher GalaWindowSwitcher;
typedef struct _GalaWindowSwitcherClass GalaWindowSwitcherClass;
typedef struct _GalaWindowSwitcherPrivate GalaWindowSwitcherPrivate;

#define GALA_TYPE_GESTURE_CONTROLLER (gala_gesture_controller_get_type ())
#define GALA_GESTURE_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE_CONTROLLER, GalaGestureController))
#define GALA_GESTURE_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_GESTURE_CONTROLLER, GalaGestureControllerClass))
#define GALA_IS_GESTURE_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE_CONTROLLER))
#define GALA_IS_GESTURE_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_GESTURE_CONTROLLER))
#define GALA_GESTURE_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_GESTURE_CONTROLLER, GalaGestureControllerClass))

typedef struct _GalaGestureController GalaGestureController;
typedef struct _GalaGestureControllerClass GalaGestureControllerClass;

#define GALA_TYPE_WINDOW_SWITCHER_ICON (gala_window_switcher_icon_get_type ())
#define GALA_WINDOW_SWITCHER_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_SWITCHER_ICON, GalaWindowSwitcherIcon))
#define GALA_WINDOW_SWITCHER_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_SWITCHER_ICON, GalaWindowSwitcherIconClass))
#define GALA_IS_WINDOW_SWITCHER_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_SWITCHER_ICON))
#define GALA_IS_WINDOW_SWITCHER_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_SWITCHER_ICON))
#define GALA_WINDOW_SWITCHER_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_SWITCHER_ICON, GalaWindowSwitcherIconClass))

typedef struct _GalaWindowSwitcherIcon GalaWindowSwitcherIcon;
typedef struct _GalaWindowSwitcherIconClass GalaWindowSwitcherIconClass;
enum  {
	GALA_WINDOW_SWITCHER_0_PROPERTY,
	GALA_WINDOW_SWITCHER_WM_PROPERTY,
	GALA_WINDOW_SWITCHER_OPENED_PROPERTY,
	GALA_WINDOW_SWITCHER_ACTOR_PROPERTY,
	GALA_WINDOW_SWITCHER_NUM_PROPERTIES
};
static GParamSpec* gala_window_switcher_properties[GALA_WINDOW_SWITCHER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_CoglColor_free0(var) ((var == NULL) ? NULL : (var = (_vala_CoglColor_free (var), NULL)))

#define GALA_TYPE_WINDOW_TRACKER (gala_window_tracker_get_type ())
#define GALA_WINDOW_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_TRACKER, GalaWindowTracker))
#define GALA_WINDOW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_TRACKER, GalaWindowTrackerClass))
#define GALA_IS_WINDOW_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_TRACKER))
#define GALA_IS_WINDOW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_TRACKER))
#define GALA_WINDOW_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_TRACKER, GalaWindowTrackerClass))

typedef struct _GalaWindowTracker GalaWindowTracker;
typedef struct _GalaWindowTrackerClass GalaWindowTrackerClass;

#define GALA_TYPE_WINDOW_MANAGER_GALA (gala_window_manager_gala_get_type ())
#define GALA_WINDOW_MANAGER_GALA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGala))
#define GALA_WINDOW_MANAGER_GALA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGalaClass))
#define GALA_IS_WINDOW_MANAGER_GALA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_MANAGER_GALA))
#define GALA_IS_WINDOW_MANAGER_GALA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_MANAGER_GALA))
#define GALA_WINDOW_MANAGER_GALA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGalaClass))

typedef struct _GalaWindowManagerGala GalaWindowManagerGala;
typedef struct _GalaWindowManagerGalaClass GalaWindowManagerGalaClass;

struct _GalaGestureTargetIface {
	GTypeInterface parent_iface;
	void (*propagate) (GalaGestureTarget* self, GalaGestureTargetUpdateType update_type, GalaGestureAction action, gdouble progress);
	ClutterActor* (*get_actor) (GalaGestureTarget* self);
};

struct _GalaRootTargetIface {
	GTypeInterface parent_iface;
};

struct _GalaWindowSwitcher {
	GalaCanvasActor parent_instance;
	GalaWindowSwitcherPrivate * priv;
};

struct _GalaWindowSwitcherClass {
	GalaCanvasActorClass parent_class;
};

struct _GalaWindowSwitcherPrivate {
	GalaWindowManager* _wm;
	gboolean _opened;
	GalaGestureController* gesture_controller;
	gint modifier_mask;
	GalaModalProxy* modal_proxy;
	GalaDrawingStyleManager* style_manager;
	ClutterActor* container;
	ClutterText* caption;
	GalaShadowEffect* shadow_effect;
	GalaWindowSwitcherIcon* _current_icon;
	gdouble previous_progress;
	gfloat scaling_factor;
};

static gint GalaWindowSwitcher_private_offset;
static gpointer gala_window_switcher_parent_class = NULL;
static GalaGestureTargetIface * gala_window_switcher_gala_gesture_target_parent_iface = NULL;
static GalaRootTargetIface * gala_window_switcher_gala_root_target_parent_iface = NULL;

VALA_EXTERN GType gala_gesture_target_update_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gala_gesture_target_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGestureTarget, g_object_unref)
VALA_EXTERN GType gala_root_target_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gala_window_switcher_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowSwitcher, g_object_unref)
VALA_EXTERN GType gala_gesture_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGestureController, g_object_unref)
VALA_EXTERN GType gala_window_switcher_icon_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowSwitcherIcon, g_object_unref)
VALA_EXTERN GalaWindowSwitcher* gala_window_switcher_new (GalaWindowManager* wm);
VALA_EXTERN GalaWindowSwitcher* gala_window_switcher_construct (GType object_type,
                                                    GalaWindowManager* wm);
static void gala_window_switcher_scale (GalaWindowSwitcher* self);
VALA_EXTERN GalaWindowManager* gala_window_switcher_get_wm (GalaWindowSwitcher* self);
static void gala_window_switcher_real_get_preferred_width (ClutterActor* base,
                                                    gfloat for_height,
                                                    gfloat* min_width,
                                                    gfloat* natural_width);
static void gala_window_switcher_real_draw (GalaCanvasActor* base,
                                     cairo_t* ctx,
                                     gint width,
                                     gint height);
static CoglColor* _vala_CoglColor_copy (CoglColor* self);
static void _vala_CoglColor_free (CoglColor* self);
static void gala_window_switcher_real_propagate (GalaGestureTarget* base,
                                          GalaGestureTargetUpdateType update_type,
                                          GalaGestureAction action,
                                          gdouble progress);
static GalaWindowSwitcherIcon* gala_window_switcher_get_current_icon (GalaWindowSwitcher* self);
VALA_EXTERN void gala_internal_utils_bell_notify (MetaDisplay* display);
static void gala_window_switcher_set_current_icon (GalaWindowSwitcher* self,
                                            GalaWindowSwitcherIcon* value);
static void gala_window_switcher_select_icon (GalaWindowSwitcher* self,
                                       GalaWindowSwitcherIcon* icon);
VALA_EXTERN void gala_gesture_controller_set_progress (GalaGestureController* self,
                                           gdouble value);
VALA_EXTERN void gala_window_switcher_handle_switch_windows (MetaDisplay* display,
                                                 MetaWindow* window,
                                                 ClutterKeyEvent* event,
                                                 MetaKeyBinding* binding,
                                                 GalaWindowSwitcher* self);
VALA_EXTERN gboolean gala_gesture_controller_get_recognizing (GalaGestureController* self);
VALA_EXTERN gboolean gala_window_switcher_get_opened (GalaWindowSwitcher* self);
static gboolean gala_window_switcher_collect_current_windows (GalaWindowSwitcher* self,
                                                       MetaDisplay* display,
                                                       MetaWorkspace* workspace);
static gboolean gala_window_switcher_collect_all_windows (GalaWindowSwitcher* self,
                                                   MetaDisplay* display,
                                                   MetaWorkspace* workspace);
static void gala_window_switcher_open_switcher (GalaWindowSwitcher* self);
static void gala_window_switcher_next_window (GalaWindowSwitcher* self,
                                       gboolean backward);
static void gala_window_switcher_recognizing_changed (GalaWindowSwitcher* self);
static void gala_window_switcher_close_switcher (GalaWindowSwitcher* self,
                                          guint32 time,
                                          gboolean cancel);
VALA_EXTERN GalaWindowSwitcherIcon* gala_window_switcher_icon_new (MetaWindow* window,
                                                       gint icon_size,
                                                       gfloat scale_factor);
VALA_EXTERN GalaWindowSwitcherIcon* gala_window_switcher_icon_construct (GType object_type,
                                                             MetaWindow* window,
                                                             gint icon_size,
                                                             gfloat scale_factor);
static void gala_window_switcher_add_icon (GalaWindowSwitcher* self,
                                    GalaWindowSwitcherIcon* icon);
VALA_EXTERN GType gala_window_tracker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowTracker, g_object_unref)
VALA_EXTERN GType gala_window_manager_gala_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowManagerGala, g_object_unref)
VALA_EXTERN GalaWindowTracker* gala_window_manager_gala_get_window_tracker (GalaWindowManagerGala* self);
VALA_EXTERN GalaApp* gala_window_tracker_get_app_for_window (GalaWindowTracker* self,
                                                 MetaWindow* window);
static gboolean __lambda94_ (GalaWindowSwitcher* self,
                      ClutterActor* _icon,
                      ClutterEvent* event);
static gboolean ___lambda94__clutter_actor_motion_event (ClutterActor* _sender,
                                                  ClutterEvent* event,
                                                  gpointer self);
static void gala_window_switcher_toggle_display (GalaWindowSwitcher* self,
                                          gboolean show);
static void gala_window_switcher_set_opened (GalaWindowSwitcher* self,
                                      gboolean value);
static void gala_window_switcher_push_modal (GalaWindowSwitcher* self);
static gboolean __lambda95_ (GalaWindowSwitcher* self,
                      MetaKeyBinding* binding);
static gboolean ___lambda95__gala_keybinding_filter (MetaKeyBinding* binding,
                                              gpointer self);
VALA_EXTERN MetaWindow* gala_window_switcher_icon_get_window (GalaWindowSwitcherIcon* self);
VALA_EXTERN gdouble gala_gesture_controller_get_progress (GalaGestureController* self);
static void gala_window_switcher_update_caption_text (GalaWindowSwitcher* self);
static void gala_window_switcher_real_key_focus_out (ClutterActor* base);
static gboolean gala_window_switcher_container_mouse_release (GalaWindowSwitcher* self,
                                                       ClutterEvent* event);
static gboolean gala_window_switcher_real_key_release_event (ClutterActor* base,
                                                      ClutterEvent* event);
static inline ClutterModifierType gala_window_switcher_get_current_modifiers (GalaWindowSwitcher* self);
static gboolean gala_window_switcher_real_key_press_event (ClutterActor* base,
                                                    ClutterEvent* event);
static void gala_window_switcher_set_wm (GalaWindowSwitcher* self,
                                  GalaWindowManager* value);
VALA_EXTERN void gala_window_switcher_icon_set_selected (GalaWindowSwitcherIcon* self,
                                             gboolean value);
static GObject * gala_window_switcher_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
VALA_EXTERN GalaGestureController* gala_gesture_controller_new (GalaGestureAction action,
                                                    GalaWindowManager* wm);
VALA_EXTERN GalaGestureController* gala_gesture_controller_construct (GType object_type,
                                                          GalaGestureAction action,
                                                          GalaWindowManager* wm);
VALA_EXTERN void gala_gesture_controller_set_overshoot_upper_clamp (GalaGestureController* self,
                                                        gdouble value);
VALA_EXTERN void gala_gesture_controller_set_overshoot_lower_clamp (GalaGestureController* self,
                                                        gdouble value);
VALA_EXTERN void gala_gesture_controller_set_snap (GalaGestureController* self,
                                       gboolean value);
VALA_EXTERN void gala_gesture_controller_enable_touchpad (GalaGestureController* self);
static void _gala_window_switcher_recognizing_changed_g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self);
VALA_EXTERN void gala_root_target_add_gesture_controller (GalaRootTarget* self,
                                              GalaGestureController* controller);
static gboolean _gala_window_switcher_container_mouse_release_clutter_actor_button_release_event (ClutterActor* _sender,
                                                                                           ClutterEvent* event,
                                                                                           gpointer self);
static void _clutter_content_invalidate_g_object_notify (GObject* _sender,
                                                  GParamSpec* pspec,
                                                  gpointer self);
static void _gala_window_switcher_scale_meta_monitor_manager_monitors_changed (MetaMonitorManager* _sender,
                                                                        gpointer self);
static void _gala_window_switcher___lambda96_ (GalaWindowSwitcher* self);
static void __gala_window_switcher___lambda96__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
VALA_EXTERN void gala_gesture_target_propagate (GalaGestureTarget* self,
                                    GalaGestureTargetUpdateType update_type,
                                    GalaGestureAction action,
                                    gdouble progress);
VALA_EXTERN ClutterActor* gala_gesture_target_get_actor (GalaGestureTarget* self);
static void gala_window_switcher_finalize (GObject * obj);
static GType gala_window_switcher_get_type_once (void);
static void _vala_gala_window_switcher_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_gala_window_switcher_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
gala_window_switcher_get_instance_private (GalaWindowSwitcher* self)
{
	return G_STRUCT_MEMBER_P (self, GalaWindowSwitcher_private_offset);
}

GalaWindowSwitcher*
gala_window_switcher_construct (GType object_type,
                                GalaWindowManager* wm)
{
	GalaWindowSwitcher * self = NULL;
#line 56 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (wm != NULL, NULL);
#line 57 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) g_object_new (object_type, "wm", wm, NULL);
#line 56 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return self;
#line 358 "WindowSwitcher.c"
}

GalaWindowSwitcher*
gala_window_switcher_new (GalaWindowManager* wm)
{
#line 56 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return gala_window_switcher_construct (GALA_TYPE_WINDOW_SWITCHER, wm);
#line 366 "WindowSwitcher.c"
}

static void
gala_window_switcher_scale (GalaWindowSwitcher* self)
{
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	GalaWindowManager* _tmp2_;
	MetaDisplay* _tmp3_;
	GalaShadowEffect* _tmp4_;
	gint margin = 0;
	ClutterActor* _tmp5_;
	ClutterActor* _tmp6_;
	ClutterActor* _tmp7_;
	ClutterActor* _tmp8_;
	ClutterText* _tmp9_;
	ClutterText* _tmp10_;
	ClutterText* _tmp11_;
#line 119 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 120 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 120 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 120 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = self->priv->_wm;
#line 120 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = meta_plugin_get_display ((MetaPlugin*) _tmp2_);
#line 120 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->scaling_factor = meta_display_get_monitor_scale (_tmp1_, meta_display_get_current_monitor (_tmp3_));
#line 122 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = self->priv->shadow_effect;
#line 122 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_shadow_effect_set_monitor_scale (_tmp4_, self->priv->scaling_factor);
#line 124 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	margin = gala_utils_scale_to_int (GALA_WINDOW_SWITCHER_WRAPPER_PADDING, self->priv->scaling_factor);
#line 126 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = self->priv->container;
#line 126 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_margin_left (_tmp5_, (gfloat) margin);
#line 127 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = self->priv->container;
#line 127 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_margin_right (_tmp6_, (gfloat) margin);
#line 128 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = self->priv->container;
#line 128 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_margin_bottom (_tmp7_, (gfloat) margin);
#line 129 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp8_ = self->priv->container;
#line 129 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_margin_top (_tmp8_, (gfloat) margin);
#line 131 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = self->priv->caption;
#line 131 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_margin_left ((ClutterActor*) _tmp9_, (gfloat) margin);
#line 132 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10_ = self->priv->caption;
#line 132 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_margin_right ((ClutterActor*) _tmp10_, (gfloat) margin);
#line 133 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11_ = self->priv->caption;
#line 133 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_margin_bottom ((ClutterActor*) _tmp11_, (gfloat) margin);
#line 431 "WindowSwitcher.c"
}

static void
gala_window_switcher_real_get_preferred_width (ClutterActor* base,
                                               gfloat for_height,
                                               gfloat* min_width,
                                               gfloat* natural_width)
{
	GalaWindowSwitcher * self;
	gfloat _vala_min_width = 0.0F;
	gfloat _vala_natural_width = 0.0F;
	gfloat preferred_nat_width = 0.0F;
	gfloat _tmp0_ = 0.0F;
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp1_;
	MetaDisplay* _tmp2_;
	gint monitor = 0;
	MtkRectangle geom = {0};
	MtkRectangle _tmp3_ = {0};
	gfloat container_nat_width = 0.0F;
	ClutterActor* _tmp4_;
	gfloat _tmp5_ = 0.0F;
	gfloat max_width = 0.0F;
	MtkRectangle _tmp6_;
#line 136 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) base;
#line 137 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_vala_min_width = (gfloat) 0;
#line 140 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	CLUTTER_ACTOR_CLASS (gala_window_switcher_parent_class)->get_preferred_width ((ClutterActor*) G_TYPE_CHECK_INSTANCE_CAST (self, GALA_TYPE_CANVAS_ACTOR, GalaCanvasActor), for_height, NULL, &_tmp0_);
#line 140 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	preferred_nat_width = _tmp0_;
#line 142 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = self->priv->_wm;
#line 142 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = meta_plugin_get_display ((MetaPlugin*) _tmp1_);
#line 142 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	display = _tmp2_;
#line 143 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	monitor = meta_display_get_current_monitor (display);
#line 144 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	meta_display_get_monitor_geometry (display, monitor, &_tmp3_);
#line 144 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	geom = _tmp3_;
#line 147 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = self->priv->container;
#line 147 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_get_preferred_size (_tmp4_, NULL, NULL, &_tmp5_, NULL);
#line 147 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	container_nat_width = _tmp5_;
#line 149 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = geom;
#line 149 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	max_width = MIN ((gfloat) (_tmp6_.width - (gala_utils_scale_to_int (GALA_WINDOW_SWITCHER_MIN_OFFSET, self->priv->scaling_factor) * 2)), container_nat_width);
#line 154 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_vala_natural_width = MIN (max_width, preferred_nat_width);
#line 136 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (min_width) {
#line 136 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		*min_width = _vala_min_width;
#line 492 "WindowSwitcher.c"
	}
#line 136 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (natural_width) {
#line 136 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		*natural_width = _vala_natural_width;
#line 498 "WindowSwitcher.c"
	}
}

static CoglColor*
_vala_CoglColor_copy (CoglColor* self)
{
#line 819 "mutter-cogl-15.vapi"
	return g_boxed_copy (cogl_color_get_type (), self);
#line 507 "WindowSwitcher.c"
}

static gpointer
__vala_CoglColor_copy0 (gpointer self)
{
#line 819 "mutter-cogl-15.vapi"
	return self ? _vala_CoglColor_copy (self) : NULL;
#line 515 "WindowSwitcher.c"
}

static CoglColor*
_vala_cogl_color_from_string (const gchar* str)
{
	CoglColor color = {0};
	CoglColor _tmp0_ = {0};
	CoglColor* result;
#line 816 "mutter-cogl-15.vapi"
	g_return_val_if_fail (str != NULL, NULL);
#line 817 "mutter-cogl-15.vapi"
	color = _tmp0_;
#line 818 "mutter-cogl-15.vapi"
	if (cogl_color_from_string (&color, str)) {
#line 530 "WindowSwitcher.c"
		CoglColor* _tmp1_;
#line 819 "mutter-cogl-15.vapi"
		_tmp1_ = __vala_CoglColor_copy0 (&color);
#line 819 "mutter-cogl-15.vapi"
		result = _tmp1_;
#line 819 "mutter-cogl-15.vapi"
		return result;
#line 538 "WindowSwitcher.c"
	}
#line 821 "mutter-cogl-15.vapi"
	result = NULL;
#line 821 "mutter-cogl-15.vapi"
	return result;
#line 544 "WindowSwitcher.c"
}

static void
_vala_CoglColor_free (CoglColor* self)
{
#line 171 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_boxed_free (cogl_color_get_type (), self);
#line 552 "WindowSwitcher.c"
}

static void
gala_window_switcher_real_draw (GalaCanvasActor* base,
                                cairo_t* ctx,
                                gint width,
                                gint height)
{
	GalaWindowSwitcher * self;
	GdkRGBA background_color = {0};
	GdkRGBA border_color = {0};
	gchar* caption_color = NULL;
	gchar* _tmp0_;
	GdkRGBA highlight_color = {0};
	GalaDrawingStyleManager* _tmp1_;
	GalaDrawingStyleManagerColorScheme _tmp2_;
	GalaDrawingStyleManagerColorScheme _tmp3_;
	ClutterText* _tmp5_;
	const gchar* _tmp6_;
	CoglColor* _tmp7_;
	CoglColor* _tmp8_;
	CoglColor _tmp9_;
	gint stroke_width = 0;
	GdkRGBA _tmp10_;
	GdkRGBA _tmp11_;
	GdkRGBA _tmp12_;
	GdkRGBA _tmp13_;
	GdkRGBA _tmp14_;
	GdkRGBA _tmp15_;
	GdkRGBA _tmp16_;
	GdkRGBA _tmp17_;
	GdkRGBA _tmp18_;
	GdkRGBA _tmp19_;
	GdkRGBA _tmp20_;
	GdkRGBA _tmp21_;
#line 157 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) base;
#line 157 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (ctx != NULL);
#line 158 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	background_color = GALA_DRAWING_COLOR_LIGHT_BACKGROUND;
#line 159 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	border_color = GALA_DRAWING_COLOR_LIGHT_BORDER;
#line 160 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = g_strdup ("#2e2e31");
#line 160 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	caption_color = _tmp0_;
#line 161 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	highlight_color = GALA_DRAWING_COLOR_LIGHT_HIGHLIGHT;
#line 163 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = self->priv->style_manager;
#line 163 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = gala_drawing_style_manager_get_prefers_color_scheme (_tmp1_);
#line 163 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = _tmp2_;
#line 163 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp3_ == GALA_DRAWING_STYLE_MANAGER_COLOR_SCHEME_DARK) {
#line 610 "WindowSwitcher.c"
		gchar* _tmp4_;
#line 164 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		background_color = GALA_DRAWING_COLOR_DARK_BACKGROUND;
#line 165 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		border_color = GALA_DRAWING_COLOR_DARK_BORDER;
#line 166 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp4_ = g_strdup ("#fafafa");
#line 166 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_free0 (caption_color);
#line 166 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		caption_color = _tmp4_;
#line 167 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		highlight_color = GALA_DRAWING_COLOR_DARK_HIGHLIGHT;
#line 624 "WindowSwitcher.c"
	}
#line 171 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = self->priv->caption;
#line 171 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = caption_color;
#line 171 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = _vala_cogl_color_from_string (_tmp6_);
#line 171 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp8_ = _tmp7_;
#line 171 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = *_tmp8_;
#line 171 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_text_set_color (_tmp5_, &_tmp9_);
#line 171 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	__vala_CoglColor_free0 (_tmp8_);
#line 176 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_save (ctx);
#line 177 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_set_operator (ctx, CAIRO_OPERATOR_CLEAR);
#line 178 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_paint (ctx);
#line 179 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_clip (ctx);
#line 180 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_reset_clip (ctx);
#line 182 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_set_operator (ctx, CAIRO_OPERATOR_SOURCE);
#line 184 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	stroke_width = gala_utils_scale_to_int (1, self->priv->scaling_factor);
#line 185 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_drawing_utilities_cairo_rounded_rectangle (ctx, stroke_width / 2.0, stroke_width / 2.0, (gdouble) (width - stroke_width), (gdouble) (height - stroke_width), (gdouble) gala_utils_scale_to_int (9, self->priv->scaling_factor));
#line 192 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10_ = background_color;
#line 192 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11_ = background_color;
#line 192 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp12_ = background_color;
#line 192 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp13_ = background_color;
#line 192 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_set_source_rgba (ctx, _tmp10_.red, _tmp11_.green, _tmp12_.blue, _tmp13_.alpha);
#line 198 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_fill_preserve (ctx);
#line 200 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_set_line_width (ctx, (gdouble) stroke_width);
#line 201 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp14_ = border_color;
#line 201 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp15_ = border_color;
#line 201 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp16_ = border_color;
#line 201 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp17_ = border_color;
#line 201 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_set_source_rgba (ctx, _tmp14_.red, _tmp15_.green, _tmp16_.blue, _tmp17_.alpha);
#line 207 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_stroke (ctx);
#line 208 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_restore (ctx);
#line 210 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_drawing_utilities_cairo_rounded_rectangle (ctx, stroke_width * 1.5, stroke_width * 1.5, (gdouble) (width - (stroke_width * 3)), (gdouble) (height - (stroke_width * 3)), (gdouble) gala_utils_scale_to_int (8, self->priv->scaling_factor));
#line 217 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_set_line_width (ctx, (gdouble) stroke_width);
#line 218 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp18_ = highlight_color;
#line 218 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp19_ = highlight_color;
#line 218 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp20_ = highlight_color;
#line 218 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp21_ = highlight_color;
#line 218 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_set_source_rgba (ctx, _tmp18_.red, _tmp19_.green, _tmp20_.blue, _tmp21_.alpha);
#line 224 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_stroke (ctx);
#line 225 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_restore (ctx);
#line 157 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_free0 (caption_color);
#line 704 "WindowSwitcher.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 248 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return self ? g_object_ref (self) : NULL;
#line 712 "WindowSwitcher.c"
}

static void
gala_window_switcher_real_propagate (GalaGestureTarget* base,
                                     GalaGestureTargetUpdateType update_type,
                                     GalaGestureAction action,
                                     gdouble progress)
{
	GalaWindowSwitcher * self;
	gboolean _tmp0_ = FALSE;
	gboolean is_step = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	ClutterActor* _tmp4_;
	gint current_index = 0;
	ClutterActor* _tmp9_;
	GalaWindowSwitcherIcon* new_icon = NULL;
	ClutterActor* _tmp11_;
	ClutterActor* _tmp12_;
	GalaWindowSwitcherIcon* _tmp13_;
	GalaWindowSwitcherIcon* _tmp14_;
	GalaWindowSwitcherIcon* _tmp15_;
	GalaWindowSwitcherIcon* _tmp16_;
#line 228 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) base;
#line 229 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (update_type != GALA_GESTURE_TARGET_UPDATE_TYPE_UPDATE) {
#line 229 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = TRUE;
#line 742 "WindowSwitcher.c"
	} else {
		ClutterActor* _tmp1_;
#line 229 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp1_ = self->priv->container;
#line 229 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = clutter_actor_get_n_children (_tmp1_) == 0;
#line 749 "WindowSwitcher.c"
	}
#line 229 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp0_) {
#line 230 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 755 "WindowSwitcher.c"
	}
#line 233 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	is_step = abs (((gint) (self->priv->previous_progress / GALA_WINDOW_SWITCHER_GESTURE_STEP)) - ((gint) (progress / GALA_WINDOW_SWITCHER_GESTURE_STEP))) >= 1;
#line 235 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->previous_progress = progress;
#line 237 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = self->priv->container;
#line 237 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (clutter_actor_get_n_children (_tmp4_) == 1) {
#line 765 "WindowSwitcher.c"
		GalaWindowSwitcherIcon* _tmp5_;
		GalaWindowSwitcherIcon* _tmp6_;
#line 237 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp5_ = gala_window_switcher_get_current_icon (self);
#line 237 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp6_ = _tmp5_;
#line 237 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp3_ = _tmp6_ != NULL;
#line 774 "WindowSwitcher.c"
	} else {
#line 237 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp3_ = FALSE;
#line 778 "WindowSwitcher.c"
	}
#line 237 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp3_) {
#line 237 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp2_ = is_step;
#line 784 "WindowSwitcher.c"
	} else {
#line 237 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp2_ = FALSE;
#line 788 "WindowSwitcher.c"
	}
#line 237 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp2_) {
#line 792 "WindowSwitcher.c"
		GalaWindowManager* _tmp7_;
		MetaDisplay* _tmp8_;
#line 238 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp7_ = self->priv->_wm;
#line 238 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp8_ = meta_plugin_get_display ((MetaPlugin*) _tmp7_);
#line 238 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_internal_utils_bell_notify (_tmp8_);
#line 239 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 803 "WindowSwitcher.c"
	}
#line 242 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = self->priv->container;
#line 242 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	current_index = ((gint) (progress / GALA_WINDOW_SWITCHER_GESTURE_STEP)) % clutter_actor_get_n_children (_tmp9_);
#line 244 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (current_index < 0) {
#line 811 "WindowSwitcher.c"
		ClutterActor* _tmp10_;
#line 245 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp10_ = self->priv->container;
#line 245 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		current_index = clutter_actor_get_n_children (_tmp10_) + current_index;
#line 817 "WindowSwitcher.c"
	}
#line 248 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11_ = self->priv->container;
#line 248 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp12_ = clutter_actor_get_child_at_index (_tmp11_, current_index);
#line 248 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GALA_TYPE_WINDOW_SWITCHER_ICON, GalaWindowSwitcherIcon));
#line 248 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	new_icon = _tmp13_;
#line 249 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp14_ = new_icon;
#line 249 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp15_ = gala_window_switcher_get_current_icon (self);
#line 249 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp16_ = _tmp15_;
#line 249 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp14_ != _tmp16_) {
#line 835 "WindowSwitcher.c"
		GalaWindowSwitcherIcon* _tmp17_;
#line 250 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp17_ = new_icon;
#line 250 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_set_current_icon (self, _tmp17_);
#line 841 "WindowSwitcher.c"
	}
#line 228 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (new_icon);
#line 845 "WindowSwitcher.c"
}

static void
gala_window_switcher_select_icon (GalaWindowSwitcher* self,
                                  GalaWindowSwitcherIcon* icon)
{
	gint index = 0;
#line 254 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 255 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (icon == NULL) {
#line 857 "WindowSwitcher.c"
		GalaGestureController* _tmp0_;
#line 256 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = self->priv->gesture_controller;
#line 256 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_gesture_controller_set_progress (_tmp0_, (gdouble) 0);
#line 257 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_set_current_icon (self, NULL);
#line 258 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 867 "WindowSwitcher.c"
	}
#line 261 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	index = 0;
#line 871 "WindowSwitcher.c"
	{
		ClutterActor* child = NULL;
		ClutterActor* _tmp1_;
		ClutterActor* _tmp2_;
		ClutterActor* _tmp3_;
#line 262 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp1_ = self->priv->container;
#line 262 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp2_ = clutter_actor_get_first_child (_tmp1_);
#line 262 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 262 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		child = _tmp3_;
#line 885 "WindowSwitcher.c"
		{
			gboolean _tmp4_ = FALSE;
#line 262 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp4_ = TRUE;
#line 262 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			while (TRUE) {
#line 892 "WindowSwitcher.c"
				ClutterActor* _tmp8_;
				ClutterActor* _tmp9_;
				gint _tmp11_;
#line 262 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				if (!_tmp4_) {
#line 898 "WindowSwitcher.c"
					ClutterActor* _tmp5_;
					ClutterActor* _tmp6_;
					ClutterActor* _tmp7_;
#line 262 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp5_ = child;
#line 262 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp6_ = clutter_actor_get_next_sibling (_tmp5_);
#line 262 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp7_ = _g_object_ref0 (_tmp6_);
#line 262 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_g_object_unref0 (child);
#line 262 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					child = _tmp7_;
#line 912 "WindowSwitcher.c"
				}
#line 262 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp4_ = FALSE;
#line 262 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp8_ = child;
#line 262 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				if (!(_tmp8_ != NULL)) {
#line 262 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					break;
#line 922 "WindowSwitcher.c"
				}
#line 263 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp9_ = child;
#line 263 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				if (_tmp9_ == G_TYPE_CHECK_INSTANCE_CAST (icon, clutter_actor_get_type (), ClutterActor)) {
#line 928 "WindowSwitcher.c"
					GalaGestureController* _tmp10_;
#line 264 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp10_ = self->priv->gesture_controller;
#line 264 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					gala_gesture_controller_set_progress (_tmp10_, index * GALA_WINDOW_SWITCHER_GESTURE_STEP);
#line 265 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					break;
#line 936 "WindowSwitcher.c"
				}
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp11_ = index;
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				index = _tmp11_ + 1;
#line 942 "WindowSwitcher.c"
			}
		}
#line 262 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (child);
#line 947 "WindowSwitcher.c"
	}
}

void
gala_window_switcher_handle_switch_windows (MetaDisplay* display,
                                            MetaWindow* window,
                                            ClutterKeyEvent* event,
                                            MetaKeyBinding* binding,
                                            GalaWindowSwitcher* self)
{
	GalaGestureController* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	MetaWorkspace* workspace = NULL;
	MetaWorkspaceManager* _tmp3_;
	MetaWorkspace* _tmp4_;
	MetaWorkspace* _tmp5_;
	guint mask = 0U;
	gboolean _tmp6_;
	gchar* binding_name = NULL;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gboolean backward = FALSE;
	const gchar* _tmp12_;
#line 272 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 272 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (display != NULL);
#line 272 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (binding != NULL);
#line 276 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->gesture_controller;
#line 276 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = gala_gesture_controller_get_recognizing (_tmp0_);
#line 276 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = _tmp1_;
#line 276 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp2_) {
#line 277 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 988 "WindowSwitcher.c"
	}
#line 280 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = meta_display_get_workspace_manager (display);
#line 280 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = meta_workspace_manager_get_active_workspace (_tmp3_);
#line 280 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 280 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	workspace = _tmp5_;
#line 283 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	mask = meta_key_binding_get_mask (binding);
#line 284 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (mask == ((guint) 0)) {
#line 285 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		self->priv->modifier_mask = 0;
#line 1004 "WindowSwitcher.c"
	} else {
#line 287 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		self->priv->modifier_mask = 1;
#line 288 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		while (TRUE) {
#line 288 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			if (!(mask > ((guint) 1))) {
#line 288 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				break;
#line 1014 "WindowSwitcher.c"
			}
#line 289 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			mask >>= (guint) 1;
#line 290 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			self->priv->modifier_mask = self->priv->modifier_mask << 1;
#line 1020 "WindowSwitcher.c"
		}
	}
#line 294 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = self->priv->_opened;
#line 294 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (!_tmp6_) {
#line 1027 "WindowSwitcher.c"
		gboolean windows_exist = FALSE;
		const gchar* _tmp7_;
#line 296 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp7_ = meta_key_binding_get_name (binding);
#line 296 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		if (g_str_has_prefix (_tmp7_, "switch-group")) {
#line 1034 "WindowSwitcher.c"
			MetaWorkspace* _tmp8_;
#line 297 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp8_ = workspace;
#line 297 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			windows_exist = gala_window_switcher_collect_current_windows (self, display, _tmp8_);
#line 1040 "WindowSwitcher.c"
		} else {
			MetaWorkspace* _tmp9_;
#line 299 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp9_ = workspace;
#line 299 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			windows_exist = gala_window_switcher_collect_all_windows (self, display, _tmp9_);
#line 1047 "WindowSwitcher.c"
		}
#line 302 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		if (!windows_exist) {
#line 303 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_g_object_unref0 (workspace);
#line 303 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			return;
#line 1055 "WindowSwitcher.c"
		}
#line 306 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_open_switcher (self);
#line 1059 "WindowSwitcher.c"
	}
#line 309 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10_ = meta_key_binding_get_name (binding);
#line 309 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 309 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	binding_name = _tmp11_;
#line 310 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp12_ = binding_name;
#line 310 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	backward = g_str_has_suffix (_tmp12_, "-backward");
#line 312 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_next_window (self, backward);
#line 272 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_free0 (binding_name);
#line 272 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (workspace);
#line 1077 "WindowSwitcher.c"
}

static void
gala_window_switcher_recognizing_changed (GalaWindowSwitcher* self)
{
	GalaGestureController* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 315 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 316 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->gesture_controller;
#line 316 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = gala_gesture_controller_get_recognizing (_tmp0_);
#line 316 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = _tmp1_;
#line 316 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp2_) {
#line 1096 "WindowSwitcher.c"
		MetaDisplay* display = NULL;
		GalaWindowManager* _tmp3_;
		MetaDisplay* _tmp4_;
		MetaWorkspaceManager* workspace_manager = NULL;
		MetaDisplay* _tmp5_;
		MetaWorkspaceManager* _tmp6_;
		MetaWorkspace* active_workspace = NULL;
		MetaWorkspaceManager* _tmp7_;
		MetaWorkspace* _tmp8_;
		gboolean windows_exist = FALSE;
		MetaDisplay* _tmp9_;
		MetaWorkspace* _tmp10_;
#line 317 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp3_ = self->priv->_wm;
#line 317 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp4_ = meta_plugin_get_display ((MetaPlugin*) _tmp3_);
#line 317 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		display = _tmp4_;
#line 318 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp5_ = display;
#line 318 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp6_ = meta_display_get_workspace_manager (_tmp5_);
#line 318 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		workspace_manager = _tmp6_;
#line 319 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp7_ = workspace_manager;
#line 319 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp8_ = meta_workspace_manager_get_active_workspace (_tmp7_);
#line 319 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		active_workspace = _tmp8_;
#line 321 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp9_ = display;
#line 321 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp10_ = active_workspace;
#line 321 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		windows_exist = gala_window_switcher_collect_all_windows (self, _tmp9_, _tmp10_);
#line 322 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		if (!windows_exist) {
#line 323 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			return;
#line 1137 "WindowSwitcher.c"
		}
#line 325 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_open_switcher (self);
#line 1141 "WindowSwitcher.c"
	} else {
		GalaWindowManager* _tmp11_;
		MetaDisplay* _tmp12_;
#line 327 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp11_ = self->priv->_wm;
#line 327 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp12_ = meta_plugin_get_display ((MetaPlugin*) _tmp11_);
#line 327 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_close_switcher (self, meta_display_get_current_time (_tmp12_), FALSE);
#line 1151 "WindowSwitcher.c"
	}
}

static gboolean
gala_window_switcher_collect_all_windows (GalaWindowSwitcher* self,
                                          MetaDisplay* display,
                                          MetaWorkspace* workspace)
{
	ClutterActor* _tmp0_;
	GList* windows = NULL;
	GList* _tmp1_;
	GList* _tmp2_;
	MetaWindow* current_window = NULL;
	MetaWindow* _tmp3_;
	GList* _tmp4_;
	gboolean result;
#line 331 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 331 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (display != NULL, FALSE);
#line 332 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->container;
#line 332 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_remove_all_children (_tmp0_);
#line 333 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_select_icon (self, NULL);
#line 335 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = meta_display_get_tab_list (display, META_TAB_LIST_NORMAL, workspace);
#line 335 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	windows = _tmp1_;
#line 336 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = windows;
#line 336 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp2_ == NULL) {
#line 337 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		result = FALSE;
#line 337 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 337 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return result;
#line 1192 "WindowSwitcher.c"
	}
#line 340 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = meta_display_get_tab_current (display, META_TAB_LIST_NORMAL, workspace);
#line 340 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	current_window = _tmp3_;
#line 341 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = windows;
#line 1200 "WindowSwitcher.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 341 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		window_collection = _tmp4_;
#line 341 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 1208 "WindowSwitcher.c"
			MetaWindow* window = NULL;
#line 341 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			window = (MetaWindow*) window_it->data;
#line 1212 "WindowSwitcher.c"
			{
				GalaWindowSwitcherIcon* icon = NULL;
				MetaWindow* _tmp5_;
				GalaWindowSwitcherIcon* _tmp6_;
				GalaWindowSwitcherIcon* _tmp7_;
				MetaWindow* _tmp8_;
				MetaWindow* _tmp9_;
#line 342 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp5_ = window;
#line 342 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp6_ = gala_window_switcher_icon_new (_tmp5_, GALA_WINDOW_SWITCHER_ICON_SIZE, self->priv->scaling_factor);
#line 342 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				g_object_ref_sink (_tmp6_);
#line 342 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				icon = _tmp6_;
#line 343 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp7_ = icon;
#line 343 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				gala_window_switcher_add_icon (self, _tmp7_);
#line 345 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp8_ = window;
#line 345 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp9_ = current_window;
#line 345 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				if (_tmp8_ == _tmp9_) {
#line 1238 "WindowSwitcher.c"
					GalaWindowSwitcherIcon* _tmp10_;
#line 346 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp10_ = icon;
#line 346 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					gala_window_switcher_select_icon (self, _tmp10_);
#line 1244 "WindowSwitcher.c"
				}
#line 341 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_g_object_unref0 (icon);
#line 1248 "WindowSwitcher.c"
			}
		}
	}
#line 350 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = TRUE;
#line 350 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 350 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 1258 "WindowSwitcher.c"
}

static gboolean
gala_window_switcher_collect_current_windows (GalaWindowSwitcher* self,
                                              MetaDisplay* display,
                                              MetaWorkspace* workspace)
{
	ClutterActor* _tmp0_;
	GList* windows = NULL;
	GList* _tmp1_;
	GList* _tmp2_;
	MetaWindow* current_window = NULL;
	MetaWindow* _tmp3_;
	MetaWindow* _tmp4_;
	GalaWindowTracker* window_tracker = NULL;
	GalaWindowManager* _tmp5_;
	GalaWindowTracker* _tmp6_;
	GalaWindowTracker* _tmp7_;
	GalaApp* app = NULL;
	GalaWindowTracker* _tmp8_;
	MetaWindow* _tmp9_;
	GalaApp* _tmp10_;
	GList* _tmp11_;
	gboolean result;
#line 353 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 353 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (display != NULL, FALSE);
#line 354 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->container;
#line 354 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_remove_all_children (_tmp0_);
#line 355 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_select_icon (self, NULL);
#line 357 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = meta_display_get_tab_list (display, META_TAB_LIST_NORMAL, workspace);
#line 357 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	windows = _tmp1_;
#line 358 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = windows;
#line 358 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp2_ == NULL) {
#line 359 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		result = FALSE;
#line 359 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 359 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return result;
#line 1307 "WindowSwitcher.c"
	}
#line 362 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = meta_display_get_tab_current (display, META_TAB_LIST_NORMAL, workspace);
#line 362 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	current_window = _tmp3_;
#line 363 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = current_window;
#line 363 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp4_ == NULL) {
#line 364 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		result = FALSE;
#line 364 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 364 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return result;
#line 1323 "WindowSwitcher.c"
	}
#line 367 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = self->priv->_wm;
#line 367 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = gala_window_manager_gala_get_window_tracker (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGala));
#line 367 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = _tmp6_;
#line 367 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	window_tracker = _tmp7_;
#line 368 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp8_ = window_tracker;
#line 368 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = current_window;
#line 368 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10_ = gala_window_tracker_get_app_for_window (_tmp8_, _tmp9_);
#line 368 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	app = _tmp10_;
#line 369 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11_ = windows;
#line 1343 "WindowSwitcher.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 369 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		window_collection = _tmp11_;
#line 369 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 1351 "WindowSwitcher.c"
			MetaWindow* window = NULL;
#line 369 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			window = (MetaWindow*) window_it->data;
#line 1355 "WindowSwitcher.c"
			{
				GalaWindowTracker* _tmp12_;
				MetaWindow* _tmp13_;
				GalaApp* _tmp14_;
				GalaApp* _tmp15_;
				GalaApp* _tmp16_;
				gboolean _tmp17_;
#line 370 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp12_ = window_tracker;
#line 370 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp13_ = window;
#line 370 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp14_ = gala_window_tracker_get_app_for_window (_tmp12_, _tmp13_);
#line 370 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp15_ = _tmp14_;
#line 370 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp16_ = app;
#line 370 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp17_ = _tmp15_ == _tmp16_;
#line 370 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_g_object_unref0 (_tmp15_);
#line 370 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				if (_tmp17_) {
#line 1379 "WindowSwitcher.c"
					GalaWindowSwitcherIcon* icon = NULL;
					MetaWindow* _tmp18_;
					GalaWindowSwitcherIcon* _tmp19_;
					GalaWindowSwitcherIcon* _tmp20_;
					MetaWindow* _tmp21_;
					MetaWindow* _tmp22_;
#line 371 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp18_ = window;
#line 371 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp19_ = gala_window_switcher_icon_new (_tmp18_, GALA_WINDOW_SWITCHER_ICON_SIZE, self->priv->scaling_factor);
#line 371 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					g_object_ref_sink (_tmp19_);
#line 371 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					icon = _tmp19_;
#line 372 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp20_ = icon;
#line 372 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					gala_window_switcher_add_icon (self, _tmp20_);
#line 374 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp21_ = window;
#line 374 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp22_ = current_window;
#line 374 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					if (_tmp21_ == _tmp22_) {
#line 1404 "WindowSwitcher.c"
						GalaWindowSwitcherIcon* _tmp23_;
#line 375 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
						_tmp23_ = icon;
#line 375 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
						gala_window_switcher_select_icon (self, _tmp23_);
#line 1410 "WindowSwitcher.c"
					}
#line 370 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_g_object_unref0 (icon);
#line 1414 "WindowSwitcher.c"
				}
			}
		}
	}
#line 380 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = TRUE;
#line 380 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (app);
#line 380 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 380 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 1427 "WindowSwitcher.c"
}

static gboolean
__lambda94_ (GalaWindowSwitcher* self,
             ClutterActor* _icon,
             ClutterEvent* event)
{
	gboolean _tmp0_ = FALSE;
	GalaWindowSwitcherIcon* _tmp1_;
	GalaWindowSwitcherIcon* _tmp2_;
	gboolean result;
#line 387 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (_icon != NULL, FALSE);
#line 387 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 388 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = gala_window_switcher_get_current_icon (self);
#line 388 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = _tmp1_;
#line 388 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, clutter_actor_get_type (), ClutterActor) != _icon) {
#line 1449 "WindowSwitcher.c"
		GalaGestureController* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 388 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp3_ = self->priv->gesture_controller;
#line 388 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp4_ = gala_gesture_controller_get_recognizing (_tmp3_);
#line 388 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp5_ = _tmp4_;
#line 388 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = !_tmp5_;
#line 1461 "WindowSwitcher.c"
	} else {
#line 388 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = FALSE;
#line 1465 "WindowSwitcher.c"
	}
#line 388 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp0_) {
#line 389 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_select_icon (self, G_TYPE_CHECK_INSTANCE_CAST (_icon, GALA_TYPE_WINDOW_SWITCHER_ICON, GalaWindowSwitcherIcon));
#line 1471 "WindowSwitcher.c"
	}
#line 392 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 392 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 1477 "WindowSwitcher.c"
}

static gboolean
___lambda94__clutter_actor_motion_event (ClutterActor* _sender,
                                         ClutterEvent* event,
                                         gpointer self)
{
	gboolean result;
	result = __lambda94_ ((GalaWindowSwitcher*) self, _sender, event);
#line 387 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 1489 "WindowSwitcher.c"
}

static void
gala_window_switcher_add_icon (GalaWindowSwitcher* self,
                               GalaWindowSwitcherIcon* icon)
{
	ClutterActor* _tmp0_;
	AtkObject* _tmp1_;
	ClutterActor* _tmp2_;
	AtkObject* _tmp3_;
#line 383 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 383 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (icon != NULL);
#line 384 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->container;
#line 384 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_add_child (_tmp0_, (ClutterActor*) icon);
#line 385 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = clutter_actor_get_accessible ((ClutterActor*) icon);
#line 385 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = self->priv->container;
#line 385 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = clutter_actor_get_accessible (_tmp2_);
#line 385 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_set (_tmp1_, "accessible-parent", _tmp3_, NULL);
#line 387 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_signal_connect_object ((ClutterActor*) icon, "motion-event", (GCallback) ___lambda94__clutter_actor_motion_event, self, 0);
#line 1518 "WindowSwitcher.c"
}

static void
gala_window_switcher_open_switcher (GalaWindowSwitcher* self)
{
	ClutterActor* _tmp0_;
	gboolean _tmp3_;
	gfloat width = 0.0F;
	gfloat height = 0.0F;
	gfloat _tmp4_ = 0.0F;
	gfloat _tmp5_ = 0.0F;
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp6_;
	MetaDisplay* _tmp7_;
	gint monitor = 0;
	MetaDisplay* _tmp8_;
	MtkRectangle geom = {0};
	MetaDisplay* _tmp9_;
	MtkRectangle _tmp10_ = {0};
	MtkRectangle _tmp11_;
	MtkRectangle _tmp12_;
	MtkRectangle _tmp13_;
	MtkRectangle _tmp14_;
#line 396 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 397 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->container;
#line 397 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (clutter_actor_get_n_children (_tmp0_) == 0) {
#line 1548 "WindowSwitcher.c"
		GalaWindowManager* _tmp1_;
		MetaDisplay* _tmp2_;
#line 398 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp1_ = self->priv->_wm;
#line 398 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp2_ = meta_plugin_get_display ((MetaPlugin*) _tmp1_);
#line 398 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_internal_utils_bell_notify (_tmp2_);
#line 399 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 1559 "WindowSwitcher.c"
	}
#line 402 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = self->priv->_opened;
#line 402 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp3_) {
#line 403 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 1567 "WindowSwitcher.c"
	}
#line 408 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_set ((ClutterActor*) self, "visible", TRUE, NULL);
#line 411 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_get_preferred_size ((ClutterActor*) self, NULL, NULL, &_tmp4_, &_tmp5_);
#line 411 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	width = _tmp4_;
#line 411 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	height = _tmp5_;
#line 413 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = self->priv->_wm;
#line 413 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = meta_plugin_get_display ((MetaPlugin*) _tmp6_);
#line 413 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	display = _tmp7_;
#line 414 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp8_ = display;
#line 414 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	monitor = meta_display_get_current_monitor (_tmp8_);
#line 415 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = display;
#line 415 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	meta_display_get_monitor_geometry (_tmp9_, monitor, &_tmp10_);
#line 415 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	geom = _tmp10_;
#line 417 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11_ = geom;
#line 417 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp12_ = geom;
#line 417 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp13_ = geom;
#line 417 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp14_ = geom;
#line 417 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_position ((ClutterActor*) self, (gfloat) ((gint) (_tmp11_.x + ((_tmp12_.width - width) / 2))), (gfloat) ((gint) (_tmp13_.y + ((_tmp14_.height - height) / 2))));
#line 422 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_toggle_display (self, TRUE);
#line 1605 "WindowSwitcher.c"
}

static void
gala_window_switcher_toggle_display (GalaWindowSwitcher* self,
                                     gboolean show)
{
	gboolean _tmp0_;
	gint _tmp4_ = 0;
#line 425 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 426 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_opened;
#line 426 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp0_ == show) {
#line 427 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 1622 "WindowSwitcher.c"
	}
#line 430 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_set_opened (self, show);
#line 431 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (show) {
#line 432 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_push_modal (self);
#line 1630 "WindowSwitcher.c"
	} else {
		GalaWindowManager* _tmp1_;
		GalaModalProxy* _tmp2_;
		ClutterStage* _tmp3_;
#line 434 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp1_ = self->priv->_wm;
#line 434 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp2_ = self->priv->modal_proxy;
#line 434 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_manager_pop_modal (_tmp1_, _tmp2_);
#line 435 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp3_ = (ClutterStage*) clutter_actor_get_stage ((ClutterActor*) self);
#line 435 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		clutter_stage_set_key_focus (_tmp3_, NULL);
#line 1645 "WindowSwitcher.c"
	}
#line 438 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_save_easing_state ((ClutterActor*) self);
#line 439 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) self, gala_utils_get_animation_duration ((guint) GALA_WINDOW_SWITCHER_ANIMATION_DURATION));
#line 440 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (show) {
#line 440 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp4_ = 255;
#line 1655 "WindowSwitcher.c"
	} else {
#line 440 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp4_ = 0;
#line 1659 "WindowSwitcher.c"
	}
#line 440 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) _tmp4_);
#line 441 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) self);
#line 1665 "WindowSwitcher.c"
}

static gboolean
__lambda95_ (GalaWindowSwitcher* self,
             MetaKeyBinding* binding)
{
	MetaKeyBindingAction action = 0;
	const gchar* _tmp0_;
	gboolean result;
#line 447 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (binding != NULL, FALSE);
#line 448 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = meta_key_binding_get_name (binding);
#line 448 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	action = meta_prefs_get_keybinding_action (_tmp0_);
#line 450 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	switch (action) {
#line 450 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case META_KEYBINDING_ACTION_NONE:
#line 450 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case META_KEYBINDING_ACTION_LOCATE_POINTER_KEY:
#line 1687 "WindowSwitcher.c"
		{
#line 453 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			result = FALSE;
#line 453 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			return result;
#line 1693 "WindowSwitcher.c"
		}
		default:
		{
#line 455 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			break;
#line 1699 "WindowSwitcher.c"
		}
	}
#line 458 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = TRUE;
#line 458 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 1706 "WindowSwitcher.c"
}

static gboolean
___lambda95__gala_keybinding_filter (MetaKeyBinding* binding,
                                     gpointer self)
{
	gboolean result;
	result = __lambda95_ ((GalaWindowSwitcher*) self, binding);
#line 447 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 1717 "WindowSwitcher.c"
}

static void
gala_window_switcher_push_modal (GalaWindowSwitcher* self)
{
	GalaWindowManager* _tmp0_;
	GalaModalProxy* _tmp1_;
	GalaModalProxy* _tmp2_;
	GalaGestureAction* _tmp3_;
	GalaGestureAction* _tmp4_;
	gint _tmp4__length1;
	GalaModalProxy* _tmp5_;
#line 444 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 445 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 445 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = gala_window_manager_push_modal (_tmp0_, (ClutterActor*) self);
#line 445 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->modal_proxy);
#line 445 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->modal_proxy = _tmp1_;
#line 446 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = self->priv->modal_proxy;
#line 446 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = g_new0 (GalaGestureAction, 1);
#line 446 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_[0] = GALA_GESTURE_ACTION_SWITCH_WINDOWS;
#line 446 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = _tmp3_;
#line 446 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4__length1 = 1;
#line 446 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_modal_proxy_allow_actions (_tmp2_, _tmp4_, (gint) 1);
#line 446 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = (g_free (_tmp4_), NULL);
#line 447 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = self->priv->modal_proxy;
#line 447 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_modal_proxy_set_keybinding_filter (_tmp5_, ___lambda95__gala_keybinding_filter, self);
#line 1758 "WindowSwitcher.c"
}

static void
gala_window_switcher_close_switcher (GalaWindowSwitcher* self,
                                     guint32 time,
                                     gboolean cancel)
{
	gboolean _tmp0_;
	MetaWindow* window = NULL;
	GalaWindowSwitcherIcon* _tmp1_;
	GalaWindowSwitcherIcon* _tmp2_;
	MetaWindow* _tmp3_;
	MetaWindow* _tmp4_;
	MetaWindow* _tmp5_;
	MetaWindow* _tmp6_;
#line 463 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 464 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_opened;
#line 464 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (!_tmp0_) {
#line 465 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 1782 "WindowSwitcher.c"
	}
#line 468 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = gala_window_switcher_get_current_icon (self);
#line 468 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = _tmp1_;
#line 468 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = gala_window_switcher_icon_get_window (_tmp2_);
#line 468 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = _tmp3_;
#line 468 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 468 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	window = _tmp5_;
#line 469 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = window;
#line 469 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp6_ == NULL) {
#line 470 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (window);
#line 470 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 1804 "WindowSwitcher.c"
	}
#line 473 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (!cancel) {
#line 1808 "WindowSwitcher.c"
		MetaWorkspace* workspace = NULL;
		MetaWindow* _tmp7_;
		MetaWorkspace* _tmp8_;
		MetaWorkspace* _tmp9_;
		GalaWindowManager* _tmp10_;
		MetaDisplay* _tmp11_;
		MetaWorkspaceManager* _tmp12_;
		MetaWorkspace* _tmp13_;
#line 474 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp7_ = window;
#line 474 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp8_ = meta_window_get_workspace (_tmp7_);
#line 474 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		workspace = _tmp8_;
#line 475 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp9_ = workspace;
#line 475 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp10_ = self->priv->_wm;
#line 475 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp11_ = meta_plugin_get_display ((MetaPlugin*) _tmp10_);
#line 475 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp12_ = meta_display_get_workspace_manager (_tmp11_);
#line 475 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp13_ = meta_workspace_manager_get_active_workspace (_tmp12_);
#line 475 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		if (_tmp9_ != _tmp13_) {
#line 1835 "WindowSwitcher.c"
			MetaWorkspace* _tmp14_;
			MetaWindow* _tmp15_;
#line 476 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp14_ = workspace;
#line 476 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp15_ = window;
#line 476 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			meta_workspace_activate_with_focus (_tmp14_, _tmp15_, time);
#line 1844 "WindowSwitcher.c"
		} else {
			MetaWindow* _tmp16_;
#line 478 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp16_ = window;
#line 478 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			meta_window_activate (_tmp16_, time);
#line 1851 "WindowSwitcher.c"
		}
	}
#line 482 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_toggle_display (self, FALSE);
#line 463 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (window);
#line 1858 "WindowSwitcher.c"
}

static void
gala_window_switcher_next_window (GalaWindowSwitcher* self,
                                  gboolean backward)
{
	gdouble _tmp0_ = 0.0;
	GalaGestureController* _tmp1_;
	GalaGestureController* _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
#line 485 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 486 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (backward) {
#line 486 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = -GALA_WINDOW_SWITCHER_GESTURE_STEP;
#line 1876 "WindowSwitcher.c"
	} else {
#line 486 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = GALA_WINDOW_SWITCHER_GESTURE_STEP;
#line 1880 "WindowSwitcher.c"
	}
#line 486 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = self->priv->gesture_controller;
#line 486 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = self->priv->gesture_controller;
#line 486 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = gala_gesture_controller_get_progress (_tmp2_);
#line 486 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = _tmp3_;
#line 486 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_gesture_controller_set_progress (_tmp2_, _tmp4_ + _tmp0_);
#line 1892 "WindowSwitcher.c"
}

static void
gala_window_switcher_update_caption_text (GalaWindowSwitcher* self)
{
	MetaWindow* _tmp0_ = NULL;
	GalaWindowSwitcherIcon* _tmp1_;
	GalaWindowSwitcherIcon* _tmp2_;
	MetaWindow* current_window = NULL;
	MetaWindow* _tmp7_;
	const gchar* _tmp8_ = NULL;
	MetaWindow* _tmp9_;
	gchar* current_caption = NULL;
	gchar* _tmp13_;
	ClutterText* _tmp14_;
#line 489 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 490 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = gala_window_switcher_get_current_icon (self);
#line 490 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = _tmp1_;
#line 490 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp2_ != NULL) {
#line 1916 "WindowSwitcher.c"
		GalaWindowSwitcherIcon* _tmp3_;
		GalaWindowSwitcherIcon* _tmp4_;
		MetaWindow* _tmp5_;
		MetaWindow* _tmp6_;
#line 490 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp3_ = gala_window_switcher_get_current_icon (self);
#line 490 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp4_ = _tmp3_;
#line 490 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp5_ = gala_window_switcher_icon_get_window (_tmp4_);
#line 490 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp6_ = _tmp5_;
#line 490 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = _tmp6_;
#line 1931 "WindowSwitcher.c"
	} else {
#line 490 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = NULL;
#line 1935 "WindowSwitcher.c"
	}
#line 490 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = _g_object_ref0 (_tmp0_);
#line 490 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	current_window = _tmp7_;
#line 491 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = current_window;
#line 491 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp9_ != NULL) {
#line 1945 "WindowSwitcher.c"
		MetaWindow* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
#line 491 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp10_ = current_window;
#line 491 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp11_ = meta_window_get_title (_tmp10_);
#line 491 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp12_ = _tmp11_;
#line 491 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp8_ = _tmp12_;
#line 1957 "WindowSwitcher.c"
	} else {
#line 491 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp8_ = "n/a";
#line 1961 "WindowSwitcher.c"
	}
#line 491 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp13_ = g_strdup (_tmp8_);
#line 491 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	current_caption = _tmp13_;
#line 492 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp14_ = self->priv->caption;
#line 492 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_text_set_text (_tmp14_, current_caption);
#line 489 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_free0 (current_caption);
#line 489 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (current_window);
#line 1975 "WindowSwitcher.c"
}

static void
gala_window_switcher_real_key_focus_out (ClutterActor* base)
{
	GalaWindowSwitcher * self;
	GalaGestureController* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 495 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) base;
#line 496 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->gesture_controller;
#line 496 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = gala_gesture_controller_get_recognizing (_tmp0_);
#line 496 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = _tmp1_;
#line 496 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (!_tmp2_) {
#line 1995 "WindowSwitcher.c"
		GalaWindowManager* _tmp3_;
		MetaDisplay* _tmp4_;
#line 497 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp3_ = self->priv->_wm;
#line 497 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp4_ = meta_plugin_get_display ((MetaPlugin*) _tmp3_);
#line 497 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_close_switcher (self, meta_display_get_current_time (_tmp4_), FALSE);
#line 2004 "WindowSwitcher.c"
	}
}

static gboolean
gala_window_switcher_container_mouse_release (GalaWindowSwitcher* self,
                                              ClutterEvent* event)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean result;
#line 501 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 501 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 502 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = self->priv->_opened;
#line 502 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp2_) {
#line 502 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp1_ = clutter_event_get_button (event) == CLUTTER_BUTTON_PRIMARY;
#line 2026 "WindowSwitcher.c"
	} else {
#line 502 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp1_ = FALSE;
#line 2030 "WindowSwitcher.c"
	}
#line 502 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp1_) {
#line 2034 "WindowSwitcher.c"
		GalaGestureController* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 502 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp3_ = self->priv->gesture_controller;
#line 502 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp4_ = gala_gesture_controller_get_recognizing (_tmp3_);
#line 502 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp5_ = _tmp4_;
#line 502 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = !_tmp5_;
#line 2046 "WindowSwitcher.c"
	} else {
#line 502 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = FALSE;
#line 2050 "WindowSwitcher.c"
	}
#line 502 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp0_) {
#line 503 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_close_switcher (self, clutter_event_get_time (event), FALSE);
#line 2056 "WindowSwitcher.c"
	}
#line 506 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = TRUE;
#line 506 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2062 "WindowSwitcher.c"
}

static gboolean
gala_window_switcher_real_key_release_event (ClutterActor* base,
                                             ClutterEvent* event)
{
	GalaWindowSwitcher * self;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 509 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) base;
#line 509 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 510 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if ((gala_window_switcher_get_current_modifiers (self) & self->priv->modifier_mask) == 0) {
#line 2078 "WindowSwitcher.c"
		GalaGestureController* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 510 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp1_ = self->priv->gesture_controller;
#line 510 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp2_ = gala_gesture_controller_get_recognizing (_tmp1_);
#line 510 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp3_ = _tmp2_;
#line 510 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = !_tmp3_;
#line 2090 "WindowSwitcher.c"
	} else {
#line 510 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = FALSE;
#line 2094 "WindowSwitcher.c"
	}
#line 510 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp0_) {
#line 511 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_close_switcher (self, clutter_event_get_time (event), FALSE);
#line 2100 "WindowSwitcher.c"
	}
#line 514 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 514 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2106 "WindowSwitcher.c"
}

static gboolean
gala_window_switcher_real_key_press_event (ClutterActor* base,
                                           ClutterEvent* event)
{
	GalaWindowSwitcher * self;
	gboolean result;
#line 517 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) base;
#line 517 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 518 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	switch (clutter_event_get_key_symbol (event)) {
#line 518 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case CLUTTER_KEY_Right:
#line 2123 "WindowSwitcher.c"
		{
			GalaGestureController* _tmp0_;
			gboolean _tmp1_;
			gboolean _tmp2_;
#line 520 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp0_ = self->priv->gesture_controller;
#line 520 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp1_ = gala_gesture_controller_get_recognizing (_tmp0_);
#line 520 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp2_ = _tmp1_;
#line 520 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			if (!_tmp2_) {
#line 521 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				gala_window_switcher_next_window (self, FALSE);
#line 2138 "WindowSwitcher.c"
			}
#line 523 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			result = CLUTTER_EVENT_STOP;
#line 523 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			return result;
#line 2144 "WindowSwitcher.c"
		}
#line 518 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case CLUTTER_KEY_Left:
#line 2148 "WindowSwitcher.c"
		{
			GalaGestureController* _tmp3_;
			gboolean _tmp4_;
			gboolean _tmp5_;
#line 525 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp3_ = self->priv->gesture_controller;
#line 525 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp4_ = gala_gesture_controller_get_recognizing (_tmp3_);
#line 525 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp5_ = _tmp4_;
#line 525 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			if (!_tmp5_) {
#line 526 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				gala_window_switcher_next_window (self, TRUE);
#line 2163 "WindowSwitcher.c"
			}
#line 528 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			result = CLUTTER_EVENT_STOP;
#line 528 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			return result;
#line 2169 "WindowSwitcher.c"
		}
#line 518 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case CLUTTER_KEY_Escape:
#line 2173 "WindowSwitcher.c"
		{
#line 530 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			gala_window_switcher_close_switcher (self, clutter_event_get_time (event), TRUE);
#line 531 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			result = CLUTTER_EVENT_PROPAGATE;
#line 531 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			return result;
#line 2181 "WindowSwitcher.c"
		}
#line 518 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case CLUTTER_KEY_Return:
#line 2185 "WindowSwitcher.c"
		{
#line 533 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			gala_window_switcher_close_switcher (self, clutter_event_get_time (event), FALSE);
#line 534 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			result = CLUTTER_EVENT_PROPAGATE;
#line 534 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			return result;
#line 2193 "WindowSwitcher.c"
		}
		default:
#line 518 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 2198 "WindowSwitcher.c"
	}
#line 537 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 537 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2204 "WindowSwitcher.c"
}

static inline ClutterModifierType
gala_window_switcher_get_current_modifiers (GalaWindowSwitcher* self)
{
	ClutterModifierType modifiers = 0U;
	MetaCursorTracker* tracker = NULL;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaCursorTracker* _tmp2_;
	ClutterModifierType _tmp3_ = 0U;
	ClutterModifierType result;
#line 541 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 546 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 546 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 546 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = meta_cursor_tracker_get_for_display (_tmp1_);
#line 546 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	tracker = _tmp2_;
#line 548 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	meta_cursor_tracker_get_pointer (tracker, NULL, &_tmp3_);
#line 548 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	modifiers = _tmp3_;
#line 550 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = modifiers & CLUTTER_MODIFIER_MASK;
#line 550 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2235 "WindowSwitcher.c"
}

GalaWindowManager*
gala_window_switcher_get_wm (GalaWindowSwitcher* self)
{
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
#line 19 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 19 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 19 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = _tmp0_;
#line 19 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2251 "WindowSwitcher.c"
}

static void
gala_window_switcher_set_wm (GalaWindowSwitcher* self,
                             GalaWindowManager* value)
{
	GalaWindowManager* old_value;
#line 19 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 19 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	old_value = gala_window_switcher_get_wm (self);
#line 19 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (old_value != value) {
#line 2265 "WindowSwitcher.c"
		GalaWindowManager* _tmp0_;
#line 19 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 19 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (self->priv->_wm);
#line 19 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		self->priv->_wm = _tmp0_;
#line 19 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_WM_PROPERTY]);
#line 2275 "WindowSwitcher.c"
	}
}

gboolean
gala_window_switcher_get_opened (GalaWindowSwitcher* self)
{
	gboolean result;
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = self->priv->_opened;
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2289 "WindowSwitcher.c"
}

static void
gala_window_switcher_set_opened (GalaWindowSwitcher* self,
                                 gboolean value)
{
	gboolean old_value;
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	old_value = gala_window_switcher_get_opened (self);
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (old_value != value) {
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		self->priv->_opened = value;
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_OPENED_PROPERTY]);
#line 2307 "WindowSwitcher.c"
	}
}

static ClutterActor*
gala_window_switcher_real_get_actor (GalaGestureTarget* base)
{
	ClutterActor* result;
	GalaWindowSwitcher* self;
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) base;
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = (ClutterActor*) self;
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2322 "WindowSwitcher.c"
}

static GalaWindowSwitcherIcon*
gala_window_switcher_get_current_icon (GalaWindowSwitcher* self)
{
	GalaWindowSwitcherIcon* result;
	GalaWindowSwitcherIcon* _tmp0_;
#line 34 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_current_icon;
#line 35 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = _tmp0_;
#line 35 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2338 "WindowSwitcher.c"
}

static void
gala_window_switcher_set_current_icon (GalaWindowSwitcher* self,
                                       GalaWindowSwitcherIcon* value)
{
	GalaWindowSwitcherIcon* _tmp0_;
	GalaWindowSwitcherIcon* _tmp2_;
	GalaWindowSwitcherIcon* _tmp3_;
#line 37 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_current_icon;
#line 38 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp0_ != NULL) {
#line 2354 "WindowSwitcher.c"
		GalaWindowSwitcherIcon* _tmp1_;
#line 39 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp1_ = self->priv->_current_icon;
#line 39 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_icon_set_selected (_tmp1_, FALSE);
#line 2360 "WindowSwitcher.c"
	}
#line 42 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = _g_object_ref0 (value);
#line 42 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->_current_icon);
#line 42 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->_current_icon = _tmp2_;
#line 43 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = self->priv->_current_icon;
#line 43 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp3_ != NULL) {
#line 2372 "WindowSwitcher.c"
		GalaWindowSwitcherIcon* _tmp4_;
		GalaWindowSwitcherIcon* _tmp5_;
#line 44 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp4_ = self->priv->_current_icon;
#line 44 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_icon_set_selected (_tmp4_, TRUE);
#line 45 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp5_ = self->priv->_current_icon;
#line 45 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		clutter_actor_grab_key_focus ((ClutterActor*) _tmp5_);
#line 2383 "WindowSwitcher.c"
	}
#line 48 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_update_caption_text (self);
#line 2387 "WindowSwitcher.c"
}

static void
_gala_window_switcher_recognizing_changed_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self)
{
#line 69 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_recognizing_changed ((GalaWindowSwitcher*) self);
#line 2397 "WindowSwitcher.c"
}

static gboolean
_gala_window_switcher_container_mouse_release_clutter_actor_button_release_event (ClutterActor* _sender,
                                                                                  ClutterEvent* event,
                                                                                  gpointer self)
{
	gboolean result;
	result = gala_window_switcher_container_mouse_release ((GalaWindowSwitcher*) self, event);
#line 108 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2409 "WindowSwitcher.c"
}

static void
_clutter_content_invalidate_g_object_notify (GObject* _sender,
                                             GParamSpec* pspec,
                                             gpointer self)
{
#line 111 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_content_invalidate ((ClutterContent*) self);
#line 2419 "WindowSwitcher.c"
}

static void
_gala_window_switcher_scale_meta_monitor_manager_monitors_changed (MetaMonitorManager* _sender,
                                                                   gpointer self)
{
#line 114 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_scale ((GalaWindowSwitcher*) self);
#line 2428 "WindowSwitcher.c"
}

static void
_gala_window_switcher___lambda96_ (GalaWindowSwitcher* self)
{
	guint _tmp0_;
	guint _tmp1_;
#line 116 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = clutter_actor_get_opacity ((ClutterActor*) self);
#line 116 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = _tmp0_;
#line 116 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_set ((ClutterActor*) self, "visible", _tmp1_ != ((guint) 0), NULL);
#line 2442 "WindowSwitcher.c"
}

static void
__gala_window_switcher___lambda96__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
#line 116 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_gala_window_switcher___lambda96_ ((GalaWindowSwitcher*) self);
#line 2452 "WindowSwitcher.c"
}

static GObject *
gala_window_switcher_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaWindowSwitcher * self;
	GalaDrawingStyleManager* _tmp0_;
	GalaWindowManager* _tmp1_;
	GalaGestureController* _tmp2_ = NULL;
	GalaGestureController* _tmp3_;
	GalaGestureController* _tmp4_;
	GalaGestureController* _tmp5_;
	ClutterFlowLayout* _tmp6_;
	ClutterActor* _tmp7_ = NULL;
	AtkObject* _tmp8_;
	ClutterActor* _tmp9_;
	AtkObject* _tmp10_;
	gchar* _tmp11_;
	ClutterText* _tmp12_ = NULL;
	ClutterActor* _tmp13_;
	ClutterText* _tmp14_;
	ClutterBoxLayout* _tmp15_ = NULL;
	ClutterBoxLayout* _tmp16_;
	GalaShadowEffect* _tmp17_ = NULL;
	GalaShadowEffect* _tmp18_;
	ClutterActor* _tmp19_;
	GalaDrawingStyleManager* _tmp20_;
	ClutterContent* _tmp21_;
	ClutterContent* _tmp22_;
	MetaMonitorManager* monitor_manager = NULL;
	GalaWindowManager* _tmp23_;
	MetaDisplay* _tmp24_;
	MetaContext* _tmp25_;
	MetaBackend* _tmp26_;
	MetaMonitorManager* _tmp27_;
	MetaMonitorManager* _tmp28_;
#line 60 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	parent_class = G_OBJECT_CLASS (gala_window_switcher_parent_class);
#line 60 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 60 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
#line 61 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = gala_drawing_style_manager_get_instance ();
#line 61 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->style_manager);
#line 61 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->style_manager = _tmp0_;
#line 63 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = self->priv->_wm;
#line 63 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = gala_gesture_controller_new (GALA_GESTURE_ACTION_SWITCH_WINDOWS, _tmp1_);
#line 63 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_gesture_controller_set_overshoot_upper_clamp (_tmp2_, (gdouble) G_MAXINT);
#line 63 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_gesture_controller_set_overshoot_lower_clamp (_tmp2_, (gdouble) G_MININT);
#line 63 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_gesture_controller_set_snap (_tmp2_, FALSE);
#line 63 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->gesture_controller);
#line 63 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->gesture_controller = _tmp2_;
#line 68 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = self->priv->gesture_controller;
#line 68 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_gesture_controller_enable_touchpad (_tmp3_);
#line 69 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = self->priv->gesture_controller;
#line 69 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_signal_connect_object ((GObject*) _tmp4_, "notify::recognizing", (GCallback) _gala_window_switcher_recognizing_changed_g_object_notify, self, 0);
#line 70 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = self->priv->gesture_controller;
#line 70 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_root_target_add_gesture_controller ((GalaRootTarget*) self, _tmp5_);
#line 72 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = (ClutterFlowLayout*) clutter_flow_layout_new (CLUTTER_ORIENTATION_HORIZONTAL);
#line 72 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_ref_sink (_tmp6_);
#line 72 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = clutter_actor_new ();
#line 72 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_reactive (_tmp7_, TRUE);
#line 72 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_layout_manager (_tmp7_, (ClutterLayoutManager*) _tmp6_);
#line 72 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (_tmp6_);
#line 72 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_ref_sink (_tmp7_);
#line 72 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->container);
#line 72 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->container = _tmp7_;
#line 81 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp8_ = clutter_actor_get_accessible ((ClutterActor*) self);
#line 81 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_set (_tmp8_, "accessible-name", _ ("Window switcher"), NULL);
#line 82 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = self->priv->container;
#line 82 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10_ = clutter_actor_get_accessible (_tmp9_);
#line 82 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_set (_tmp10_, "accessible-role", ATK_ROLE_LIST, NULL);
#line 84 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11_ = g_strdup (GALA_WINDOW_SWITCHER_CAPTION_FONT_NAME);
#line 84 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp12_ = (ClutterText*) clutter_text_new ();
#line 84 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_text_set_font_name (_tmp12_, _tmp11_);
#line 84 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_free0 (_tmp11_);
#line 84 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_text_set_ellipsize (_tmp12_, PANGO_ELLIPSIZE_END);
#line 84 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_text_set_line_alignment (_tmp12_, PANGO_ALIGN_CENTER);
#line 84 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_ref_sink (_tmp12_);
#line 84 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->caption);
#line 84 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->caption = _tmp12_;
#line 90 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp13_ = self->priv->container;
#line 90 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_add_child ((ClutterActor*) self, _tmp13_);
#line 91 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp14_ = self->priv->caption;
#line 91 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_add_child ((ClutterActor*) self, (ClutterActor*) _tmp14_);
#line 93 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_reactive ((ClutterActor*) self, TRUE);
#line 94 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
#line 95 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) 0);
#line 96 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp15_ = (ClutterBoxLayout*) clutter_box_layout_new ();
#line 96 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_box_layout_set_orientation (_tmp15_, CLUTTER_ORIENTATION_VERTICAL);
#line 96 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_ref_sink (_tmp15_);
#line 96 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp16_ = _tmp15_;
#line 96 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_layout_manager ((ClutterActor*) self, (ClutterLayoutManager*) _tmp16_);
#line 96 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (_tmp16_);
#line 100 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp17_ = gala_shadow_effect_new ("window-switcher", self->priv->scaling_factor);
#line 100 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_shadow_effect_set_border_radius (_tmp17_, 10);
#line 100 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_shadow_effect_set_shadow_opacity (_tmp17_, (guint8) 100);
#line 100 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_ref_sink (_tmp17_);
#line 100 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->shadow_effect);
#line 100 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->shadow_effect = _tmp17_;
#line 104 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp18_ = self->priv->shadow_effect;
#line 104 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_add_effect ((ClutterActor*) self, (ClutterEffect*) _tmp18_);
#line 106 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_scale (self);
#line 108 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp19_ = self->priv->container;
#line 108 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_signal_connect_object (_tmp19_, "button-release-event", (GCallback) _gala_window_switcher_container_mouse_release_clutter_actor_button_release_event, self, 0);
#line 111 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp20_ = self->priv->style_manager;
#line 111 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp21_ = clutter_actor_get_content ((ClutterActor*) self);
#line 111 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp22_ = _tmp21_;
#line 111 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_signal_connect_object ((GObject*) _tmp20_, "notify::prefers-color-scheme", (GCallback) _clutter_content_invalidate_g_object_notify, _tmp22_, 0);
#line 113 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp23_ = self->priv->_wm;
#line 113 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp24_ = meta_plugin_get_display ((MetaPlugin*) _tmp23_);
#line 113 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp25_ = meta_display_get_context (_tmp24_);
#line 113 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp26_ = meta_context_get_backend (_tmp25_);
#line 113 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp27_ = meta_backend_get_monitor_manager (_tmp26_);
#line 113 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	monitor_manager = _tmp27_;
#line 114 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp28_ = monitor_manager;
#line 114 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_signal_connect_object (_tmp28_, "monitors-changed", (GCallback) _gala_window_switcher_scale_meta_monitor_manager_monitors_changed, self, 0);
#line 116 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_signal_connect_object ((GObject*) self, "notify::opacity", (GCallback) __gala_window_switcher___lambda96__g_object_notify, self, 0);
#line 60 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return obj;
#line 2653 "WindowSwitcher.c"
}

static void
gala_window_switcher_class_init (GalaWindowSwitcherClass * klass,
                                 gpointer klass_data)
{
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_parent_class = g_type_class_peek_parent (klass);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_type_class_adjust_private_offset (klass, &GalaWindowSwitcher_private_offset);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	((ClutterActorClass *) klass)->get_preferred_width = (void (*) (ClutterActor*, gfloat, gfloat*, gfloat*)) gala_window_switcher_real_get_preferred_width;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	((GalaCanvasActorClass *) klass)->draw = (void (*) (GalaCanvasActor*, cairo_t*, gint, gint)) gala_window_switcher_real_draw;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	((ClutterActorClass *) klass)->key_focus_out = (void (*) (ClutterActor*)) gala_window_switcher_real_key_focus_out;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	((ClutterActorClass *) klass)->key_release_event = (gboolean (*) (ClutterActor*, ClutterEvent*)) gala_window_switcher_real_key_release_event;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	((ClutterActorClass *) klass)->key_press_event = (gboolean (*) (ClutterActor*, ClutterEvent*)) gala_window_switcher_real_key_press_event;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_window_switcher_get_property;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_window_switcher_set_property;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_window_switcher_constructor;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_window_switcher_finalize;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_SWITCHER_WM_PROPERTY, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_WM_PROPERTY] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_SWITCHER_OPENED_PROPERTY, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_OPENED_PROPERTY] = g_param_spec_boolean ("opened", "opened", "opened", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_SWITCHER_ACTOR_PROPERTY, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_ACTOR_PROPERTY] = g_param_spec_object ("actor", "actor", "actor", clutter_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2688 "WindowSwitcher.c"
}

static void
gala_window_switcher_gala_gesture_target_interface_init (GalaGestureTargetIface * iface,
                                                         gpointer iface_data)
{
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_gala_gesture_target_parent_iface = g_type_interface_peek_parent (iface);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	iface->propagate = (void (*) (GalaGestureTarget*, GalaGestureTargetUpdateType, GalaGestureAction, gdouble)) gala_window_switcher_real_propagate;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	iface->get_actor = gala_window_switcher_real_get_actor;
#line 2701 "WindowSwitcher.c"
}

static void
gala_window_switcher_gala_root_target_interface_init (GalaRootTargetIface * iface,
                                                      gpointer iface_data)
{
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_gala_root_target_parent_iface = g_type_interface_peek_parent (iface);
#line 2710 "WindowSwitcher.c"
}

static void
gala_window_switcher_instance_init (GalaWindowSwitcher * self,
                                    gpointer klass)
{
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv = gala_window_switcher_get_instance_private (self);
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->_opened = FALSE;
#line 26 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->modal_proxy = NULL;
#line 32 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->_current_icon = NULL;
#line 52 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->previous_progress = 0.;
#line 54 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->scaling_factor = 1.0f;
#line 2729 "WindowSwitcher.c"
}

static void
gala_window_switcher_finalize (GObject * obj)
{
	GalaWindowSwitcher * self;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
#line 19 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->_wm);
#line 24 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->gesture_controller);
#line 26 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->modal_proxy);
#line 27 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->style_manager);
#line 28 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->container);
#line 29 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->caption);
#line 30 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->shadow_effect);
#line 32 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->_current_icon);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	G_OBJECT_CLASS (gala_window_switcher_parent_class)->finalize (obj);
#line 2756 "WindowSwitcher.c"
}

 G_GNUC_NO_INLINE static GType
gala_window_switcher_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaWindowSwitcherClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_window_switcher_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWindowSwitcher), 0, (GInstanceInitFunc) gala_window_switcher_instance_init, NULL };
	static const GInterfaceInfo gala_gesture_target_info = { (GInterfaceInitFunc) gala_window_switcher_gala_gesture_target_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo gala_root_target_info = { (GInterfaceInitFunc) gala_window_switcher_gala_root_target_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gala_window_switcher_type_id;
	gala_window_switcher_type_id = g_type_register_static (GALA_TYPE_CANVAS_ACTOR, "GalaWindowSwitcher", &g_define_type_info, 0);
	g_type_add_interface_static (gala_window_switcher_type_id, GALA_TYPE_GESTURE_TARGET, &gala_gesture_target_info);
	g_type_add_interface_static (gala_window_switcher_type_id, GALA_TYPE_ROOT_TARGET, &gala_root_target_info);
	GalaWindowSwitcher_private_offset = g_type_add_instance_private (gala_window_switcher_type_id, sizeof (GalaWindowSwitcherPrivate));
	return gala_window_switcher_type_id;
}

GType
gala_window_switcher_get_type (void)
{
	static gsize gala_window_switcher_type_id__once = 0;
	if (g_once_init_enter (&gala_window_switcher_type_id__once)) {
		GType gala_window_switcher_type_id;
		gala_window_switcher_type_id = gala_window_switcher_get_type_once ();
		g_once_init_leave (&gala_window_switcher_type_id__once, gala_window_switcher_type_id);
	}
	return gala_window_switcher_type_id__once;
}

static void
_vala_gala_window_switcher_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	GalaWindowSwitcher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	switch (property_id) {
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_WM_PROPERTY:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_value_set_object (value, gala_window_switcher_get_wm (self));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_OPENED_PROPERTY:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_value_set_boolean (value, gala_window_switcher_get_opened (self));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_ACTOR_PROPERTY:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_value_set_object (value, gala_gesture_target_get_actor ((GalaGestureTarget*) self));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 2813 "WindowSwitcher.c"
		default:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 2819 "WindowSwitcher.c"
	}
}

static void
_vala_gala_window_switcher_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	GalaWindowSwitcher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	switch (property_id) {
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_WM_PROPERTY:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_set_wm (self, g_value_get_object (value));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_OPENED_PROPERTY:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_set_opened (self, g_value_get_boolean (value));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 2845 "WindowSwitcher.c"
		default:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 2851 "WindowSwitcher.c"
	}
}

